-- 连充献礼 panel
Lua_AlwaysRechargeGiftPanel = class("Lua_AlwaysRechargeGiftPanel", Lua_DisplayObject);

function Lua_AlwaysRechargeGiftPanel:ctor(p, skinName)
	self:superCall("ctor", p, skinName);
end

function Lua_AlwaysRechargeGiftPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 135, 105, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_AlwaysRechargeRewardItem, 105, 105, 1);
	self.rewardList:setRectAnchor(1);
	self.rewardList:setLocation(60, -455.5, 0);

	self.itemList = Lua_DragList.new(self.content, 700, 680 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.itemList:setListCell(Lua_AlwaysRechargeGiftItem, 700, 185, 1);
	self.itemList:setLocation(0, -180, 0);

	self.tipIcon:addClickFuntion(self, self.onTipIconClick);
	self.receiveBtn:addClickFuntion(self, self.onReceiveBtnClick);

	self:addLuaEvent("UPDATE_ALWAYSRECHARGEGIFT_INFO", self, self.onUpdateInfo);
	self:addLuaEvent("ALWAYSRECHARGEGIFT_RECHARGE", self, self.onRechargeEvent);
end

function Lua_AlwaysRechargeGiftPanel:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	if self.redPointIcon ~= nil then
		self.redPointIcon:dispose();
		self.redPointIcon = nil;
	end
	self:superCall("dispose");
end

function Lua_AlwaysRechargeGiftPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);

	self.itemList:setContentRect(700, 680 + self.adaptHeight);
end

function Lua_AlwaysRechargeGiftPanel:setData(actVo)
	self.actVo = actVo;
	self:starTimer();
end

function Lua_AlwaysRechargeGiftPanel:onUpdateInfo(msg)
	if msg.prize ~= nil and msg.prize[1] ~= nil then -- 奖品信息
		self.rewardInfo = msg.prize[1];
		self.desTxt.text = self.rewardInfo.cond_int;
		self.rewardList:setArrayData(self.rewardInfo.item_list);

		if self.rewardInfo.state == 0 then
			self.receiveBtn:setLangValue(775000);
			self.receiveBtn:setGray(true);
		elseif self.rewardInfo.state == 1 then
			self.receiveBtn:setLangValue(775000);
			self.receiveBtn:setGray(false);
		elseif self.rewardInfo.state == 2 then
			self.receiveBtn:setLangValue(775001);
			self.receiveBtn:setGray(true);
		end
	end
	self:updateRedPoint(self.rewardInfo.state == 1);

	local goodsList = msg.goods;
	table.sort(goodsList, function(a, b) return a.id < b.id end)

	local curDay = 0;
	local addDay = 0;
	for i = 1, #goodsList do
		if goodsList[i].state > 0 then
			curDay = curDay + 1;
		end

		if goodsList[i].state == 2 then
			addDay = addDay + 1;
		end
	end
	self.dayTxt.text = LanUtil.formateStr(775002, addDay);

	self.itemList:setArrayData(goodsList); -- 商品信息
	if curDay > 0 then
		self.itemList:moveToIndex(curDay, true);
	end
end

function Lua_AlwaysRechargeGiftPanel:starTimer()
	if not self.isTimer then
		self.isTimer = true;
		self:onTimer();
		self:addTimer("onTimer", 1, self, self.onTimer);
	end
end

function Lua_AlwaysRechargeGiftPanel:onTimer()
	local time = self.actVo.residueTime;
	if time <= 0 then
		time = 0;
		self:endTimer();
	end
	self.timeTxt.text = LanUtil.formateStr(775003, Lua_TimeTransform.transSeconds16(time));
end

function Lua_AlwaysRechargeGiftPanel:endTimer()
	if self.isTimer then
		self.isTimer = false;
		self:removeTimer(self, self.onTimer);
	end
end

function Lua_AlwaysRechargeGiftPanel:onTipIconClick()
	local tipData = { des = self.actVo.help_des, posX = -160, posY = -250 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_AlwaysRechargeGiftPanel:onReceiveBtnClick()
	if self.actVo.residueTime <= 0 then
		OperateAlert.showLangValue(775006);
		return;
	end

	if self.rewardInfo.state == 0 then
		OperateAlert.showLangValue(775004);
	elseif self.rewardInfo.state == 1 then
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sGetAlwaysRechargeReward(self.actVo.actIdx, self.rewardInfo.id);
	end
end

function Lua_AlwaysRechargeGiftPanel:updateRedPoint(val)
	if val then
		if self.redPointIcon == nil then
			self.redPointIcon = Lua_RedPointIcon.new(self.content);
			self.redPointIcon:setRectAnchor(1);
			self.redPointIcon:createRedPointEff();
			self.redPointIcon:setLocation(305, -425, 0);
		end
		self.redPointIcon:updateRedPointShow(true);
	else
		if self.redPointIcon ~= nil then
			self.redPointIcon:updateRedPointShow(false);
		end
	end
end

function Lua_AlwaysRechargeGiftPanel:onRechargeEvent(rechargeInfo)
	if self.actVo.residueTime <= 0 then
		OperateAlert.showLangValue(775006);
		return;
	end
	
	DataCenter.sdkInterface:PointOut(tonumber(rechargeInfo.gold), tonumber(rechargeInfo.money),
			tonumber(rechargeInfo.money_type), tonumber(rechargeInfo.id), rechargeInfo.gift_name, rechargeInfo.gold);
end

























Lua_AlwaysRechargeGiftItem = class("Lua_AlwaysRechargeGiftItem", Lua_ListCell);

function Lua_AlwaysRechargeGiftItem:ctor(p)
	self:superCall("ctor", p, "AlwaysRechargeGiftItem_skin");
end

function Lua_AlwaysRechargeGiftItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 460, 100, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_AlwaysRechargeGiftRewardItem, 100, 100, 1);
	self.rewardList:setLocation(-90, -8, 0);
	self:setSubList(self.rewardList);

	self.buyBtn:addClickFuntion(self, self.onBuyBtnClick);
end

function Lua_AlwaysRechargeGiftItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end

function Lua_AlwaysRechargeGiftItem:setData(data)
	self.data = data;
	self.titleTxt.text = LanUtil.formateStr(775005, data.id);
	self.rewardList:setArrayData(data.item_list);
	self.rewardList.canDrag = not self.rewardList.isTheEnd;

	if self.data.state <= 1 then
		self.rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(data.cond_int);
		if self.rechargeInfo ~= nil then
			self.buyBtn.label = LanUtil.formateStr(775007, self.rechargeInfo.money);
		else
			self.buyBtn:setLangValue(775008);
		end
	elseif self.data.state == 2 then
		self.stateSp:setAltas("common_altas_1", "xui_common_label_12");
	elseif self.data.state == 3 then
		self.stateSp:setAltas("common_altas_5", "xui_common_label_35");
	end
	local showState = self.data.state <= 1;
	self.buyBtn:setEnable(showState);
	self.stateSp:setEnable(not showState);

	self.buyBtn:setGray(self.data.state == 0);
end

function Lua_AlwaysRechargeGiftItem:onBuyBtnClick()
	if self.data.state == 0 then
		OperateAlert.showLangValue(775009);
	elseif self.data.state == 1 and self.rechargeInfo ~= nil then
		Lua_MsgUtil.callFunc("ALWAYSRECHARGEGIFT_RECHARGE", self.rechargeInfo);
	end
end






















Lua_AlwaysRechargeRewardItem = class("Lua_AlwaysRechargeRewardItem", Lua_ItemIconCell);

function Lua_AlwaysRechargeRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon:setScale(0.84, 0.84);
end


















Lua_AlwaysRechargeGiftRewardItem = class("Lua_AlwaysRechargeRewardItem", Lua_ItemIconCell);

function Lua_AlwaysRechargeGiftRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon:setScale(0.75, 0.75);
end