-- 邀请助阵
Lua_EndlessLevelInviteWindow = class("Lua_EndlessLevelInviteWindow", Lua_Window);
function Lua_EndlessLevelInviteWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_EndlessLevelInviteWindow";
	self.skinName = "EndlessLevelInviteWindow_skin";
	self.showWinBg = true;
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_EndlessLevelInviteWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.desTxt:setLangValue(779020);
	self.playerList = {};
	self.assistBtn:addClickFuntion(self, self.onAssistClick);

	self:addLuaEvent("UPDATE_ENDLESSLEVEL_ASSIST_OTHER_INFO", self, self.showAssistOtherInfo);
end

function Lua_EndlessLevelInviteWindow:showWin(param)
	self:superCall("showWin", param);
	self:showAssistOtherInfo(param);
end

function Lua_EndlessLevelInviteWindow:showAssistOtherInfo(msg)
	if self.playerId and self.playerId ~= tonumber(msg.show_role.id) then
		return;
	end
	self.playerId = tonumber(msg.show_role.id);
	self.serverInfo = msg;

	local assistList = msg.helper_list;
	self.assistNumTxt.text = LanUtil.formateStr(779021, #assistList, msg.help_max);
	self.assistTimesTxt.text = LanUtil.formateStr(779022, msg.max_help_count - msg.curr_help, msg.max_help_count);
	self.assistBtn:setGray(msg.curr_help >= msg.max_help_count);

	local item;
	local posList = {{-169, 142}, {169, 142}, {0, -145}};
	self.assistPlayerIdDic = {};
	for i = 1, #posList do
		item = self.playerList[i];
		if item == nil then
			item = Lua_EndlessLevelInviteItem.new(self.content);
			item:setLocation(posList[i][1], posList[i][2]);
			self.playerList[i] = item;
		end
		item:setData(assistList[i]);

		if assistList[i] ~= nil then
			self.assistPlayerIdDic[tonumber(assistList[i].id)] = true;
		end
	end
	self.condTipsIcon:setGray(#assistList < msg.help_max);
end

function Lua_EndlessLevelInviteWindow:onAssistClick()
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.5 then
		return;
	end
	self.clickTime = getTime();

	local actVo = DataCenter.backstageActData:getActVoByIdx(self.serverInfo.act_index);
	if DataCenter.backstageActData:checkActIsEnd(actVo) then
		self:hide();
		return;
	end
	if self.serverInfo.curr_help >= self.serverInfo.max_help_count then
		OperateAlert.showLangValue(779023);
		return;
	end
	local playerId = DataCenter.roleData.roleId;
	if self.assistPlayerIdDic ~= nil and self.assistPlayerIdDic[playerId] then
		OperateAlert.showLangValue(779024);
		return;
	end

	local isCanAssist = #self.serverInfo.helper_list < self.serverInfo.help_max;
	if not isCanAssist then
		OperateAlert.showLangValue(779025);
	else
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sEndlessLevelAssistToOther(self.serverInfo.act_index,
			tonumber(self.serverInfo.show_role.id), self.serverInfo.show_role.server_flag);
	end
end

function Lua_EndlessLevelInviteWindow:dispose()
	if self.playerList ~= nil then
		for i = 1, #self.playerList do
			self.playerList[i]:dispose();
			self.playerList[i] = nil;
		end
		self.playerList = nil;
	end
	self.serverInfo = nil;
	self.assistPlayerIdDic = nil;
	self:superCall("dispose");
end










Lua_EndlessLevelInviteItem = class("Lua_EndlessLevelInviteItem", Lua_DisplayObject);
function Lua_EndlessLevelInviteItem:ctor(p)
	self:superCall("ctor", p, "EndlessLevelInviteItem_skin");
end

function Lua_EndlessLevelInviteItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_EndlessLevelInviteItem:setData(data)
	if data == nil then
		if self.avatarItem ~= nil then
			self.avatarItem:setEnable(false);
		end
		self.nameTxt:setLangValue(779018);
	else
		if self.avatarItem == nil then
			self.avatarItem = Lua_AvatarItem.new(self.content);
			self.avatarItem:setSiblingIndex(self.selectedIcon.siblingIndex);
			self.avatarItem:setLocation(-1, 1.5, 0);
			self.avatarItem:setScale(1.15, 1.15, 1);
		end
		self.avatarItem:setRoleId(data.id, data.server_flag);
		self.avatarItem:setRoleDressUp(data.dress_info, false);
		self.avatarItem:setRoleFrame(nil);
		self.avatarItem:setRoleLevel(data.level);
		self.nameTxt.text = data.name;
	end
	self.addIcon:setEnable(data == nil);
	self.selectedIcon:setEnable(data ~= nil);
end

function Lua_EndlessLevelInviteItem:dispose()
	if self.avatarItem ~= nil then
		self.avatarItem:dispose();
		self.avatarItem = nil;
	end
	self:superCall("dispose");
end