-- 我的助阵
Lua_EndlessLevelMyAssistWindow = class("Lua_EndlessLevelMyAssistWindow", Lua_Window);
function Lua_EndlessLevelMyAssistWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_EndlessLevelMyAssistWindow";
	self.skinName = "EndlessLevelMyAssistWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_EndlessLevelMyAssistWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.shareObj:SetActive(false);
	self.playerList = {};

	self.itemList = Lua_DragList.new(self.content, 510, 100, Lua_AxisDefine.Horizontal);
	self.itemList:setListCell(Lua_EndlessLevelAssistRewardItem, 100, 100, 1);
	self.itemList:setCellSpacing(5, 0);
	self.itemList:setSiblingIndex(12);
	self.itemList:setLocation(0, -302, 0);

	self.drawBtn:addClickFuntion(self, self.onDrawClick);
	self.shareBtn:addClickFuntion(self, self.onShareClick);
	self.worldBtn:addClickFuntion(self, self.onWorldClick); -- 频道分享（世界）
	self.friendBtn:addClickFuntion(self, self.onFriendClick); -- 频道分享（好友）

	self:addLuaEvent("UPDATE_ENDLESSLEVEL_ASSIS_MY_INFO", self, self.showAssistMyInfo);
	self:addLuaEvent("UPDATE_ENDLESSLEVEL_ASSIST_SHARE", self, self.assitShareResult);
end

function Lua_EndlessLevelMyAssistWindow:showWin(param)
	self:superCall("showWin", param);
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sEndlessLevelAssistMyInfo(param.actIdx);
end

function Lua_EndlessLevelMyAssistWindow:showAssistMyInfo(msg)
	if msg == nil then
		return;
	end
	self.serverInfo = msg;
	self.clickTime = tonumber(tostring(msg.share_tick));

	local assistList = msg.helper_list;
	self.desTxt.text = LanUtil.formateStr(779026, msg.helped_max);
	self.assistNumTxt.text = LanUtil.formateStr(779027, #assistList, msg.helped_max);

	local posX = #msg.award > 3 and 0 or (510 - #msg.award * 100) / 2;
	self.itemList.canDrag = #msg.award > 3;
	self.itemList:setArrayData(msg.award);
	self.itemList:setLocation(posX, -302, 0);

	local item;
	local posList = {{-169, 210}, {169, 210}, {0, -78}};
	for i = 1, #posList do
		item = self.playerList[i];
		if item == nil then
			item = Lua_EndlessLevelMyAssistItem.new(self.content);
			self.playerList[i] = item;
		end
		item:setLocation(posList[i][1], posList[i][2]);
		item:setData(assistList[i]);
	end
	self.condTipsIcon:setGray(#assistList < msg.helped_max);

	if msg.state ~= 2 then
		self.drawBtn:setLangValue(779028);
	else
		self.drawBtn:setLangValue(779029);
	end
	self.drawBtn:setGray(msg.state ~= 1);
	self.shareBtn:setGray(#assistList >= msg.helped_max);
end

function Lua_EndlessLevelMyAssistWindow:onDrawClick(go)
	if self.serverInfo.state == 0 then
		OperateAlert.show(LanUtil.formateStr(779030, self.serverInfo.helped_max));
	elseif self.serverInfo.state == 1 then
		Lua_MsgUtil.callFunc("REQUEST_ENDLESSLEVEL_DRAW_REWARD", 3);
	else
		OperateAlert.showLangValue(779029);
	end
end

function Lua_EndlessLevelMyAssistWindow:onShareClick(go)
	self:onShareOperate(1);
end

function Lua_EndlessLevelMyAssistWindow:onWorldClick(go)
	self:onShareOperate(2);
end

function Lua_EndlessLevelMyAssistWindow:onFriendClick()
	self:onShareOperate(3);
end

function Lua_EndlessLevelMyAssistWindow:onShareOperate(operateType)
	local actVo = DataCenter.backstageActData:getActVoByIdx(self.showData.actIdx);
	if DataCenter.backstageActData:checkActIsEnd(actVo) then
		self:hide();
		return;
	end
	if #self.serverInfo.helper_list >= self.serverInfo.helped_max then
		self.shareObj:SetActive(false);
		OperateAlert.showLangValue(779031);
		return;
	end

	if operateType == 1 then
		local time = Mathf.Ceil(self.clickTime - DataCenter.roleData.serverTime);
		if not self.shareObj.activeSelf and time > 0 then -- 一分钟分享一次
			OperateAlert.show(LanUtil.formateStr(779032, time));
			return;
		end
		self.shareObj:SetActive(true);
	elseif operateType == 2 then
		if not DataCenter.funcOpenData:isOpened(10228) then
			OperateAlert.showLangValue(779033);
		else
			self.shareObj:SetActive(false);
			local str1 = LanUtil.formateStr(779034, self.showData.title);
			local str2 = LanUtil.formateStr(779035, self.showData.actIdx);
			local chatContent = spliceStr(str1, str2);
			DataCenter.chatData:setChatShowItem(Lua_ChatData.CONTENT_ENDLESSLEVEL_INVITE, chatContent);
			Lua_ChatUtil.sendMsg(Lua_ChatData.CHANNEL_WORLD, chatContent, false, false);
			self.isShareToWorld = true;

			Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sEndlessLevelAssistShare(Lua_ChatData.CHANNEL_WORLD,
				DataCenter.roleData.server_flag, self.showData.actIdx);
		end
	elseif operateType == 3 then
		-- -- 好友
		-- if not DataCenter.funcOpenData:isOpened(10231) then
		-- 	OperateAlert.showLangValue(779033);
		-- else
		-- 	self.shareObj:SetActive(false);
		-- 	Lua_WindowUtil.openWin("Lua_EndlessLevelShareFriendWindow", Lua_WinParam.ACTION_OPEN, {owner = self, callbackFun = self.callbackFun});
		-- end

		-- 公会
		if not DataCenter.funcOpenData:isOpened(10229) then
			OperateAlert.showLangValue(779033);
		elseif DataCenter.roleData.league_id <= 0 then
			OperateAlert.showLangValue(779041);
		else
			self.shareObj:SetActive(false);
			local str1 = LanUtil.formateStr(779034, self.showData.title);
			local str2 = LanUtil.formateStr(779035, self.showData.actIdx);
			local chatContent = spliceStr(str1, str2);
			DataCenter.chatData:setChatShowItem(Lua_ChatData.CONTENT_ENDLESSLEVEL_INVITE, chatContent);
			Lua_ChatUtil.sendMsg(Lua_ChatData.CHANNEL_LEAGUE, chatContent, false, false);
			self.isShareToLeague = true;

			Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sEndlessLevelAssistShare(Lua_ChatData.CHANNEL_LEAGUE,
				DataCenter.roleData.server_flag, self.showData.actIdx);
		end
	end
end

function Lua_EndlessLevelMyAssistWindow:callbackFun(friendInfo)
	self.friendId = tonumber(friendInfo.id);
	self.friendName = friendInfo.name;
	self.friendServerFlag = friendInfo.server_flag;
	local tipData = {
		owner = self,
		des = LanUtil.formateStr(779036, friendInfo.name);
		btnType = 1,
		sureFun = self.onSureFun
	};
	Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_EndlessLevelMyAssistWindow:onSureFun()
	local str1 = LanUtil.formateStr(779034, self.showData.title);
	local str2 = LanUtil.formateStr(779035, self.showData.actIdx);
	local chatContent = spliceStr(str1, str2);
	DataCenter.chatData:setChatShowItem(Lua_ChatData.CONTENT_ENDLESSLEVEL_INVITE, chatContent);
	Lua_ChatUtil.sendMsg(Lua_ChatData.CHANNEL_FRIEND, chatContent, false, false, self.friendId);

	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sEndlessLevelAssistShare(self.friendId,
		self.friendServerFlag, self.showData.actIdx);
end

function Lua_EndlessLevelMyAssistWindow:assitShareResult(msg)
	-- print(self.friendId, msg.index, self.isShareToWorld);
	self.clickTime = tonumber(tostring(msg.share_tick));
	if msg.index == Lua_ChatData.CHANNEL_WORLD then -- 世界
		if self.isShareToWorld then
			self.isShareToWorld = false;
			OperateAlert.showLangValue(779037);
		end
	elseif msg.index == Lua_ChatData.CHANNEL_LEAGUE then -- 公会
		if self.isShareToLeague then
			self.isShareToLeague = false;
			OperateAlert.showLangValue(779066);
		end
	else -- 好友
		if self.friendId == msg.index then
			OperateAlert.show(LanUtil.formateStr(779038, self.friendName));
		end
	end
end

function Lua_EndlessLevelMyAssistWindow:dispose()
	if self.playerList ~= nil then
		for i = 1, #self.playerList do
			self.playerList[i]:dispose();
			self.playerList[i] = nil;
		end
		self.playerList = nil;
	end
	self.serverInfo = nil;
	self:superCall("dispose");
end










Lua_EndlessLevelAssistRewardItem = class("Lua_EndlessLevelAssistRewardItem", Lua_ItemIconCell);
function Lua_EndlessLevelAssistRewardItem:buildShowItem()
	self:superCall("buildShowItem");
	self.itemIcon:setScale(0.8, 0.8);
end










Lua_EndlessLevelMyAssistItem = class("Lua_EndlessLevelMyAssistItem", Lua_DisplayObject);
function Lua_EndlessLevelMyAssistItem:ctor(p)
	self:superCall("ctor", p, "EndlessLevelMyAssistItem_skin");
end

function Lua_EndlessLevelMyAssistItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_EndlessLevelMyAssistItem:setData(data)
	if data == nil then
		if self.avatarItem ~= nil then
			self.avatarItem:setEnable(false);
		end
		self.nameTxt:setLangValue(779018);
	else
		if self.avatarItem == nil then
			self.avatarItem = Lua_AvatarItem.new(self.content);
			self.avatarItem:setSiblingIndex(self.selectedIcon.siblingIndex);
			self.avatarItem:setLocation(-1, 1.5, 0);
			self.avatarItem:setScale(1.15, 1.15, 1);
		end
		self.avatarItem:setRoleId(data.id, data.server_flag);
		self.avatarItem:setRoleDressUp(data.dress_info, false);
		self.avatarItem:setRoleFrame(nil);
		self.avatarItem:setRoleLevel(data.level);
		self.nameTxt.text = data.name;
	end
	self.addIcon:setEnable(data == nil);
	self.selectedIcon:setEnable(data ~= nil);
end

function Lua_EndlessLevelMyAssistItem:dispose()
	if self.avatarItem ~= nil then
		self.avatarItem:dispose();
		self.avatarItem = nil;
	end
	self:superCall("dispose");
end