-- 无尽关卡
Lua_EndlessLevelPanel = class("Lua_EndlessLevelPanel", Lua_DisplayObject);
function Lua_EndlessLevelPanel:ctor(p, skinName)
	self:superCall("ctor", p, skinName);
end

function Lua_EndlessLevelPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.rectW = 512;
	self.rectH = 199;
	self.subRectW = self.rectW;
	self.subRectH = 199;
	self.subMinPos = -(self.subRectW - self.rectW) / 2;
	self.subMaxPox = -self.subMinPos;
	self.spaceW = 150;
	self.stageArr = Array();
	self.rankArr = Array();

	self.scrollContainer = UICreate.createScrollContainer(self.content, 0, 0, self.rectW, self.rectH);
	self.scrollContainer.horizontal = true;
	self.scrollContainer.vertical = false;
	self.scrollContainer.movementTypeValue = 1;
	self.scrollContainer.elasticity = 0.3;
	self.scrollContainer.inertia = true;
	-- self.scrollContainer.siblingIndex = 8;
	self.scrollContainer.anchorValue = 7;
	self.scrollContainer:setScrollAnchor(0.5, 0.5, 0.5, 0.5);
	self.scrollContainer:setScrollPivot(4);
	self.scrollContainer:addRectMask2D();
	self.scrollContainer:addMousDownFuntion(self, self.onMouseDownFun);
	self.scrollContainer:addMouseUpFuntion(self, self.onMouseUpFun);
	self.scrollContainer:setLocation(61, 508, 0);

	self.dailyRewardRedPoint = Lua_RedPointIcon.new(self.content, Lua_RedPointList.EndlessLevel_DailyReward);
	self.dailyRewardRedPoint:setRectAnchor(7);
	self.dailyRewardRedPoint:setLocation(-247, 270, 0);

	self.assistRewardRedPoint = Lua_RedPointIcon.new(self.content, Lua_RedPointList.EndlessLevel_AssistReward);
	self.assistRewardRedPoint:setRectAnchor(7);
	self.assistRewardRedPoint:setLocation(-200, 626, 0);

	self.waveRewardRedPoint = Lua_RedPointIcon.new(self.content, Lua_RedPointList.EndlessLevel_WaveReward);
	self.waveRewardRedPoint:setRectAnchor(7);
	self.waveRewardRedPoint:setLocation(-200, 556, 0);

	self.sub = self.scrollContainer.scrollContent;
	self.waveBar = UICreate.createProgressBar(self.sub, "endless_level_atlas", "xui_dbzl_Progress _1_b",
		"endless_level_atlas", "xui_dbzl_Progress _1_f", -self.rectW / 2, 0, self.rectW, 10);
	self.waveBar.pivot = Lua_WindowUtil.getPivot(3);

	self.ruleBtn:addClickFuntion(self, self.onRuleClick);
	self.rankBtn:addClickFuntion(self, self.onRankClick);
	self.readBtn:addClickFuntion(self, self.onReadClick);
	self.inviteBtn:addClickFuntion(self, self.onInviteClick);
	self.previewBtn:addClickFuntion(self, self.onPreviewClick);
	self.rewardBtn:addClickFuntion(self, self.onRewardClick);
	self.assistRuleBtn:addClickFuntion(self, self.onAssistRuleClick);
	self.challengeBtn:addClickFuntion(self, self.onChallengeClick);
	self.buffTipsTxt:addUrlClickFuntion(self, self.onBuffTipsClick);

	self:addLuaEvent("UPDATE_ENDLESSLEVEL_INFO", self, self.updateEndlessLevelInfo);
	self:addLuaEvent("UPDATE_ENDLESSLEVEL_RANK_INFO", self, self.updateEndlessLevelRankInfo);
	self:addLuaEvent("UPDATE_ENDLESSLEVEL_ASSIS_MY_INFO", self, self.showAssistMyInfo);
	self:addLuaEvent("REQUEST_ENDLESSLEVEL_REFRESH_INFO", self, self.onEndlessLevelRefreshFun);
	self:addLuaEvent("REQUEST_ENDLESSLEVEL_RANK_INFO", self, self.onRequestRankInfo);
	self:addLuaEvent("REQUEST_ENDLESSLEVEL_RANKREWARD_INFO", self, self.onReadClick);
	self:addLuaEvent("REQUEST_ENDLESSLEVEL_CHALLENGE_INFO", self, self.onChallengeClick);
	self:addLuaEvent("REQUEST_ENDLESSLEVEL_DRAW_REWARD", self, self.onDrawRewardClick);
	self:addLuaEvent("FIGHTPLAY_ENTER", self, self.onFightRequestRefreshFun);
end

function Lua_EndlessLevelPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
end

function Lua_EndlessLevelPanel:setData(actVo)
	self.actVo = actVo;
	self:startTimer();
	self:updateLeftTime();
	self:onRequestRankInfo(0);
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sEndlessLevelAssistMyInfo(actVo.actIdx); -- 助阵奖励
end

function Lua_EndlessLevelPanel:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		self:addTimer("Lua_EndlessLevelPanel", 1, self, self.updateLeftTime);
	end
end

function Lua_EndlessLevelPanel:updateLeftTime()
	local time = self.actVo.residueTime;
	self.leftTimeTxt.text = LanUtil.formateStr(779001, Lua_TimeTransform.transSeconds16(time, true, true, true));
	if time <= 0 then
		self.leftTimeTxt:setLangValue(779002);
		self:endTimer();
	end
	if self.isCheck and time <= Lua_EndlessLevelData.reusltRankTime then
		Lua_MsgUtil.callFunc("REQUEST_ENDLESSLEVEL_REFRESH_INFO");
	end
	self.isCheck = time > Lua_EndlessLevelData.reusltRankTime;
end

function Lua_EndlessLevelPanel:endTimer()
	if self.bTimer == true then
		self.bTimer = false;
		self:removeTimer(self, self.updateLeftTime);
	end
end

function Lua_EndlessLevelPanel:updateEndlessLevelInfo()
	local endlessLevelData = DataCenter.endlessLevelData;
	self.assistTimesTxt.text = LanUtil.formateStr(779003, endlessLevelData.hasAssistTimes, endlessLevelData.maxAssistTimes);
	self.maxScoreTxt.text = LanUtil.formateStr(779004, endlessLevelData.curMaxWave, endlessLevelData.curMaxScore);

	local recordId = DataCenter.fightData:getRecordIdByTemplateId(Lua_FightDefine.TEMPLATE_ID_ENDLESSLEVEL);
	local isResultAct = self.actVo.residueTime <= Lua_EndlessLevelData.reusltRankTime;
	if isResultAct then
		self.challengeBtn:setLangValue(779005);
	else
		if recordId > 0 then
			self.challengeBtn:setLangValue(779006);
		else
			if not endlessLevelData.iskeepFighting then
				self.challengeBtn:setLangValue(779007);
			else
				self.challengeBtn:setLangValue(779061);
			end
		end
	end
	self:updateBuffTipsInfo();
	self:updateChallenCondInfo();
	self:updateRewardInfo();
	self:showFightEff(recordId > 0 and not isResultAct);
end

function Lua_EndlessLevelPanel:updateBuffTipsInfo()
	local buff = DataCenter.endlessLevelData.buff;
	local vo, num;
	local skillStr = "";
	for i = 1, #buff.skill_id do
		vo = Lua_SkillConfigData.getConfigData(buff.skill_id[i]); -- vo.show_type
		if vo then
			skillStr = skillStr .. LanUtil.formateStr(779069, buff.skill_id[i], vo.name);
			if i ~= #buff.skill_id then
				skillStr = skillStr .. "，";
			end
		end
	end
	self.buffTipsTxt.text = LanUtil.formateStr(779008, skillStr);
	self.buffTipsTxt:resetSize();
	self.buffTipsTxt:setEnable(#skillStr > 0);
end

function Lua_EndlessLevelPanel:updateChallenCondInfo()
	local challengeCond = DataCenter.endlessLevelData.challengeCond;
	local camp, career, target, campName, careerName;
	local str = "";
	for i = 1, #challengeCond do
		if #challengeCond[i][2] > 2 then -- 满足阵营和职业
			camp = challengeCond[i][2][1];
			career = challengeCond[i][2][2];
			target = challengeCond[i][2][3];
			campName = DataCenter.heroUtil:getCampName(camp);
			careerName = DataCenter.heroUtil:getHeroCareer(career);
			-- print(i, camp, career, target, campName, careerName);
			if camp > 0 and career > 0 then
				str = str .. LanUtil.formateStr(779009, target, campName, careerName);
			elseif camp > 0 then
				str = str .. LanUtil.formateStr(779010, target, campName);
			elseif career > 0 then
				str = str .. LanUtil.formateStr(779010, target, careerName);
			end
		end
	end
	self.condTxt.text = LanUtil.formateStr(779011, str);
	self.condTxt:setEnable(#str > 0);
end

function Lua_EndlessLevelPanel:updateRewardInfo()
	local rewardList = DataCenter.endlessLevelData.waveReward;
	local dataLen = #rewardList;
	local barWidth = dataLen * self.spaceW;
	self.subRectW = barWidth + 67; -- 67 item的宽/2
	local halfSubRectW = self.subRectW / 2;
	if not self.isFirstIn then
		self.isFirstIn = true;
		self.subMinPos = -(self.subRectW - self.rectW) / 2;
		self.subMaxPox = -self.subMinPos;
		-- self.scrollContainer.horizontal = dataLen > 5;
		self.scrollContainer:setScrollSize(self.subRectW, self.subRectH);
		self.scrollContainer:setScrollPosition(self.subMaxPox, 0, 0);

		self.waveBar:SetDimensions(barWidth, 10);
		self.waveBar:setLocation(-halfSubRectW, -52, 0);
	end

	local wave = DataCenter.endlessLevelData.totalMaxWave;
	self.scoreTxt.text = wave;

	local vo = rewardList[dataLen];
	local maxValue = vo.term_param1;
	local value = 0;
	local index = 1;
	if wave >= maxValue then
		value = maxValue;
	else
		for i = 1, dataLen do
			vo = rewardList[i];
			if vo.term_param1 >= wave then
				index = i;
				break;
			end
		end

		local num;
		local stepSpace = maxValue / dataLen;
		vo = rewardList[index];
		value = value + stepSpace * (index - 1);
		if index <= 1 then
			num = stepSpace / vo.term_param1;
			value = value + wave * num;
		else
			local preVo = rewardList[index - 1];
			num = stepSpace / (vo.term_param1 - preVo.term_param1);
			value = value + (wave - preVo.term_param1) * num;
		end
	end
	self.waveBar:setMaxValue(maxValue);
	self.waveBar:setValue(value);
	
	local hasLen = self.stageArr:getSize();
	local maxLen = dataLen > hasLen and dataLen or hasLen;
	local item;
	local index = 1;
	for i = 1, maxLen do
		item = self.stageArr[i];
		if i > dataLen then
			if item ~= nil then
				item:setEnable(false);
			end
		else
			vo = rewardList[i];
			if vo.term_param2 == 2 then index = i end
			if item == nil then
				item = Lua_EndlessLevelStageRewardItem.new(self.sub);
				item.contentName = "Lua_EndlessLevelStageRewardItem_" .. i;
				self.stageArr:add(item);
			end
			item:setEnable(true);
			item:setLocation(i / dataLen * barWidth - halfSubRectW, -52, 0);
			item:setData(vo, i == dataLen);
		end
	end
	-- self:moveToIndex(dataLen > 5 and index or 5);
	self:moveToIndex(index);

	local state = DataCenter.endlessLevelData.dayReward.term_param2;
	if state == 0 then
		self.rewardBtn:setAltas("endless_level_atlas", "xui_dbzl_widget_15");
	elseif state == 1 then
		self.rewardBtn:setAltas("endless_level_atlas", "xui_dbzl_widget_15");
	else
		self.rewardBtn:setAltas("endless_level_atlas", "xui_dbzl_widget_14");
	end
	self.rewardBtn:setGray(state == 0);
end

function Lua_EndlessLevelPanel:moveToIndex(idx)
	local targetPos = self.subMaxPox;
	for i = 1, idx - 1 do
		targetPos = targetPos - self.spaceW;
	end

	if targetPos > self.subMaxPox then
		targetPos = self.subMaxPox;
	elseif targetPos < self.subMinPos then
		targetPos = self.subMinPos;
	end
	self.scrollContainer:setScrollPosition(targetPos, 0, 0);
end

function Lua_EndlessLevelPanel:onMouseDownFun()
	self.startMouseX = CommonUtil.mousePositionX;
	self.startMouseY = CommonUtil.mousePositionY;
	self.startClickTime = getTime();
end

function Lua_EndlessLevelPanel:onMouseUpFun()
	local dx = CommonUtil.mousePositionX - self.startMouseX;
	local dy = CommonUtil.mousePositionY - self.startMouseY;
	if getTime() - self.startClickTime <= 0.3 and Mathf.Abs(dx) + Mathf.Abs(dy) < 4 then
		self:checkPressItem();
	end
end

function Lua_EndlessLevelPanel:checkPressItem()
	local winPos = LuaUtil.getTouchPosInverseObj(self.sub);
	local len = self.stageArr:getSize();
	for i = 1, len do
		if self.stageArr and self.stageArr[i] then
			if self.stageArr[i].isActive and self.stageArr[i]:checkInBound(winPos.x, winPos.y) then
				self.stageArr[i]:onPressClick();
			end
		end
	end
end

function Lua_EndlessLevelPanel:showFightEff(bShow)
	if bShow then
		if self.fightEff == nil then
			self.fightEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_ty_zdbs_0101", "ui_ty_zdbs_0101", 75, 260);
			self.fightEff.anchorValue = 7;
			self.fightEff:setScale(0.5, 0.5, 0.5);
		end
		self.fightEff:setEnable(true);
	else
		if self.fightEff then
			self.fightEff:setEnable(false);
		end
	end
end

function Lua_EndlessLevelPanel:updateEndlessLevelRankInfo(msg)
	if msg == nil then
		return;
	end

	local list = msg.rank_list;
	-- table.sort( list, function(a, b) return a.rank < b.rank end);
	local item;
	for i = 1, 3 do
		item = self.rankArr[i];
		if item == nil then
			item = Lua_EndlessLevelMiniRankItem.new(self.content);
			item:setRectAnchor(1);
			item:setLocation(0, -360 - (i - 1) * 64, 0);
			self.rankArr:add(item);
		end
		item:setData(i, list[i]);
	end
	local myRank = msg.self_rank.rank == 0 and LanUtil.getValue(779012) or msg.self_rank.rank;
	self.myRankTxt.text = LanUtil.formateStr(779013, myRank);
end

function Lua_EndlessLevelPanel:showAssistMyInfo(msg)
	if msg == nil then
		return;
	end
	self.assistNumTxt.text = LanUtil.formateStr(779062, #msg.helper_list, msg.helped_max);
	if #msg.helper_list >= msg.helped_max then
		self.buffTipsIcon:setAltas("endless_level_atlas", "xui_dbzl_label_5");
	else
		self.buffTipsIcon:setAltas("endless_level_atlas", "xui_dbzl_label_4");
	end
end

function Lua_EndlessLevelPanel:onEndlessLevelRefreshFun()
	self:onEndlessLevelOperate(1);
end

function Lua_EndlessLevelPanel:onRuleClick(go)
	local tipData = { des = self.actVo.help_des, posX = 180, posY = -323 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_EndlessLevelPanel:onRankClick(go)
	self:onEndlessLevelOperate(2);
end

function Lua_EndlessLevelPanel:onReadClick(go)
	self:onEndlessLevelOperate(3);
end

function Lua_EndlessLevelPanel:onInviteClick(go)
	self:onEndlessLevelOperate(4);
end

function Lua_EndlessLevelPanel:onPreviewClick(go)
	self:onEndlessLevelOperate(5);
end

function Lua_EndlessLevelPanel:onRewardClick(go)
	self:onEndlessLevelOperate(6);
end

function Lua_EndlessLevelPanel:onAssistRuleClick(go)
	local tipData = { des = 779014, isBottomShow = true, posX = 180, posY = 400 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_EndlessLevelPanel:onChallengeClick(go)
	self:onEndlessLevelOperate(7);
end

function Lua_EndlessLevelPanel:onBuffTipsClick(urlStr)
	local arr = string.split(urlStr, "_");
	if arr and arr:getSize() > 1 then
		local skillData = Lua_SkillConfigData.getConfigData(arr[2]);
		if skillData ~= nil then
			if skillData.subType == 1 then
				Lua_WindowUtil.openWin("Lua_HeroAwakenSkillDetailsWindow", Lua_WinParam.ACTION_OPEN, skillData);
			elseif skillData.artifactId > 0 then
				Lua_WindowUtil.openWin("Lua_ArtifactSkillTipsWindow", Lua_WinParam.ACTION_OPEN, skillData);
			else
				local param = {skillVo = skillData, skill_level = nil, unlock_type = nil, unlock_level = nil, extra_des = nil};
				Lua_WindowUtil.openWin("Lua_SkillTipsWindow", Lua_WinParam.ACTION_OPEN, param);
			end
		end
	end
end

-- 请求排行信息
function Lua_EndlessLevelPanel:onRequestRankInfo(page)
	self:onEndlessLevelOperate(8, page);
end

function Lua_EndlessLevelPanel:onDrawRewardClick(rewardType)
	self:onEndlessLevelOperate(9, rewardType);
end

function Lua_EndlessLevelPanel:onEndlessLevelOperate(operateType, param)
	if DataCenter.backstageActData:checkActIsEnd(self.actVo) then
		return;
	end

	if operateType == 1 then -- 刷新
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sActivityInfo(self.actVo.actIdx);
	elseif operateType == 2 then -- 排行榜
		Lua_WindowUtil.openWin("Lua_EndlessLevelRankWindow", Lua_WinParam.ACTION_OPEN, self.actVo);
	elseif operateType == 3 then -- 排行奖励
		Lua_WindowUtil.openWin("Lua_EndlessLevelRankRewardWindow", Lua_WinParam.ACTION_OPEN, self.actVo);
	elseif operateType == 4 then -- 我的助阵
		Lua_WindowUtil.openWin("Lua_EndlessLevelMyAssistWindow", Lua_WinParam.ACTION_OPEN, self.actVo);
	elseif operateType == 5 then -- 波数奖励
		Lua_WindowUtil.openWin("Lua_EndlessLevelPreviewRewardWindow", Lua_WinParam.ACTION_OPEN, self.actVo);
	elseif operateType == 6 then -- 每日奖励
		Lua_WindowUtil.openWin("Lua_EndlessLevelDailyRewardWindow", Lua_WinParam.ACTION_OPEN);
	elseif operateType == 7 then -- 布阵
		if self.actVo.residueTime <= Lua_EndlessLevelData.reusltRankTime then
			-- local leftTime = getReaminSecondsTo24();
			OperateAlert.showLangValue(779016);
			return;
		end
		local recordId = DataCenter.fightData:getRecordIdByTemplateId(Lua_FightDefine.TEMPLATE_ID_ENDLESSLEVEL);
		if recordId > 0 then
			DataCenter.fightData:showFightToStageByRid(recordId);
			return;
		end
		if not DataCenter.endlessLevelData.iskeepFighting then
			local sceneId = DataCenter.heroLineupData:getFightLineupSceneId(Lua_FightDefine.TEMPLATE_ID_ENDLESSLEVEL);
			DataCenter.preLoadData:preShowScene("Lua_EndlessLevelLineupWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onSceneShow, nil, sceneId, 0);
		else
			self.isNeedRefresh = true;
			Lua_ProxyManager.getProxy("Lua_FightProxy"):sStartFight(Lua_FightDefine.TEMPLATE_ID_ENDLESSLEVEL, self.actVo.actIdx);
		end
	elseif operateType == 8 then -- 排行榜信息
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sEndlessLevelRankInfo(self.actVo.actIdx, param);
	elseif operateType == 9 then -- 领取奖励
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sEndlessLevelDrawReward(param, self.actVo.actIdx);
	end
end

function Lua_EndlessLevelPanel:onSceneShow(param, mp, success)
	if not success then return; end
	local data = Lua_LineupWinData.getData(Lua_FightDefine.TEMPLATE_ID_ENDLESSLEVEL, nil, self.actVo.actIdx);
	Lua_WindowUtil.openWin("Lua_EndlessLevelLineupWindow", Lua_WinParam.ACTION_OPEN, data);
end

function Lua_EndlessLevelPanel:onFightRequestRefreshFun()
	if self.isNeedRefresh or DataCenter.endlessLevelData.isNeedRefresh then
		self.isNeedRefresh = false;
		DataCenter.endlessLevelData.isNeedRefresh = false;
		self:onEndlessLevelRefreshFun();
	end
end

function Lua_EndlessLevelPanel:dispose()
	if self.stageArr ~= nil then
		self.stageArr:dispose();
		self.stageArr:clear();
		self.stageArr = nil;
	end
	if self.rankArr ~= nil then
		self.rankArr:dispose();
		self.rankArr:clear();
		self.rankArr = nil;
	end
	if self.dailyRewardRedPoint ~= nil then
		self.dailyRewardRedPoint:dispose();
		self.dailyRewardRedPoint = nil;
	end
	if self.assistRewardRedPoint ~= nil then
		self.assistRewardRedPoint:dispose();
		self.assistRewardRedPoint = nil;
	end
	if self.waveRewardRedPoint ~= nil then
		self.waveRewardRedPoint:dispose();
		self.waveRewardRedPoint = nil;
	end
	if self.scrollContainer ~= nil then
		self.scrollContainer:dispose();
		self.scrollContainer = nil;
	end
	if self.waveBar ~= nil then
		self.waveBar:dispose();
		self.waveBar = nil;
	end
	if self.fightEff ~= nil then
		self.fightEff:dispose();
		self.fightEff = nil;
	end
	self.sub = nil;
	self.actVo = nil;
	DataCenter.preLoadData:removeBySign("Lua_EndlessLevelLineupWindow", self, self.onSceneShow);
	self:endTimer();
	self:superCall("dispose");
end










Lua_EndlessLevelStageRewardItem = class("Lua_EndlessLevelStageRewardItem", Lua_DisplayObject);
function Lua_EndlessLevelStageRewardItem:ctor(p)
	self:superCall("ctor", p, "EndlessLevelStageRewardItem_skin");
end

function Lua_EndlessLevelStageRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.showItem = Lua_EndlessLevelStageRewardSubItem.new(self.content);
	self.showItem:setRectPivot(7);
	self.showItem:setLocation(0, 10, 0);
end

function Lua_EndlessLevelStageRewardItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local spriteName = data.term_param2 == 0 and "xui_dbzl_widget_9" or "xui_dbzl_widget_8";
	self.pointIcon:setAltas("endless_level_atlas", spriteName);
	self.pointIcon:resetSize();

	self.showItem:setData(data);
	self.showItem:setScale(data.scale, data.scale);

	self.waveTxt.text = LanUtil.formateStr(779017, data.term_param1);
	self.waveTxt:resetSize();
end

function Lua_EndlessLevelStageRewardItem:checkInBound(posX, posY)
	local minX = self.centerPosX + self.showItem.posX + - self.showItem:getWidth() / 2 * self._data.scale;
	local maxX = self.centerPosX + self.showItem.posX + self.showItem:getWidth() / 2 * self._data.scale;
	local minY = self.centerPosY + self.showItem.posY;
	local maxY = self.centerPosY + self.showItem.posY + self.showItem:getHeight() * self._data.scale;
	return posX >= minX and posX <= maxX and posY >= minY and posY <= maxY;
end

function Lua_EndlessLevelStageRewardItem:onPressClick(go)
	if self._data.term_param2 == 1 then
		Lua_MsgUtil.callFunc("REQUEST_ENDLESSLEVEL_DRAW_REWARD", 1);
	else
		local vo = Lua_ToolVo.createToolVo(self._data.item[1].id);
		vo:fromServer(self._data.item[1]);
		DataCenter.packUtil:showItemInfo(vo);
	end
end

function Lua_EndlessLevelStageRewardItem:dispose()
	if self.showItem ~= nil then
		self.showItem:dispose();
		self.showItem = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end










Lua_EndlessLevelStageRewardSubItem = class("Lua_EndlessLevelStageRewardSubItem", Lua_DisplayObject);
function Lua_EndlessLevelStageRewardSubItem:ctor(p)
	self:superCall("ctor", p, "EndlessLevelStageRewardSubItem_skin");
end

function Lua_EndlessLevelStageRewardSubItem:buildShowItem()
	self:superCall("buildShowItem");

	self:setRectSize(self.itemBg.width, self.itemBg.height);
	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setSiblingIndex(1);
end

function Lua_EndlessLevelStageRewardSubItem:setData(data)
	local tvo = Lua_ToolVo.createToolVo(data.item[1].id);
	tvo:fromServer(data.item[1]);
	self.itemIcon:setData(tvo);
	self.drawIcon_1:setEnable(data.term_param2 == 2);
	self.drawIcon_2:setEnable(data.term_param2 == 2);
end

function Lua_EndlessLevelStageRewardSubItem:getWidth()
	return self.itemIcon.iconBg.width;
end

function Lua_EndlessLevelStageRewardSubItem:getHeight()
	return self.itemIcon.iconBg.height;
end

function Lua_EndlessLevelStageRewardSubItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self:superCall("dispose");
end










Lua_EndlessLevelMiniRankItem = class("Lua_EndlessLevelMiniRankItem", Lua_ListCell);
function Lua_EndlessLevelMiniRankItem:ctor(p)
	self:superCall("ctor", p, "EndlessLevelMiniRankItem_skin");
end

function Lua_EndlessLevelMiniRankItem:setData(rank, data)
	self.rankIcon:setAltas("endless_level_atlas", "xui_dbzl_label_"..rank);
	self.rankIcon:resetSize();
	if data == nil then
		self.nameTxt:setLangValue(779018);
		self.scoreTxt.text = "";
	else
		self.nameTxt.text = data.player_show.name;
		self.scoreTxt.text = LanUtil.formateStr(779019, data.value, data.sub_value);
	end
end