-- 无尽关卡波数奖励预览界面
Lua_EndlessLevelPreviewRewardWindow = class("Lua_EndlessLevelPreviewRewardWindow", Lua_Window);
function Lua_EndlessLevelPreviewRewardWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_EndlessLevelPreviewRewardWindow";
	self.skinName = "EndlessLevelPreviewRewardWindow_skin";
	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_EndlessLevelPreviewRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.itemList = Lua_DragList.new(self.content, 628, 760, Lua_AxisDefine.Vertical);
	self.itemList:setListCell(Lua_EndlessLevelPreviewRewardItem, 628, 165, 1);
	self.itemList:setLocation(0, -70, 0);
	self.itemList:setCellSpacing(0, 5);
	self:updateEndlessLevelInfo();

	self:addLuaEvent("UPDATE_ENDLESSLEVEL_INFO", self, self.updateEndlessLevelInfo);
end

function Lua_EndlessLevelPreviewRewardWindow:updateEndlessLevelInfo()
	-- 可领取＞未达成＞已领取，term_param2：0未完成 1可领取 2已领取
	local list = DataCenter.endlessLevelData.waveReward;
	table.sort( list,
		function(a, b)
			if a.term_param2 == b.term_param2 then
				return a.id < b.id;
			else
				local aWeight = (a.term_param2 + 1) % 3;
				local bWeight = (b.term_param2 + 1) % 3;
				return aWeight > bWeight;
			end
		end
	);
	self.itemList:setArrayData(list);
end

function Lua_EndlessLevelPreviewRewardWindow:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	self:superCall("dispose");
end










Lua_EndlessLevelPreviewRewardItem = class("Lua_EndlessLevelPreviewRewardItem", Lua_ListCell);
function Lua_EndlessLevelPreviewRewardItem:ctor(p)
	self:superCall("ctor", p, "EndlessLevelPreviewRewardItem_skin");
end

function Lua_EndlessLevelPreviewRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 400, 87, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_EndlessLevelPreviewRewardIconItem, 87, 87, 1);
	self.rewardList:setLocation(-90, -17, 0);
	self.rewardList:setCellSpacing(5, 0);
	self:setSubList(self.rewardList);

	self.stateBtn:addClickFuntion(self, self.onBtnClick);
end

function Lua_EndlessLevelPreviewRewardItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local wave = DataCenter.endlessLevelData.totalMaxWave;
	wave = wave >= data.term_param1 and data.term_param1 or wave;
	local colorStr = wave >= data.term_param1 and "503A2C" or "ED4C30";
	self.desTxt.text = LanUtil.formateStr(779039, data.term_param1, colorStr, wave, data.term_param1);

	self.rewardList.canDrag = #data.item > 4;
	self.rewardList:setArrayData(data.item);

	if data.term_param2 == 0 then
		self.drawIcon:setAltas("common_altas_4", "xui_common_label_28");
	elseif data.term_param2 == 2 then
		self.drawIcon:setAltas("common_altas_1", "xui_common_label_12");
	end
	self.stateBtn:setEnable(data.term_param2 == 1);
	self.drawIcon:setEnable(data.term_param2 ~= 1);
	self:showRedDot(data.term_param2 == 1);
end

function Lua_EndlessLevelPreviewRewardItem:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:createRedPointEff();
			self.redPoint:setLocation(267, -5, 0);
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_EndlessLevelPreviewRewardItem:onBtnClick(go)
	Lua_MsgUtil.callFunc("REQUEST_ENDLESSLEVEL_DRAW_REWARD", 1);
end

function Lua_EndlessLevelPreviewRewardItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end










Lua_EndlessLevelPreviewRewardIconItem = class("Lua_EndlessLevelPreviewRewardIconItem", Lua_ItemIconCell)
function Lua_EndlessLevelPreviewRewardIconItem:buildShowItem()
	self:superCall("buildShowItem");
	self.itemIcon:setScale(0.7, 0.7);
end