-- 无尽关卡排行奖励界面
Lua_EndlessLevelRankRewardWindow = class("Lua_EndlessLevelRankRewardWindow", Lua_Window);
function Lua_EndlessLevelRankRewardWindow:ctor(p)
	self:superCall("ctor");

	self.windowName = "Lua_EndlessLevelRankRewardWindow";
	self.skinName = "EndlessLevelRankRewardWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_EndlessLevelRankRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.itemList = Lua_DragList.new(self.content, 620, 684, Lua_AxisDefine.Vertical);
	self.itemList:setListCell(Lua_EndlessLevelRankRewardItem, 620, 120, 1);
	self.itemList:setLocation(0, -78, 0);
	self.itemList:setCellSpacing(0, 5);

	self:addLuaEvent("UPDATE_ENDLESSLEVEL_RANK_REWARD", self, self.updateShowInfo);
end

function Lua_EndlessLevelRankRewardWindow:showWin(param)
	self:superCall("showWin", param);
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sEndlessLevelRankRewardInfo(param.actIdx);
end

function Lua_EndlessLevelRankRewardWindow:updateShowInfo(msg)
	if msg == nil then return; end
	table.sort( msg, function(a, b) return a.term_param1 < b.term_param1; end );
	self.itemList:setArrayData(msg);
end

function Lua_EndlessLevelRankRewardWindow:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	self:superCall("dispose");
end










Lua_EndlessLevelRankRewardItem = class("Lua_EndlessLevelRankRewardItem", Lua_ListCell);
function Lua_EndlessLevelRankRewardItem:ctor(p)
	self:superCall("ctor", p, "EndlessLevelRankRewardItem_skin");
end

function Lua_EndlessLevelRankRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 400, 87, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_EndlessLevelRankRewardIconItem, 87, 87, 1);
	self.rewardList:setLocation(80, 0, 0);
	self.rewardList:setCellSpacing(5, 0);
	self:setSubList(self.rewardList);
end

function Lua_EndlessLevelRankRewardItem:setData(data)
	if data == nil then
		return;
	end

	if data.term_param1 == data.term_param2 then
		self.rankBg:setAltas("common_altas_4", "xui_jys_label_1"..(data.term_param1 - 1));
		self.rankTxt:setEnable(false);
	else
		self.rankTxt:setEnable(true);
		self.rankBg:setAltas("common_altas_4", "xui_jys_label_13");
		local rightStr;
		if data.term_param2 == -1 then
			rightStr = "+";
		else
			if data.term_param2 > 100 then
				rightStr = "-\n"..data.term_param2;
			else
				rightStr = "-"..data.term_param2;
			end
		end
		self.rankTxt.text = data.term_param1..rightStr;
	end

	local tvo;
	local tvoArr = Array();
	for i = 1, #data.item do
		tvo = Lua_ToolVo.createToolVo(data.item[i].id);
		tvo:fromServer(data.item[i]);
		tvoArr:add(tvo);
	end
	self.rewardList.canDrag = tvoArr:getSize() > 4;
	self.rewardList:setArrayData(tvoArr);
end

function Lua_EndlessLevelRankRewardItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self:superCall("dispose");
end










Lua_EndlessLevelRankRewardIconItem = class("Lua_EndlessLevelRankRewardIconItem", Lua_ItemIconCell)
function Lua_EndlessLevelRankRewardIconItem:buildShowItem()
	self:superCall("buildShowItem");
	self.itemIcon:setScale(0.7, 0.7);
end