-- 无尽关卡-好友分享邀请
Lua_EndlessLevelShareFriendWindow = class("Lua_EndlessLevelShareFriendWindow", Lua_Window);
function Lua_EndlessLevelShareFriendWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_EndlessLevelShareFriendWindow";
	self.skinName = "EndlessLevelShareFriendWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_EndlessLevelShareFriendWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.titleName:setLangValue(779045);
	self.tipTxt:setLangValue(779046);

	self.friendList = Lua_DragList.new(self.content, 610, 473, Lua_AxisDefine.Vertical);
	self.friendList:setListCell(Lua_EndlessLevelShareFriendItem, 610, 136, 1);
	self.friendList:setCellSpacing(0, 10);
	self.friendList:setLocation(0, -40, 0);

	self:addLuaEvent("ENDLESSLEVEL_ASSIST_SHARE_TO_FRIEND", self, self.shareToFriend);
	self:addLuaEvent("SET_FRIENDPANEL_INFO", self, self.updateFriendList);
	Lua_ProxyManager.getProxy("Lua_FriendProxy"):sGetFriendListInfo(Lua_FriendData.FRIEND_TYPE);
end

function Lua_EndlessLevelShareFriendWindow:showWin(param)
	self:superCall("showWin", param);
	self.owner = param.owner;
	self.callbackFun = param.callbackFun;
end

function Lua_EndlessLevelShareFriendWindow:updateFriendList()
	local friendInfo = DataCenter.friendData:getFriendType(Lua_FriendData.FRIEND_TYPE);
	local list = friendInfo:getFriendList();
	self.friendList:setArrayData(list);
	self.tipTxt:setEnable(list == nil or #list <= 0);
end

function Lua_EndlessLevelShareFriendWindow:shareToFriend(friendInfo)
	if self.owner ~= nil and self.callbackFun ~= nil then
		self.callbackFun(self.owner, friendInfo);
		self:hide();
	end
end

function Lua_EndlessLevelShareFriendWindow:dispose()
	if self.friendList ~= nil then
		self.friendList:dispose();
		self.friendList = nil;
	end
	self.owner = nil;
	self.callbackFun = nil;
	self:superCall("dispose");
end










Lua_EndlessLevelShareFriendItem = class("Lua_EndlessLevelShareFriendItem", Lua_ListCell);
function Lua_EndlessLevelShareFriendItem:ctor(p)
	self:superCall("ctor", p, "EndlessLevelShareFriendItem_skin");
end

function Lua_EndlessLevelShareFriendItem:buildShowItem()
	self:superCall("buildShowItem");

	self.avatarItem = Lua_AvatarItem.new(self.content);
	self.avatarItem:setAvatarClick(self, self.onHeadImageClick);
	self.avatarItem:setLocation(-237, 0, 0);
	self.avatarItem:setScale(0.8, 0.8);

	self.shareBtn:addClickFuntion(self, self.onShareClick);
end

function Lua_EndlessLevelShareFriendItem:setData(data)
	self._data = DataCenter.friendData:getFriendType(Lua_FriendData.FRIEND_TYPE):getFriendItemById(data);
	if data == nil or self._data == nil then
		return;
	end

	self.avatarItem:setRoleId(tonumber(self._data.show.id), self._data.show.server_flag);
	self.avatarItem:setRoleDressUp(self._data.show.dress_info, true);
	self.avatarItem:setRoleLevel2(self._data.show.level);

	self.nameTxt.text = self._data.show.name;
	self.fightTxt.text = self._data.show.force;

	if self._data.offlineTick == 0 then -- 在线
		self.onlineTxt:setLangValue(779047); -- <color=#777675>离线</color>
	else
		if self._data.offlineTick / 3600 < 1 then
			self.onlineTxt.text = LanUtil.formateStr(779048, Mathf.Floor(self._data.offlineTick / 60));
		elseif self._data.offlineTick / 3600 < 24 then
			self.onlineTxt.text = LanUtil.formateStr(779049, Mathf.Floor(self._data.offlineTick / 3600));
		elseif self._data.offlineTick / 3600 < 48 then
			self.onlineTxt.text = LanUtil.formateStr(779050, 1);
		elseif self._data.offlineTick / 3600 < 72 then
			self.onlineTxt.text = LanUtil.formateStr(779051, 2);
		else
			self.onlineTxt:setLangValue(779052);
		end
	end
end

function Lua_EndlessLevelShareFriendItem:onHeadImageClick(go)
	Lua_ProxyManager.getProxy("Lua_RoleProxy"):sOtherRoleId(self._data.show.id, self._data.show.server_flag);
end

function Lua_EndlessLevelShareFriendItem:onShareClick()
	if self._data ~= nil and self._data.show ~= nil then
		Lua_MsgUtil.callFunc("ENDLESSLEVEL_ASSIST_SHARE_TO_FRIEND", self._data.show);
	end
end

function Lua_EndlessLevelShareFriendItem:dispose()
	if self.avatarItem ~= nil then
		self.avatarItem:dispose();
		self.avatarItem = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end