-- 半月礼包-预览界面
Lua_HalfMonthGiftPreviewWindow = class("Lua_HalfMonthGiftPreviewWindow", Lua_Window);
function Lua_HalfMonthGiftPreviewWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_HalfMonthGiftPreviewWindow";
	self.showBlackMask = true;
	self.isClickClose = true;
	self.showCloseText = true;
	self.closeTextPosY = -480;
	self.showWinBg = true;
	self.winBgPosX = 0;
	self.winBgPosY = 40;
	self.winBgPath = "/images/activities/xui_bylb_bg_2.png";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
end

function Lua_HalfMonthGiftPreviewWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.tltleIcon = UICreate.createUIAtlasImage(self.content, "half_month_gift_atlas", "xui_bylb_title_2", 0, 410, 0, 0);

	self.dragContainer = Lua_DragListContainer.new(self.content, 638, 745, Lua_AxisDefine.Vertical);
	self.dragContainer:setCellSpacing(10, 15);
	self.dragContainer:setLocation(2.5, -6, 0);
end

function Lua_HalfMonthGiftPreviewWindow:showWin(param)
	self:superCall("showWin", param);

	local list = DataCenter.halfMonthGiftData:getPreviewInfoByGifType(param);
	self.dragContainer:clearList();
	for i = 1, #list do
		if list[i][1].reward_type == 2 then
			self.dragContainer:addChildData(list[i], Lua_HalfMonthGiftPreviewOptionalItem, 638, 186, 1); -- 自选奖励
		else
			self.dragContainer:addChildData(list[i], Lua_HalfMonthGiftPreviewFixItem, 206, 186, 3); -- 固定奖励
		end
	end
	self.dragContainer:updateChildPos();
end

function Lua_HalfMonthGiftPreviewWindow:dispose()
	if self.tltleIcon ~= nil then
		self.tltleIcon:dispose();
		self.tltleIcon = nil;
	end
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end
	self:superCall("dispose");
end










Lua_HalfMonthGiftPreviewOptionalItem = class("Lua_HalfMonthGiftPreviewOptionalItem", Lua_DragContainerItem)
function Lua_HalfMonthGiftPreviewOptionalItem:ctor(p)
	self:superCall("ctor", p, "HalfMonthGiftOptionalItem_skin");
end

function Lua_HalfMonthGiftPreviewOptionalItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 378, 81, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_HalfMonthGiftPreviewOptionalRewardItemm, 81, 81, 1);
	self.rewardList:setCellSpacing(10, 0);
	self.rewardList:setRectPivot(3);
	self.rewardList:setLocation(-90, -12, 0);
	self:setSubList(self.rewardList);

	self.maskIcon:setEnable(false);
	self.drawIcon:setEnable(false);
end

function Lua_HalfMonthGiftPreviewOptionalItem:setData(data)
	if data == nil then
		return;
	end

	self.dayTxt.text = data.title;
	self.tipsTxt.text = LanUtil.formateStr(789007, convert_arab_to_chinese(data.free_number, true));
	self.desTxt.text = data.content;
	self.itemIcon:setAltas(data.icon_config.icon_atlas, data.icon_config.icon_index);

	self.rewardList.canDrag = #data.item_list > 4;
	self.rewardList:setArrayData(data.item_list);
end

function Lua_HalfMonthGiftPreviewOptionalItem:dispose()
	if self.rewardList then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self:superCall("dispose");
end










Lua_HalfMonthGiftPreviewOptionalRewardItemm = class("Lua_HalfMonthGiftPreviewOptionalRewardItemm", Lua_ItemIconCell);
function Lua_HalfMonthGiftPreviewOptionalRewardItemm:buildShowItem()
	self:superCall("buildShowItem");
	self.itemIcon:setScale(0.65, 0.65);
end










Lua_HalfMonthGiftPreviewFixItem = class("Lua_HalfMonthGiftPreviewFixItem", Lua_DragContainerItem)
function Lua_HalfMonthGiftPreviewFixItem:ctor(p)
	self:superCall("ctor", p, "HalfMonthGiftFixItem_skin");
end

function Lua_HalfMonthGiftPreviewFixItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setCanClick(false);
	self.itemIcon:setSiblingIndex(2);
	self.itemIcon:setScale(0.7, 0.7);
	self.itemIcon:setLocation(0, -12.5, 0);

	self.maskIcon:setEnable(false);
	self.drawIcon:setEnable(false);
end

function Lua_HalfMonthGiftPreviewFixItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.dayTxt.text = data.title;
	local tvo = Lua_ToolVo.createToolVo(data.item_list[1].id);
	tvo:fromServer(data.item_list[1]);
	self.itemIcon:setData(tvo);
end

function Lua_HalfMonthGiftPreviewFixItem:checkInBound(posX, posY)
	local minX = self.centerPosX - self.itemIcon.itemW / 2 * self.itemIcon.scaleX;
	local maxX = self.centerPosX + self.itemIcon.itemW / 2 * self.itemIcon.scaleX;
	local minY = self.centerPosY - self.itemIcon.itemH / 2 * self.itemIcon.scaleY;
	local maxY = self.centerPosY + self.itemIcon.itemH / 2 * self.itemIcon.scaleY;
	return posX >= minX and posX <= maxX and posY >= minY and posY <= maxY;
end

function Lua_HalfMonthGiftPreviewFixItem:onPressClick()
	if self._data == nil then
		return;
	end
	self.itemIcon:onItemClick();
end

function Lua_HalfMonthGiftPreviewFixItem:dispose()
	if self.itemIcon then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end