-- 半月礼包-自选奖励界面
Lua_HalfMonthGiftSelectWindow = class("Lua_HalfMonthGiftSelectWindow", Lua_Window);
function Lua_HalfMonthGiftSelectWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_HalfMonthGiftSelectWindow";
	self.skinName = "HalfMonthGiftSelectWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_HalfMonthGiftSelectWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 600, 306, Lua_AxisDefine.Vertical);
	-- self.rewardList.canLongPress = true;
	-- self.rewardList.longPressLimit = 0.4;
	self.rewardList:setListCell(Lua_HalfMonthGiftSelectRewardItem, 120, 100, 5);
	self.rewardList:setCellSpacing(0, 16);
	self.rewardList:setLocation(0, 44, 0);

	self.cancelBtn:addClickFuntion(self, self.hide);
	self.sureBtn:addClickFuntion(self, self.onSureClick);

	self:addLuaEvent("ON_HALFMONTHGIFT_OPTIONAL_SELECT_CLICK", self, self.onSelcetOptionalRewardClick);
end

function Lua_HalfMonthGiftSelectWindow:showWin(param)
	self:superCall("showWin", param);

	self.tipsTxt.text = LanUtil.formateStr(789008, param.giftInfo.free_number);

	local list = self.showData.giftInfo.item_list;
	self.showTvoArr = Array()
	for i = 1, #list do
		tvo = Lua_ToolVo.createToolVo(list[i].id);
		tvo:fromServer(list[i]);
		tvo.bSelect = false;
		self.showTvoArr:add(tvo);
	end
	self:showOptionalGiftInfo();
end

function Lua_HalfMonthGiftSelectWindow:showOptionalGiftInfo(param)
	if self.itemArr == nil then
		self.itemArr = Array();
	else
		self.itemArr:clear();
	end

	-- 策划要求暂时不处理多个的情况
	-- local bChange = false;
	-- for i = 1, self.showTvoArr:getSize() do
	-- 	if not bChange and param and param.id == self.showTvoArr[i].id and param.count == self.showTvoArr[i].count then
	-- 		bChange = true;
	-- 		self.showTvoArr[i].bSelect = not param.bSelect;
	-- 	end
	-- 	if self.showTvoArr[i].bSelect then
	-- 		self.itemArr:add(self.showTvoArr[i]);
	-- 	end
	-- end
	local bChange = false;
	for i = 1, self.showTvoArr:getSize() do
		self.showTvoArr[i].bSelect = false;
		if not bChange and param and param.id == self.showTvoArr[i].id and param.count == self.showTvoArr[i].count then
			bChange = true;
			self.showTvoArr[i].bSelect = not param.bSelect;
			if self.showTvoArr[i].bSelect then
				self.itemArr:add(self.showTvoArr[i]);
			end
		end
	end
	self.rewardList.canDrag = self.showTvoArr:getSize() > 10;
	self.rewardList:setArrayData(self.showTvoArr);
end

function Lua_HalfMonthGiftSelectWindow:onSelcetOptionalRewardClick(param)
	-- 策划要求暂时不处理多个的情况
	-- if self.itemArr:getSize() >= self.showData.giftInfo.free_number and not param.bSelect then
	-- 	OperateAlert.show(LanUtil.formateStr(789009, self.showData.giftInfo.free_number));
	-- 	return;
	-- end
	self:showOptionalGiftInfo(param);
end

function Lua_HalfMonthGiftSelectWindow:onSureClick(go)
	if DataCenter.backstageActData:checkActIsEnd(self.showData.actVo) then
		self:hide();
		return;
	end
	-- 策划要求暂时不处理多个的情况
	-- if self.itemArr:getSize() < self.showData.giftInfo.free_number then
	-- 	OperateAlert.show(LanUtil.formateStr(789010, self.showData.giftInfo.free_number - self.itemArr:getSize()));
	-- 	return;
	-- end
	if self.itemArr:getSize() <= 0 then
		OperateAlert.showLangValue(789011);
		return;
	end
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sDrawHalfMonthGift(self.showData.actVo.actIdx, self.showData.giftInfo.id, self.itemArr);
	self:hide();
end

function Lua_HalfMonthGiftSelectWindow:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self:superCall("dispose");
end












Lua_HalfMonthGiftSelectRewardItem = class("Lua_HalfMonthGiftSelectRewardItem", Lua_ListCell);
function Lua_HalfMonthGiftSelectRewardItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_HalfMonthGiftSelectRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setScale(0.8, 0.8);
end

function Lua_HalfMonthGiftSelectRewardItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.itemIcon:setData(data);
	self.itemIcon:setDrawMask(data.bSelect);
end

function Lua_HalfMonthGiftSelectRewardItem:onPressClick()
	if self._data then
		Lua_MsgUtil.callFunc("ON_HALFMONTHGIFT_OPTIONAL_SELECT_CLICK", self._data); -- cellSeqIndex
	end
end

-- function Lua_HalfMonthGiftSelectRewardItem:onLongPressClick()
-- 	if self._data == nil then
-- 		return;
-- 	end
-- 	DataCenter.packUtil:showItemInfo(self._data);
-- end

function Lua_HalfMonthGiftSelectRewardItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end