-- 跳跳乐（后台）
Lua_JumpHappyPanel = class("Lua_JumpHappyPanel", Lua_DisplayObject);
function Lua_JumpHappyPanel:ctor(p, skinName)
	self:superCall("ctor", p, skinName);
end

function Lua_JumpHappyPanel:buildShowItem()
	self:superCall("buildShowItem");

	self:createRedPoint();
	self.levelList = Lua_DragList.new(self.content, 716, 469, Lua_AxisDefine.Vertical);
	self.levelList:setListCell(Lua_JumpHappyLevelItem, 716, 153, 1);
	self.levelList:setCellSpacing(0, 5);
	self.levelList:setRectAnchor(7);
	self.levelList:setLocation(0, 410, 0);

	self.tipSp:addClickFuntion(self, self.onClickTipSp);
	self.taskSp:addClickFuntion(self, self.onClickTaskSpSp);
	self.rankSp:addClickFuntion(self, self.onClickRankSpSp);
	self.operateSp:addClickFuntion(self, self.onClickOperateSp);
	self:addLuaEvent("UPDATE_JUMPHAPPY_PANEL_INFO", self, self.updatePanel);
	self:addLuaEvent("SHOW_JUMPHAPPY_REWARD_INFO", self, self.showRewardWin);
end

function Lua_JumpHappyPanel:dispose()
	self:endTimer();
	self.act_vo = nil;
	if self.taskRedPoint then
		self.taskRedPoint:dispose();
		self.taskRedPoint = nil;
	end
	if self.levelList then
		self.levelList:dispose();
		self.levelList = nil;
	end
	self:superCall("dispose");
end

function Lua_JumpHappyPanel:setData(data)
	self.act_vo = data;

	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sJumpingHappyTaskInfo(self.act_vo.actIdx, 1);
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sJumpingHappyTaskInfo(self.act_vo.actIdx, 2);

	self.actEndTime = self.act_vo and self.act_vo.end_tick or 0;
	DataCenter.jumpingHappyData.activity_id = self.act_vo.actIdx;
	self:onTimer();
	self:starTimer();
end

function Lua_JumpHappyPanel:createRedPoint()
	if self.taskRedPoint == nil then
		self.taskRedPoint = Lua_RedPointIcon.new(self.content, Lua_RedPointList.JumpHappy_Task);
		self.taskRedPoint:setLocation(329, -192);
		self.taskRedPoint:setRectAnchor(1);
	end
end

function Lua_JumpHappyPanel:checkValidActivity()
	local activity_id = DataCenter.jumpingHappyData.activity_id;
	local actVo = DataCenter.backstageActData:getActVoByIdx(activity_id);
	if DataCenter.backstageActData:checkActIsEnd(actVo) then
		return;
	end

	if self.clickTime ~= nil and getTime() - self.clickTime < 0.5 then
		return;
	end
	self.clickTime = getTime();

	return true;
end

function Lua_JumpHappyPanel:onClickTipSp()
	local tipData = { des = 791001, posX = 187, posY = -271 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_JumpHappyPanel:onClickOperateSp()
	if self:checkValidActivity() then
		Lua_WindowUtil.openWin("Lua_JumpHappyExplainWindow", Lua_WinParam.ACTION_OPEN);
	end
end

function Lua_JumpHappyPanel:onClickTaskSpSp()
	if self:checkValidActivity() then
		Lua_WindowUtil.openWin("Lua_JumpHappyTaskWindow", Lua_WinParam.ACTION_OPEN);
	end
end

function Lua_JumpHappyPanel:onClickRankSpSp()
	if self:checkValidActivity() then
		DataCenter.funcPathUtil:gotoFunction(1187);
	end
end

function Lua_JumpHappyPanel:starTimer()
	if self.sTime ~= false then
		self.sTime = true;
		self:addTimer("Lua_JumpHappyPanel", 1, self, self.onTimer);
	end
end

function Lua_JumpHappyPanel:onTimer()
	local residueTime = self.actEndTime - DataCenter.roleData.serverTime;
	if residueTime > 0 then
		self.timeTxt.text = LanUtil.formateStr(791002, Lua_TimeTransform.transSeconds16(residueTime));
	else
		self:endTimer();
		self.timeTxt.text = nil;
	end
end

function Lua_JumpHappyPanel:endTimer()
	if self.sTime == true then
		self.sTime = false;
		self:removeTimer(self, self.onTimer);
	end
end

function Lua_JumpHappyPanel:updatePanel()
	local levelInfo = DataCenter.jumpingHappyData.levelInfo;
	self.levelList:setArrayData(levelInfo);

	local count = DataCenter.jumpingHappyData.residueCount or 0;
	self.countTxt.text = LanUtil.formateStr(791003, count);
end

function Lua_JumpHappyPanel:showRewardWin(item)
	if item == nil then
		return;
	end

	local pos = item.content.transform.position;
	pos = self.content.transform:InverseTransformPoint(pos);
	Lua_WindowUtil.openWin("Lua_JumpHappyProgressRewardWindow", Lua_WinParam.ACTION_OPEN, {item_list = item.data.item_list, posX = pos.x, posY = pos.y});
end













---------关卡item-----------
Lua_JumpHappyLevelItem = class("Lua_JumpHappyLevelItem", Lua_ListCell);
function Lua_JumpHappyLevelItem:ctor(p)
	self:superCall("ctor", p, "JumpHappyLevelItem_skin");
end

function Lua_JumpHappyLevelItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rectW = 387;
	self.rectH = 98;
	self.subRectW = self.rectW;
	self.subRectH = self.rectH;
	self.subMinPos = -(self.subRectW - self.rectW) / 2;
	self.subMaxPox = -self.subMinPos;
	self.spaceW = 69;

	self.scrollContainer = UICreate.createScrollContainer(self.openObj, -10, 5, self.rectW, self.rectH);
	self.scrollContainer.horizontal = true;
	self.scrollContainer.vertical = false;
	self.scrollContainer.movementTypeValue = 1;
	self.scrollContainer.elasticity = 0.3;
	self.scrollContainer.inertia = true;
	self.scrollContainer.siblingIndex = 8;
	-- self.scrollContainer.anchorValue = 7;
	self.scrollContainer:setScrollAnchor(0.5, 0.5, 0.5, 0.5);
	self.scrollContainer:setScrollPivot(4);
	self.scrollContainer:addRectMask2D();
	self.scrollContainer:addMousDownFuntion(self, self.onMouseDownFun);
	self.scrollContainer:addMouseUpFuntion(self, self.onMouseUpFun);
	-- self.scrollContainer:setLocation(52, 506.5, 0);

	self.sub = self.scrollContainer.scrollContent;
	self.scoreBar = UICreate.createProgressBar(self.sub, "activities_atlas_4", "xui_bfbz_Progress _01_b",
		"activities_atlas_4", "xui_bfbz_Progress _01_f", -self.rectW / 2, -8, self.rectW, 20);
	self.scoreBar.pivot = Lua_WindowUtil.getPivot(3);
	self.scoreBar:setBarOffset(4, 2);
	self.scoreBar:setBarPosOffset(0, -1);

	self.stageArr = Array();

	self.challengeBtn:addClickFuntion(self, self.onClickChallengeBtn);
end

function Lua_JumpHappyLevelItem:setData(data)
	self.data = data;
    if data == nil then
    	self.bOpened = false;
		self:endTimer();
		return;
	end

	self:updateOpenAlpha();
	self.levelTxt.text = LanUtil.formateStr(791004, self.data.type_id);
	self.lockIcon:setEnable(self.bOpened ~= true);

	if not self.bOpened then
		self:onTimer();
		self:starTimer();
	else
		self:endTimer();
		self.openTxt.text = nil;

		self:updateReward(self.data);
	end
	self.openObj:SetActive(self.bOpened);
end

function Lua_JumpHappyLevelItem:updateReward(msg)
	local rewardList = msg.process_reward;
	local dataLen = #rewardList;
	local barWidth = dataLen * self.spaceW;
	self.subRectW = barWidth + 38; -- 38 item的宽/2
	local halfSubRectW = self.subRectW / 2;
	if not self.isFirstIn then
		self.isFirstIn = true;
		self.subMinPos = -(self.subRectW - self.rectW) / 2;
		self.subMaxPox = -self.subMinPos;
		-- self.scrollContainer.horizontal = dataLen > 5;
		-- self.scrollContainer:setScrollSize(self.subRectW, self.subRectH);
		-- self.scrollContainer:setScrollPosition(self.subMaxPox, 0, 0);

		self.scoreBar:SetDimensions(barWidth, 18);
		self.scoreBar:setLocation(-halfSubRectW, -8, 0);
	end

	local score = msg.top_score;
	self.scoreTxt.text = score;

	local stageInfo = rewardList[dataLen];
	local maxValue = tonumber(tostring(stageInfo.cond_int));
	local value = 0;
	local index = 1;
	if score >= maxValue then
		value = maxValue;
	else
		for i = 1, dataLen do
			stageInfo = rewardList[i];
			if tonumber(tostring(stageInfo.cond_int)) >= score then
				index = i;
				break;
			end
		end

		local num;
		local stepSpace = maxValue / dataLen;
		stageInfo = rewardList[index];
		value = value + stepSpace * (index - 1);
		if index <= 1 then
			num = stepSpace / tonumber(tostring(stageInfo.cond_int));
			value = value + score * num;
		else
			local preVo = rewardList[index - 1];
			num = stepSpace / (tonumber(tostring(stageInfo.cond_int)) - tonumber(tostring(preVo.cond_int)));
			value = value + (score - tonumber(tostring(preVo.cond_int))) * num;
		end
	end
	self.scoreBar:setMaxValue(maxValue);
	self.scoreBar:setValue(value);
	
	local hasLen = self.stageArr:getSize();
	local maxLen = dataLen > hasLen and dataLen or hasLen;
	local item;
	local index = 1;
	for i = 1, maxLen do
		item = self.stageArr[i];
		if i > dataLen then
			if item ~= nil then
				item:setEnable(false);
			end
		else
			stageInfo = rewardList[i];
			if stageInfo.state == 2 then index = i end
			if item == nil then
				item = Lua_JumpHappyLevelSubItem.new(self.sub);
				item.contentName = "Lua_JumpHappyLevelSubItem" .. i;
				item:setRectSize(45, 45);
				self.stageArr:add(item);
			end
			item:setEnable(true);
			item:setLocation(i * self.spaceW - halfSubRectW, 14, 0);
			item:setData(stageInfo, i == dataLen);
		end
	end
	-- self.scoreBar.siblingIndex = self.stageArr[dataLen].siblingIndex + 1;
	-- self:moveToIndex(dataLen > 5 and index or 5);
	-- self:moveToIndex(index);
end

function Lua_JumpHappyLevelItem:updateOpenAlpha()
	self.bOpened = self.data.open_time <= 0;

	local alphaVal;
	if self.bOpened then
		alphaVal = 1;
	else
		alphaVal = 0.6;
	end

	self.lockIcon:setAlpha(alphaVal);
	self.levelBg:setAlpha(alphaVal);

	self.backLockBg:setEnable(self.bOpened == false);
end

function Lua_JumpHappyLevelItem:dispose()
	self.sub = nil;
	self.data = nil;
	self:endTimer();
	if self.scrollContainer then
		self.scrollContainer:dispose();
		self.scrollContainer = nil;
	end
	if self.scoreBar then
		self.scoreBar:dispose();
		self.scoreBar = nil;
	end
    self:superCall("dispose");
end

function Lua_JumpHappyLevelItem:onClickChallengeBtn()
	local activity_id = DataCenter.jumpingHappyData.activity_id;
	local actVo = DataCenter.backstageActData:getActVoByIdx(activity_id);
	if DataCenter.backstageActData:checkActIsEnd(actVo) then
		return;
	end

	if self.data == nil or self.bOpened ~= true then
		return;
	end

	if self.clickTime ~= nil and getTime() - self.clickTime < 0.5 then
		return;
	end
	self.clickTime = getTime();

	local hasSaveGameInfo = self.data.game_info and #self.data.game_info > 0;
	local residueCount = DataCenter.jumpingHappyData.residueCount;
	if residueCount <= 0 and hasSaveGameInfo ~= true then
		Lua_WindowUtil.openWin("Lua_JumpHappyShoppingWindow", Lua_WinParam.ACTION_OPEN);
		return;
	end

	if hasSaveGameInfo then
		DataCenter.jumpingHappyData.curJumpNum = self.data.jump_num;
		Lua_WindowUtil.openWin("Lua_JumpHappyPlayWindow", Lua_WinParam.ACTION_OPEN, self.data);
		return;
	end

	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sJumpingHappyScore(activity_id, self.data.type_id, 1);
end

function Lua_JumpHappyLevelItem:starTimer()
	if self.sTime ~= false then
		self.sTime = true;
		self:addTimer("Lua_JumpHappyLevelItem", 1, self, self.onTimer);
	end
end

function Lua_JumpHappyLevelItem:onTimer()
	self.data.open_time = self.data.open_time - 1;
	if self.data.open_time > 0 then
		self.openTxt.text = LanUtil.formateStr(791005, Lua_TimeTransform.transSeconds18(self.data.open_time));
	else
		self:endTimer(true);
		self.openTxt.text = nil;
	end
end

function Lua_JumpHappyLevelItem:endTimer(bCheck)
	if self.sTime == true then
		self.sTime = false;
		self:removeTimer(self, self.onTimer);

		if bCheck then
			self:updateOpenAlpha();
		end
	end
end

function Lua_JumpHappyLevelItem:onMouseDownFun()
	self.startMouseX = CommonUtil.mousePositionX;
	self.startMouseY = CommonUtil.mousePositionY;
	self.startClickTime = getTime();
end

function Lua_JumpHappyLevelItem:onMouseUpFun()
	local dx = CommonUtil.mousePositionX - self.startMouseX;
	local dy = CommonUtil.mousePositionY - self.startMouseY;
	if getTime() - self.startClickTime <= 0.3 and Mathf.Abs(dx) + Mathf.Abs(dy) < 4 then
		self:checkPressItem();
	end
end

function Lua_JumpHappyLevelItem:checkPressItem()
	local winPos = LuaUtil.getTouchPosInverseObj(self.sub);
	local len = self.stageArr:getSize();
	for i = 1, len do
		if self.stageArr and self.stageArr[i] then
			if self.stageArr[i].isActive and self.stageArr[i]:checkInBound(winPos.x, winPos.y) then
				self.stageArr[i]:onPressClick();
			end
		end
	end
end
















Lua_JumpHappyLevelSubItem = class("Lua_JumpHappyLevelSubItem", Lua_DisplayObject);
function Lua_JumpHappyLevelSubItem:ctor(p)
	self:superCall("ctor", p, "JumpHappyLevelSubItem_skin");
end

function Lua_JumpHappyLevelSubItem:buildShowItem()
	self:superCall("buildShowItem");
	-- self.stateIcon:addClickFuntion(self, self.onPressClick);
end

function Lua_JumpHappyLevelSubItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	local itemInfo = self.data.item_list[1];
	if self.tvo == nil then
		self.tvo = Lua_ToolVo.createToolVo(itemInfo.id);
	end
	self.tvo:fromServer(itemInfo);

	local total_score = tonumber(self.data.cond_int);
	self.scoreTxt.text = total_score;
	self:updateRewardShowState();
	self:showRedDot(self.data.state == 1);
end

function Lua_JumpHappyLevelSubItem:updateRewardShowState()
	local bReceived;
	local stateIconSp;
	local pointIconSp;
	local width, height;
	if self.data.state == 0 then
		stateIconSp = "xui_bfbz_widget_7";
		pointIconSp = "xui_bfbz_widget_10";
		width, height = 47, 43;
	elseif self.data.state == 1 then
		stateIconSp = "xui_bfbz_widget_9";
		pointIconSp = "xui_bfbz_widget_11";
		width, height = 73, 71;
	elseif self.data.state == 2 then
		bReceived = true;
		stateIconSp = "xui_bfbz_widget_8";
		pointIconSp = "xui_bfbz_widget_11";
		width, height = 47, 43;
	end

	self.stateIcon:setAltas("activities_atlas_4", stateIconSp);
	self.stateIcon:SetDimensions(width, height);
	self.pointIcon:setAltas("activities_atlas_4", pointIconSp);
	self.receivedSp:setEnable(bReceived == true);
end

function Lua_JumpHappyLevelSubItem:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:createRedPointEff();
			self.redPoint:setLocation(20, 14, 0);
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_JumpHappyLevelSubItem:onPressClick(go)
	local activity_id = DataCenter.jumpingHappyData.activity_id;
	local actVo = DataCenter.backstageActData:getActVoByIdx(activity_id);
	if DataCenter.backstageActData:checkActIsEnd(actVo) then
		return;
	end

	if self.data == nil then
		return;
	end

	if self.clickTime ~= nil and getTime() - self.clickTime < 0.5 then
		return;
	end
	self.clickTime = getTime();


	if self.data.state == 1 then
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sJumpingHappyStageReward(activity_id, self.data.id);
	else
		Lua_MsgUtil.callFunc("SHOW_JUMPHAPPY_REWARD_INFO", self);
	end
end

function Lua_JumpHappyLevelSubItem:checkInBound(posX, posY)
	local minX = self.centerPosX - self.w / 2;
	local maxX = self.centerPosX + self.w / 2;
	local minY = self.centerPosY - self.h / 2;
	local maxY = self.centerPosY + self.h / 2;
	if posX >= minX and posX <= maxX and posY >= minY and posY <= maxY then
		return true;
	end
	return false
end

function Lua_JumpHappyLevelSubItem:dispose()
	self.data = nil;
	self.tvo = nil;
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self:superCall("dispose");
end