-- 跳跳乐
Lua_JumpHappyPlayWindow = class("Lua_JumpHappyPlayWindow", Lua_Window);
Lua_JumpHappyPlayWindow.Action_Idle = 0;-- 待机
Lua_JumpHappyPlayWindow.Action_Jump_Pre = 100011; -- 下蹲
Lua_JumpHappyPlayWindow.Action_Jump_Ready = 100012; -- 蓄力
Lua_JumpHappyPlayWindow.Action_Jump_Up = 100013;-- 起跳
Lua_JumpHappyPlayWindow.Action_Jump_Sky = 100014; -- 空中循环
Lua_JumpHappyPlayWindow.Action_Jump_Down = 100015; -- 下落
Lua_JumpHappyPlayWindow.Action_Jump_Success = 100017; -- 下落成功，下落缓冲
Lua_JumpHappyPlayWindow.Action_Jump_Fail = 100016; --下落死亡

Lua_JumpHappyPlayWindow.Action_Pre_To_Ready = 100020; -- 下蹲切蓄力
Lua_JumpHappyPlayWindow.Action_Pre_To_Up = 100021; -- 下蹲切起跳
Lua_JumpHappyPlayWindow.Action_Ready_To_Up = 100022; -- 蓄力切起跳
Lua_JumpHappyPlayWindow.Action_Up_To_Sky = 100023; -- 起跳切空中
Lua_JumpHappyPlayWindow.Action_Up_To_Down = 100024; -- 起跳切下落
Lua_JumpHappyPlayWindow.Action_Sky_To_Down = 100025; -- 空中切下落
Lua_JumpHappyPlayWindow.Action_Down_To_Success = 100026; -- 下落切成功
Lua_JumpHappyPlayWindow.Action_Down_To_Fail = 100027; -- 下落切失败

Lua_JumpHappyPlayWindow.Action_Idle_Time = 0.0;-- 待机时长
Lua_JumpHappyPlayWindow.Action_Jump_Pre_Time = DataCenter.jumpingHappyData.animation_time_pre; -- 下蹲时长
Lua_JumpHappyPlayWindow.Action_Jump_Ready_Time = 0.0; -- 蓄力时长
Lua_JumpHappyPlayWindow.Action_Jump_Up_Time = DataCenter.jumpingHappyData.animation_time_up; -- 起跳时长
Lua_JumpHappyPlayWindow.Action_Jump_Sky_Time = 0.0; -- 空中循环时长
Lua_JumpHappyPlayWindow.Action_Jump_Sky_Origin_Time = DataCenter.jumpingHappyData.animation_time_sky; -- 原地跳空中循环时长
Lua_JumpHappyPlayWindow.Action_Jump_Down_Time = DataCenter.jumpingHappyData.animation_time_down; -- 下落时长
Lua_JumpHappyPlayWindow.Action_Jump_Success_Time = DataCenter.jumpingHappyData.animation_time_success; -- 下落成功，下落缓冲时长
Lua_JumpHappyPlayWindow.Action_Jump_Fail_Time = DataCenter.jumpingHappyData.animation_time_fail; --下落死亡时长

Lua_JumpHappyPlayWindow.Sound_Ready = "ttl_charge_audio"; --跳跳乐-蓄力音效
Lua_JumpHappyPlayWindow.Sound_Ready_Loop = "ttl_chargeloop_audio"; --跳跳乐-蓄力循环
Lua_JumpHappyPlayWindow.Sound_Jump = "ttl_jump_audio"; --跳跳乐-起跳音效
Lua_JumpHappyPlayWindow.Sound_Center = "ttl_centre_audio"; --跳跳乐-落点

Lua_JumpHappyPlayWindow.Sound_Time_Ready = 2.8; -- 蓄力音效时长

function Lua_JumpHappyPlayWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.windowName = "Lua_JumpHappyPlayWindow";
	self.skinName = "JumpHappyPlayWindow_skin";
	self.isFullSizeWin = true;
	self.showBlackMask = true;
	self.showWinBg = true;
	self.winBgPath = "/images/activities/xui_ttl_bg_3.jpg";

    self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
end

function Lua_JumpHappyPlayWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.angle = 60;
	self.curIndex = 0;
	self.maxItemCount = 10;
	
	self._avoidTime = DataCenter.jumpingHappyData.avoid_num or 10; -- 防误触按压时间（帧）
	self._routeTimeRate = DataCenter.jumpingHappyData.jump_time_ratio or 0.5; -- 跳跃轨迹运动时长相对按压时长比例
	self._spd = DataCenter.jumpingHappyData.model_speed or 350; -- 原地跳高度
	self._jumpOrginY = DataCenter.jumpingHappyData.origin_height or 350; -- 原地跳高度
	-- 按压时长限制
	local press_time_limit = DataCenter.jumpingHappyData.press_time_limit;
	self._maxDownTime = press_time_limit and press_time_limit[1] or 10;
	self._maxRouteTime = press_time_limit and press_time_limit[2] or 18;
	-- 控制点控制系数
	local control_point = DataCenter.jumpingHappyData.control_point;
	self._controllX = control_point and control_point[1] or 0.5;
	self._controllY = control_point and control_point[2] or 1.15;

	self.pressTime = 0.0;
	self.maxPressTime = DataCenter.jumpingHappyData.maxPressTime;
	self.perPressDistance = DataCenter.jumpingHappyData.perJumpDistance;
	self.pressDetalTime = DataCenter.jumpingHappyData.pressTime;

	self.maxPressItemCount = 10;
	self.checkSercerTime = 0.06; -- 检验服务端数据间隔时间
	self.checkServerDataCount = 6; -- 获取服务端数据检验次数
	self.showCenterEffTime = 1; -- 中心特效显示时间

	self.curArriveBlockIndex = 0; -- 当前所处的方块index
	self.lastArriveBlockIndex = 1;
	self.curArriveBlockEdgeDistance = 0; -- 当前模型所处的位置距方块边缘的距离

	self.arrivedItemPosX =  214;
	self.arrivedItemPosY = -206;

	self.scoreNum = Lua_NumberImage.new(self.content);
	self.scoreNum:setRectAnchor(1);
	self.scoreNum:setLocation(0, -152, 0);
	-- self.scoreNum.pivot = 1;
	self.scoreNum.numOffsetX = -2;
	self.scoreNum.numAtlas = "number";
	self.scoreNum.preStr = "xui_ttl_number_";
	self:showMySelfScore(0);

	self.pointObj:SetActive(false);
	self:showModelItem(false);
	self:createJumpClickMask();
	self:createBackBtn(58, 86.5, "common_altas_3", "xui_common_button_031");
	DataCenter.jumpingHappyData.bPlayJumping = true;
end

function Lua_JumpHappyPlayWindow:showWin(param)
	self:superCall("showWin", param);

	if type(param) ~= "table" then
		return;
	end

	if param.act_index ~= nil then
		self.levelId = param.type_id;
		self:restartJumping();
	else
		self.levelId = param.type_id;
		self:showMySelfScore(param.last_score);
		self:resetLastRecordLevelInfo();
	end

	self.layerText.text = LanUtil.formateStr(791021, self.levelId);
	self:updatePlayInfo();
end

function Lua_JumpHappyPlayWindow:updatePlayInfo()
	local info = DataCenter.jumpingHappyData:getLevelInfoById(self.levelId);
	local score = 0;
	local nameStr;
	if info == nil then
		nameStr = LanUtil.getValue(791022);
	else
		score = info.top_player.value;
		nameStr = info.top_player.player_show.name;
		nameStr = strIsNullOrEmpty(nameStr) and LanUtil.getValue(791022) or nameStr;
	end

	self.scoreNumTxt.text = LanUtil.formateStr(791023, score);
	self.playNameTxt.text = LanUtil.formateStr(791024, nameStr);
end

function Lua_JumpHappyPlayWindow:dispose()
	DataCenter.jumpingHappyData.curBDeath = nil;
	DataCenter.jumpingHappyData.curJumpNum = nil;
	DataCenter.jumpingHappyData.bCheckServerData = false;
	TweenUtil.getInstance():stop(self.modelItem.mainContent);
	Lua_CommonUtil.removeTimer(self, self.startGetServerData);
	self:stopSound(Lua_JumpHappyPlayWindow.Sound_Ready);
	self:stopSound(Lua_JumpHappyPlayWindow.Sound_Jump);
	self:stopSound(Lua_JumpHappyPlayWindow.Sound_Center);
	self:stopSound(Lua_JumpHappyPlayWindow.Sound_Ready_Loop);

	self:endModelMove();
	self:endMoveItemObj();
	self:endCalPressTime();
	self:endGetServerData();
	self:endCheckCenterEff();
	self.targetJumpPos = nil;
	self.modelItemVec = nil;
	self.curModelPos = nil;
	self.cur_blockDir = nil;
	self._itemObjTf = nil;
	self.jump_vec = nil;
	if self.jumpItems then
		local item;
		for i = 1, #self.jumpItems do
			item = self.jumpItems[i];
			if item then
				item:dispose();
				item = nil;
			end
		end
		self.jumpItems = nil;
	end
	if self._modelItem then
		self._modelItem:dispose();
		self._modelItem = nil;
	end
	if self.bezierLinePoints then
		for i = 1, #self.bezierLinePoints do
			self.bezierLinePoints[i]:dispose();
			self.bezierLinePoints[i] = nil;
		end
		self.bezierLinePoints = nil;
	end
	if self.scoreNum then
		self.scoreNum:dispose();
		self.scoreNum = nil;
	end
	if self.centerEffDic then
		for k, eff in pairs(self.centerEffDic) do
			if eff then
				eff:dispose();
				eff = nil;
			end
		end
		self.centerEffDic = nil;
	end
	if self.idleCenterEffArr then
		self.idleCenterEffArr:dispose();
		self.idleCenterEffArr = nil;
	end
	if self.centerEffArr then
		self.centerEffArr:dispose();
		self.centerEffArr = nil;
	end
	if self._modelShadowSp then
		self._modelShadowSp:dispose();
		self._modelShadowSp = nil;
	end
	self:superCall("dispose");
end

function Lua_JumpHappyPlayWindow:createJumpClickMask()
	if self.jumpClickMask == nil then
		self.jumpClickMask = UICreate.createUIAtlasImage(self.content, "common_altas_1", self.maskSprite, 0, 0, 2048, 2048);
		self.jumpClickMask.name = "jumpClickMask";
		self.jumpClickMask.siblingIndex = self.itemObj.transform:GetSiblingIndex() + 1;
		self.jumpClickMask.alpha = 0.01;
		self.jumpClickMask:addMouseUpFuntion(self, self.onMouseUpHandle);
		self.jumpClickMask:addMousDownFuntion(self, self.onMouseDownHandle);
	end
end

function Lua_JumpHappyPlayWindow:onMouseUpHandle()
	self.nextAccumulatePower = false;

	if self.startClickDown ~= true then
		return;
	end
	self.startClickDown = false;

	if self:checkShowAssistLine() ~= true then
		self:calJumpControllPos(self.pressTime);
	end

	self.pointObj:SetActive(false);
	self:endCalPressTime();

	self.pressTime = getTime() - self.startMouseDownTime; -- 按压时长

	self.bShowResult = false;
	self:playingJump(self.pressTime);
end

function Lua_JumpHappyPlayWindow:checkValidPress()
	local activity_id = DataCenter.jumpingHappyData.activity_id;
	local actVo = DataCenter.backstageActData:getActVoByIdx(activity_id);
	if DataCenter.backstageActData:checkActIsEnd(actVo) then
		self:hide();
		return;
	end

	if DataCenter.jumpingHappyData.curBDeath then
		return;
	end

	-- self.modelItem:updateAddScore(nil);
	if self._bModelMove or self.bSuccess ~= nil then
		local bShow = DataCenter.jumpingHappyData.bTest;
		if bShow then
			OperateAlert.showLangValue(791025);
		end
		return;
	end

	if self.bCreatePointItem then
		if self.obtainServerDataCount < self.checkServerDataCount then
			OperateAlert.showLangValue(791026);
		else
			OperateAlert.showLangValue(791027);
		end
		return;
	end

	if self._bMoveItemObj then
		OperateAlert.showLangValue(791028);
		return;
	end

	return true;
end

function Lua_JumpHappyPlayWindow:onMouseDownHandle()
	if self._bModelMove or self.bSuccess ~= nil then -- 模型移动中按压蓄力
		self.nextAccumulatePower = true;
	end

	if self:checkValidPress() ~= true then
		return;
	end

	self:startAccumulatePower();
end

function Lua_JumpHappyPlayWindow:startAccumulatePower()
	if self.curModelPos == nil then
		self.curModelPos = Vector2(self.modelItem.x, self.modelItem.y);
	else
		self.curModelPos:Set(self.modelItem.x, self.modelItem.y);
	end

	-- self.modelItem:showCenterDisplay(false);
	self.startClickDown = true;
	if self:checkShowAssistLine() then
		self.pointObj:SetActive(true);
	end

	self:startCalPressTime();
end

function Lua_JumpHappyPlayWindow:checkNextAccumulatePower()
	local curBDeath = DataCenter.jumpingHappyData.curBDeath;
	if curBDeath then
		return;
	end

	if self.bSuccess == false then
		return;
	end

	if self.nextAccumulatePower then
		self.bSuccess = nil;
		self:endModelMove(); 
		self:startAccumulatePower();
	end
end

function Lua_JumpHappyPlayWindow:sendServer(state, distance, edgeDistance, detail_x, detail_y, blockIndex)
	state = state or 2;
	local activity_id = DataCenter.jumpingHappyData.activity_id;
	local actVo = DataCenter.backstageActData:getActVoByIdx(activity_id);
	if DataCenter.backstageActData:checkActIsEnd(actVo) then
		self:hide();
		return;
	end

	if self.levelId == nil then
		return;
	end

	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sJumpingHappyScore(activity_id, self.levelId, state, distance, 
		edgeDistance, detail_x, detail_y, blockIndex);
end

function Lua_JumpHappyPlayWindow:checkBlockItemBound(blockIndex)
	local item = self:getJumpItemByIndex(blockIndex);
	local half_length = item.half_length;

	local intervalX, intervalY = self:calIntervalXY(item.x, item.y, self.modelItem.x, self.modelItem.y);
	local _, _, distance = self:calNormalizedVec(intervalX, intervalY);
	return half_length >= distance;
end

function Lua_JumpHappyPlayWindow:calculateModelJumpData()
	local distance_twoVec = self:calJumpDistance(); 
	local distance_oneVec = self:calJumpDistanceInOneVec();
	-- self:updateTestLine();
	
	local next_item = self:getJumpItemByIndex(self.curIndex);
	local items_distance = next_item.distance;
	local item_total_length = next_item.total_length;

	local edgeDistance = self.curArriveBlockEdgeDistance;

	local bShow = DataCenter.jumpingHappyData.bTest;
	self.bShowResult = true;
	if self.curArriveBlockEdgeDistance >= distance_oneVec then
		self.bSuccess = true;
		self:calBlockEdgeDistance(self.targetJumpPos.x, self.targetJumpPos.y); 
		if bShow then
			OperateAlert.show("原方块");
		end
	else
		self.curArriveBlockIndex = self.curArriveBlockIndex + 1;
		if (distance_oneVec > self.curArriveBlockEdgeDistance and distance_oneVec < self.curArriveBlockEdgeDistance + items_distance) or
			distance_oneVec > self.curArriveBlockEdgeDistance + item_total_length + items_distance then
				self.bSuccess = false;
				if bShow then
					OperateAlert.show("失败");
				end
		else
			self.bCreatePointItem = true;
			self.bSuccess = true;
			if bShow then
				OperateAlert.show("成功");
			end
		end
	end

	local item = self:getJumpItemByIndex(self.curArriveBlockIndex);
	local detail_x, detail_y = self:calIntervalXY(item.x, item.y, self.targetJumpPos.x, self.targetJumpPos.y);
	self:sendServer(2, distance_oneVec, edgeDistance, detail_x, detail_y, self.curArriveBlockIndex); 
end

function Lua_JumpHappyPlayWindow:playingJump(dt)
	if dt == nil then
		return;
	end

	if self.actionArr == nil then
		self.actionArr = Array();
	else
		self.actionArr:clear();
	end

	if self.actionTimeArr == nil then
		self.actionTimeArr = Array();
	else
		self.actionTimeArr:clear();
	end

	local routeTime = 0; -- 路径过程时长
	local actionTime = 0; -- 动作时长
	local normalTime = Lua_JumpHappyPlayWindow.Action_Jump_Up_Time + Lua_JumpHappyPlayWindow.Action_Jump_Down_Time;  
	if dt <= self._avoidTime / 30 then
		self.bSuccess = true;
		actionTime = normalTime + Lua_JumpHappyPlayWindow.Action_Jump_Success_Time;
		routeTime = normalTime + Lua_JumpHappyPlayWindow.Action_Jump_Sky_Origin_Time;

		self.jumpControllPos:Set(self.curModelPos.x, self.curModelPos.y + self._jumpOrginY);
		self.targetJumpPos:Set(self.curModelPos.x, self.curModelPos.y);

		if self.lastModelAct == Lua_JumpHappyPlayWindow.Action_Pre_To_Ready then
			self.actionArr:add(Lua_JumpHappyPlayWindow.Action_Ready_To_Up);
		else
			self.actionArr:add(Lua_JumpHappyPlayWindow.Action_Pre_To_Up);
		end
		self.actionTimeArr:add(Lua_JumpHappyPlayWindow.Action_Jump_Up_Time);

		self.actionArr:add(Lua_JumpHappyPlayWindow.Action_Up_To_Sky);
		self.actionTimeArr:add(Lua_JumpHappyPlayWindow.Action_Jump_Sky_Origin_Time);

		self.actionArr:add(Lua_JumpHappyPlayWindow.Action_Sky_To_Down);
		self.actionTimeArr:add(Lua_JumpHappyPlayWindow.Action_Jump_Down_Time);

		self.actionArr:add(Lua_JumpHappyPlayWindow.Action_Down_To_Success);
		self.actionTimeArr:add(Lua_JumpHappyPlayWindow.Action_Jump_Success_Time);
	else 
		-- 运动轨迹时长
		if dt > self._maxDownTime / 30 then
			routeTime = self._maxRouteTime / 30;
		else
			routeTime = dt * self._routeTimeRate;
		end
		if routeTime < normalTime then
			routeTime = normalTime;
		end

		self:calculateModelJumpData();

		if self.lastModelAct == Lua_JumpHappyPlayWindow.Action_Pre_To_Ready then
			self.actionArr:add(Lua_JumpHappyPlayWindow.Action_Ready_To_Up);
		else
			self.actionArr:add(Lua_JumpHappyPlayWindow.Action_Pre_To_Up);
		end
		self.actionTimeArr:add(Lua_JumpHappyPlayWindow.Action_Jump_Up_Time);

		local skyTime = routeTime - normalTime;
		if skyTime > 0 then -- 空中循环
			self.actionArr:add(Lua_JumpHappyPlayWindow.Action_Up_To_Sky);
			self.actionTimeArr:add(skyTime);

			self.actionArr:add(Lua_JumpHappyPlayWindow.Action_Sky_To_Down);
			self.actionTimeArr:add(Lua_JumpHappyPlayWindow.Action_Jump_Down_Time);
		else
			self.actionArr:add(Lua_JumpHappyPlayWindow.Action_Up_To_Down);
			self.actionTimeArr:add(Lua_JumpHappyPlayWindow.Action_Jump_Down_Time);
		end

		if self.bSuccess then -- 成功
			self.actionArr:add(Lua_JumpHappyPlayWindow.Action_Down_To_Success);
			self.actionTimeArr:add(Lua_JumpHappyPlayWindow.Action_Jump_Success_Time);
		else -- 失败	
			self.actionArr:add(Lua_JumpHappyPlayWindow.Action_Down_To_Fail);
			self.actionTimeArr:add(Lua_JumpHappyPlayWindow.Action_Jump_Fail_Time);
		end
	end

	self.jumpRouteTime = routeTime;
	self.lastPlayingJumpTime = getTime();
	self.startPlayingJumpTime = getTime();
	self.modelItem:setAction(self.actionArr[1], -1);

	self:startModelMove();
end

function Lua_JumpHappyPlayWindow:getJumpItemByIndex(index)
	if self.jumpItems == nil then
		self.jumpItems = {};
	end

	local targetIndex = index % self.maxItemCount;
	targetIndex = targetIndex == 0 and self.maxItemCount or targetIndex;

	local item = self.jumpItems[targetIndex];
	if item == nil then
		item = Lua_JumpHappyPlayItem.new(self.itemObj);
		item:setSiblingIndex(0);
		self.jumpItems[targetIndex] = item;
	end
	item.content.name = "Lua_JumpHappyPlayItem"..index;
	return item;
end

function Lua_JumpHappyPlayWindow:updateNextItem()
	local lastIndex = self.curIndex;
	self.curIndex = self.curIndex + 1;
	local data = self:updateTemporaryData(self.curIndex);
	local next_item = self:getJumpItemByIndex(self.curIndex); 
	next_item:setSiblingIndex(0);
	next_item:setData(data);
	local next_half_length = next_item.half_length;
	local dir = next_item.direction;
	local distance = next_item.distance;
	self.bLeft = dir == 1;

	local cur_item = self:getJumpItemByIndex(lastIndex);
	local cur_half_length = cur_item.half_length;
	local cur_posX, cur_posY = cur_item.x, cur_item.y;
	local cur_bLeft = cur_item.direction == 1;
	distance = distance + cur_half_length + next_half_length;

	local next_posX, next_posY = self:calculatePos(cur_posX, cur_posY, distance, self.bLeft, 1);
	next_item:setLocation(next_posX, next_posY);

	self.modelItem:setModelEffDir(self.bLeft);

	lastIndex = lastIndex - 1;
	local last_item = self:getJumpItemByIndex(lastIndex);
	local last_posX, last_posY = last_item.x, last_item.y;
	-- local arr_pos_x = self.bLeft and self.arrivedItemPosX or -self.arrivedItemPosX;
	local intervalX, intervalY = last_posX - cur_posX, last_posY - cur_posY;
	if self.bLeft ~= cur_bLeft then
		local param = self.bLeft and 2 * self.arrivedItemPosX or - 2 * self.arrivedItemPosX;
		intervalX = intervalX + param;
	end

	self:recordItemObjTargetPos(intervalX, intervalY);
	self:calLastBlockItemDir(); 
	self:calBlockEdgeDistance(self.modelItem.x, self.modelItem.y); 
	self:startMoveItemObj();
end

function Lua_JumpHappyPlayWindow:recordItemObjTargetPos(dis_x, dis_y)
	self.tar_moving_item_dis_x = dis_x or 0;
	self.tar_moving_item_dis_y = dis_y or 0;
	self.cur_moving_item_dis_x = 0;
	self.cur_moving_item_dis_y = 0;

	self.totalDistance_x = self.tar_moving_item_dis_x;
	self.totalDistance_y = self.tar_moving_item_dis_y;
end

function Lua_JumpHappyPlayWindow:startMoveItemObj()
	if self._bMoveItemObj ~= true then
		self._bMoveItemObj = true;
		self:addTimer("Lua_JumpHappyPlayWindow_MoveItemObj", 0.02, self, self.onMoveItemObj, nil, -1, true);
		self:onMoveItemObj();
	end
end

function Lua_JumpHappyPlayWindow:onMoveItemObj()
	local detal_x = Mathf.Abs(self.tar_moving_item_dis_x - self.cur_moving_item_dis_x);
	local detal_y = Mathf.Abs(self.tar_moving_item_dis_y - self.cur_moving_item_dis_y);
	if detal_x > 6 or detal_y > 6 then
		local posX = self.totalDistance_x / 10;
		local posY = self.totalDistance_y / 10;

		self.cur_moving_item_dis_x = detal_x > 6 and self.cur_moving_item_dis_x + posX or self.tar_moving_item_dis_x;
		self.cur_moving_item_dis_y = detal_y > 6 and self.cur_moving_item_dis_y + posY or self.tar_moving_item_dis_y;
		self:setItemObjPos(posX, posY);
	else
		self.cur_moving_item_dis_x = self.tar_moving_item_dis_x;
		self.cur_moving_item_dis_y = self.tar_moving_item_dis_y;
		self:endMoveItemObj();
	end
end

function Lua_JumpHappyPlayWindow:endMoveItemObj()
	if self._bMoveItemObj then
		self._bMoveItemObj = false;
		self:removeTimer(self, self.onMoveItemObj);

		self:checkNextAccumulatePower();
	end
end

function Lua_JumpHappyPlayWindow:setItemObjPos(intervalX, intervalY)
	local posX = self.itemObjTf.localPosition.x + intervalX;
	local posY = self.itemObjTf.localPosition.y + intervalY;

	LuaUtil.setObjPos(self.itemObj, posX, posY, 0);
end

function Lua_JumpHappyPlayWindow.Get:itemObjTf()
	if self._itemObjTf == nil then
		self._itemObjTf = self.itemObj.transform;
	end

	return self._itemObjTf;
end

function Lua_JumpHappyPlayWindow:restartJumping()
	local blocak_data_1 = self:updateTemporaryData(1);
	local blocak_data_2 = self:updateTemporaryData(2);

	self.curIndex = 2;
	local item_1 = self:getJumpItemByIndex(1);
	item_1:setData(blocak_data_1);

	local item_2 = self:getJumpItemByIndex(2);
	item_2:setData(blocak_data_2);

	local dir = item_2.direction;
	local distance = item_2.distance;
	local half_length_1 = item_1.half_length;
	local half_length_2 = item_2.half_length;
	self.bLeft = dir == 1;

	local arr_pos_x = self.bLeft and self.arrivedItemPosX or -self.arrivedItemPosX;
	local arr_pos_y = self.arrivedItemPosY;
	item_1:setLocation(arr_pos_x, arr_pos_y);

	distance = distance + half_length_1 + half_length_2;
	local posX, posY = self:calculatePos(arr_pos_x, arr_pos_y, distance, self.bLeft, 1)
	item_2:setLocation(posX, posY);

	self.modelItem:setLocation(arr_pos_x, arr_pos_y);
	self.modelItem:setModelEffDir(self.bLeft);
	self.modelShadowSp:setEnable(true);
	self:showModelItem(true);

	self:calLastBlockItemDir();
	self.curArriveBlockIndex = 1;
	self.curArriveBlockEdgeDistance = half_length_1;

	self:showEdgePoint(arr_pos_x, arr_pos_y, half_length_1);

	-- self:calBlockEdgeDistance(self.modelItem.x, self.modelItem.y);
end

-- 计算item位置
function Lua_JumpHappyPlayWindow:calculatePos(posX, posY, distance, bLeft, type, angle)
	posX = posX or 0;
	posY = posY or 0;
	distance = distance or 200;
	angle = angle or self.angle;
	-- bLeft = bLeft ~= nil and  or true;

	local x1 = distance * Mathf.Sin(Mathf.Rad(angle));
	local y1 = distance * Mathf.Cos(Mathf.Rad(angle));
	if type == 1 then
		posX = bLeft and posX - x1 or posX + x1;
	else
		posX = bLeft and posX + x1 or posX - x1;
	end
	posY = type == 1 and posY + y1 or posY - y1; -- 1:上 2：下
	return posX, posY;
end

function Lua_JumpHappyPlayWindow:calculateAngle(posX, posY, targetPosX, targetPosY)
	local intervalX, intervalY = self:calIntervalXY(posX, posY, targetPosX, targetPosY);
	local vec_x, vec_y, distance = self:calNormalizedVec(intervalX, intervalY);
	local angle = Mathf.Acos((intervalY / distance)) * Mathf.Rad2Deg;
	return angle;
end

function Lua_JumpHappyPlayWindow:calIntervalXY(posX, posY, targetPosX, targetPosY)
	posX = posX or 0;
	posY = posY or 0;
	targetPosX = targetPosX or 0;
	targetPosY = targetPosY or 0;
	local intervalX = targetPosX - posX;
	local intervalY = targetPosY - posY;
	return intervalX, intervalY;
end

-- 规一化
function Lua_JumpHappyPlayWindow:calNormalizedVec(vec_x, vec_y)
	vec_x = vec_x or 0;
	vec_y = vec_y or 0;
	local distance = Mathf.Sqrt(vec_x * vec_x + vec_y * vec_y);
	return vec_x / distance, vec_y / distance, distance;
end

-- 计算方向
function Lua_JumpHappyPlayWindow:calLastBlockItemDir()
	local lastIndex = self.curIndex - 1;
	lastIndex = lastIndex <= 0 and 1 or lastIndex;
	local cur_item = self:getJumpItemByIndex(lastIndex);
	local next_item = self:getJumpItemByIndex(self.curIndex);

	local intervalX, intervalY = self:calIntervalXY(cur_item.x, cur_item.y, next_item.x, next_item.y);

	intervalX, intervalY = self:calNormalizedVec(intervalX, intervalY);

	if self.cur_blockDir == nil then
		self.cur_blockDir = Vector2(intervalX, intervalY);
	else
		self.cur_blockDir.x = intervalX;
		self.cur_blockDir.y = intervalY;
	end
end

function Lua_JumpHappyPlayWindow:calProjectVec(cal_vec, dir_vec)
	local distance = Vector2.Dot(cal_vec, dir_vec);
	local param = dir_vec * distance;
	return param;
end

function Lua_JumpHappyPlayWindow:calJumpDistance()
	local intervalX, intervalY = self:calIntervalXY(self.modelItem.x, self.modelItem.y, self.targetJumpPos.x, self.targetJumpPos.y);
	local _, _, distance = self:calNormalizedVec(intervalX, intervalY);
 

	if self.jump_vec == nil then
		self.jump_vec = Vector2(intervalX, intervalY);
	else
		self.jump_vec.x = intervalX;
		self.jump_vec.y = intervalY;
	end

	return distance;
end

function Lua_JumpHappyPlayWindow:calJumpDistanceInOneVec()
	local param = self:calProjectVec(self.jump_vec, self.cur_blockDir);
	local distance = Mathf.Sqrt(param.x * param.x + param.y * param.y);

	return distance;
end

-- 计算model距当前方块边缘的长度
function Lua_JumpHappyPlayWindow:calBlockEdgeDistance(posX, posY)
	local cur_item = self:getJumpItemByIndex(self.curArriveBlockIndex);
	local half_length = cur_item.half_length;
	local intervalX, intervalY = self:calIntervalXY(cur_item.x, cur_item.y, posX, posY);
	local param = self:calProjectVec(Vector2(intervalX, intervalY), self.cur_blockDir);
	local distance = Mathf.Sqrt(param.x * param.x + param.y * param.y);
	local positive = self.cur_blockDir.x / Mathf.Abs(self.cur_blockDir.x) == param.x / Mathf.Abs(param.x) and
					 self.cur_blockDir.y / Mathf.Abs(self.cur_blockDir.y) == param.y / Mathf.Abs(param.y); 

	local edge_distance = positive and half_length - distance or half_length + distance;
-- print("111", positive, "distance", distance,  "edge_distance", edge_distance, "half_length", half_length, self.bLeft, "!!!" )
-- print("222", positive, "distance", distance, "edge_distance", edge_distance, "self.curArriveBlockIndex", self.curArriveBlockIndex, posX, posY)
	self.curArriveBlockEdgeDistance = edge_distance;
	self:showEdgePoint(posX, posY, edge_distance);
end


function Lua_JumpHappyPlayWindow.Get:modelItem()
	if self._modelItem == nil then
		self._modelItem = Lua_JumpHappyPlayModelItem.new(self.itemObj);
		self._modelItem:setSiblingIndex(self.pointObj.transform:GetSiblingIndex() + 1);
	end

	return self._modelItem;
end

function Lua_JumpHappyPlayWindow:showModelItem(bShow)
	self.modelItem:setEnable(bShow);
end

function Lua_JumpHappyPlayWindow:setModelPos(posX, posY)
	posX = posX or 0;
	posY = posY or 0;
	self.modelItem:setLocation(posX, posY);
end

function Lua_JumpHappyPlayWindow:generateRouteAssist(dt)
	if self:checkShowAssistLine() ~= true then
		return;
	end

	self:calJumpControllPos(dt);

	local t;
	local pos = Vector2(0, 0);
	local item;
	for i = 1, self.maxPressItemCount do
		t = 1 / self.maxPressItemCount * i;
		pos = Lua_BezierUtils.Calculate2DimensionalBezierPoint(t , self.curModelPos, self.jumpControllPos, self.targetJumpPos, pos);
		item = self:getBezierLinePointByIndex(i);
		item:setLocation(pos.x, pos.y);
		item:setEnable(true);

		if i == self.maxPressItemCount then
			item:checkArriveBlockItem(true);
		end
	end
end

function Lua_JumpHappyPlayWindow:getBezierLinePointByIndex(index)
	if self.bezierLinePoints == nil then
		self.bezierLinePoints = {};
	end

	local item = self.bezierLinePoints[index];
	if item == nil then
		item = Lua_JumpHappyPlayPointItem.new(self.pointObj);
		item:setSiblingIndex(0);
		self.bezierLinePoints[index] = item;
	end

	return item;
end

function Lua_JumpHappyPlayWindow:startCalPressTime()
	if self.bPressTimer ~= true then
		self.bPressTimer = true;

		self.pressTime = 0;
		self.lastMouseDownTime = getTime();
		self.startMouseDownTime = getTime();
		self.playJumpPre = Lua_JumpHappyPlayWindow.Action_Jump_Pre_Time;
		self.modelItem:setAction(Lua_JumpHappyPlayWindow.Action_Jump_Pre, -1);
		self.lastModelAct = Lua_JumpHappyPlayWindow.Action_Jump_Pre;

		self:playingSound(Lua_JumpHappyPlayWindow.Sound_Ready);
		self:addTimer("Lua_JumpHappyPlayWindow_CalPressTime", 0.01, self, self.onPressTimer, nil, -1, true);
		self:onPressTimer();
	end
end

function Lua_JumpHappyPlayWindow:onPressTimer()
	if self.pressTime >= self.maxPressTime then
		return;
	end

	self.pressTime = getTime() - self.startMouseDownTime; -- 按压时长
	if self.playJumpPre > 0 then 
		local t = getTime();
		local dt = t - self.lastMouseDownTime;
		self.lastMouseDownTime = t;
		self.playJumpPre = self.playJumpPre - dt;
		if self.playJumpPre <= 0 then
			self.modelItem:setAction(Lua_JumpHappyPlayWindow.Action_Pre_To_Ready, -1);
			self.lastModelAct = Lua_JumpHappyPlayWindow.Action_Pre_To_Ready;
		end
	end

	if self.pressTime > Lua_JumpHappyPlayWindow.Sound_Time_Ready then
		if not DataCenter.audioManager:isPlayingById(Lua_JumpHappyPlayWindow.Sound_Ready_Loop) then
	        self:stopSound(Lua_JumpHappyPlayWindow.Sound_Ready);
			self:playingSound(Lua_JumpHappyPlayWindow.Sound_Ready_Loop);
	    end
	end

	self:generateRouteAssist(self.pressTime);

	self.modelItem:showAccumulatePower(true);
end

function Lua_JumpHappyPlayWindow:endCalPressTime()
	if self.bPressTimer then
		self.bPressTimer = false;
		self:removeTimer(self, self.onPressTimer);
		self.modelItem:showAccumulatePower(false);
	end
end

function Lua_JumpHappyPlayWindow:calJumpControllPos(dt)
	local dis = self._spd * self.pressTime;
	local next_item = self:getJumpItemByIndex(self.curIndex);

	local angle = MathUtil.getDirectionByXY(next_item.x, next_item.y, self.curModelPos.x, self.curModelPos.y);
	if self.bLeft then
		angle = 90 + angle;
	else
		angle = -angle - 90;
	end
	local nx = dis * Mathf.Sin(Mathf.Rad(angle));
	local ny = dis * Mathf.Cos(Mathf.Rad(angle));
	if self.bLeft then
		nx = self.curModelPos.x - nx;
	else
		nx = self.curModelPos.x + nx;
	end

	ny = self.curModelPos.y + ny;
	if self.targetJumpPos == nil then
		self.targetJumpPos = Vector2.New(nx, ny);
	else
		self.targetJumpPos:Set(nx, ny);
	end

	-- 控制点
	local dw = 0;
	local cx = 0;
	if self.targetJumpPos.x > 0 and self.curModelPos.x < 0 then
		dw = Mathf.Abs(self.curModelPos.x) + self.targetJumpPos.x;
	elseif self.targetJumpPos.x < 0 and self.curModelPos.x > 0 then
		dw = Mathf.Abs(self.targetJumpPos.x) + self.curModelPos.x;
	else
		dw = Mathf.Abs(self.targetJumpPos.x - self.curModelPos.x);
	end
	if not self.bLeft then
		cx = dw * self._controllX + self.curModelPos.x;
	else
		cx = -dw * self._controllX + self.curModelPos.x;
	end
	local cy = dis * self._controllY + self.targetJumpPos.y;
	if self.jumpControllPos == nil then
		self.jumpControllPos = Vector2.New(cx, cy);
	else
		self.jumpControllPos:Set(cx, cy);
	end
end

function Lua_JumpHappyPlayWindow:startModelMove()
	if self._bModelMove ~= true then
		self._bModelMove = true; 

		self:addTimer("Lua_JumpHappyPlayWindow_ModelMoving", 0.01, self, self.onPlayingJumpTimer, nil, -1, true);
		self.detail_shadowSp_x = self.targetJumpPos.x - self.curModelPos.x;
		self.detail_shadowSp_y = self.targetJumpPos.y - self.curModelPos.y;
		self.last_shadowSp_x = self.modelShadowSp.posX;
		self.last_shadowSp_y = self.modelShadowSp.posY;

		self:stopSound(Lua_JumpHappyPlayWindow.Sound_Ready);
		self:stopSound(Lua_JumpHappyPlayWindow.Sound_Ready_Loop);
		self:playingSound(Lua_JumpHappyPlayWindow.Sound_Jump);
		self:onPlayingJumpTimer();
	end
end

function Lua_JumpHappyPlayWindow:onPlayingJumpTimer()
	local actEnd = false;
	local t = getTime();
	local jumpTime = t - self.startPlayingJumpTime;
	local dt = t - self.lastPlayingJumpTime;
	self.lastPlayingJumpTime = t;

	-- 浣熊轨迹运动
	local r = jumpTime / self.jumpRouteTime;
	if r > 1 then r = 1; end
	if self.modelItemVec == nil then 
		self.modelItemVec = Vector2(0, 0);
	end
	Lua_BezierUtils.Calculate2DimensionalBezierPoint(r, self.curModelPos, self.jumpControllPos, self.targetJumpPos, self.modelItemVec);
	self.modelItem:setLocation(self.modelItemVec.x, self.modelItemVec.y);

	local posX = self.detail_shadowSp_x * r + self.last_shadowSp_x;
	local posY = self.detail_shadowSp_y * r + self.last_shadowSp_y
	self.modelShadowSp:setLocation(posX, posY);

	local scaleValue = Mathf.Sin(math.rad(180 * r)) / 4;
	scaleValue = 1 - scaleValue;
	self.modelShadowSp:setScale(scaleValue, scaleValue);

	-- 动作
	if self.actionTimeArr:getSize() > 0 then
		local at = self.actionTimeArr[1];
		at = at - dt;
		self.actionTimeArr[1] = at;
		while (at <= 0 and self.actionTimeArr:getSize() > 0) do
			self.actionArr:remove(1);
			self.actionTimeArr:remove(1);
			if self.actionTimeArr:getSize() > 0 then
				at = at + self.actionTimeArr[1];
				self.actionTimeArr[1] = at;
				self.modelItem:setAction(self.actionArr[1], -1);
				if at > 0 and self.actionArr[1] == Lua_JumpHappyPlayWindow.Action_Down_To_Fail then -- 失败渐变
					self.modelShadowSp:setEnable(false);
					TweenUtil.getInstance():stop(self.modelItem.mainContent);
					TweenUtil.getInstance():addTweenTargetAlpha(self.modelItem.mainContent, 0.6, at - 0.6, -1, false);
				end
			end
		end
		
		actEnd = at <= 0;
		if actEnd then
			self.modelItem:setAction(Lua_JumpHappyPlayWindow.Action_Idle, -1);
		end
		self:showJumpResult();
	else
		actEnd = true;
		if self.bSuccess then
			self.bSuccess = nil;
		end
		self:endModelMove();
	end
end

function Lua_JumpHappyPlayWindow:endModelMove()
	if self._bModelMove then
		self._bModelMove = false;
		self:removeTimer(self, self.onPlayingJumpTimer);
		self.modelItem:setLocation(self.targetJumpPos.x, self.targetJumpPos.y);
		self.modelItem:setAction(Lua_JumpHappyPlayWindow.Action_Idle, -1);

		local posX = self.detail_shadowSp_x + self.last_shadowSp_x;
		local posY = self.detail_shadowSp_y + self.last_shadowSp_y
		self.modelShadowSp:setLocation(posX, posY);
		self.modelShadowSp:setScale(1, 1);

		self:stopSound(Lua_JumpHappyPlayWindow.Sound_Jump);
	end
end

function Lua_JumpHappyPlayWindow:showJumpResult()

	if self.actionTimeArr == nil or self.actionTimeArr:getSize() ~= 1 then
		return;
	end

	if self.bShowResult ~= true then
		self:checkNextAccumulatePower();
		return;
	end

	self.bShowResult = false;
	if self.bSuccess then
		self:startGetServerData(); 
	else
		Lua_CommonUtil.removeTimer(self, self.startGetServerData);
  		Lua_CommonUtil.delayCall(0.6, self, self.startGetServerData);
	end
	-- if self.curArriveBlockIndex == self.lastArriveBlockIndex then
	-- 	-- self:showCenterEff();
	-- else
	-- 	self:startGetServerData(); 
	-- end

	-- self.modelItem:updateResidueNum();
end

-- 上一次记录的数据
function Lua_JumpHappyPlayWindow:resetLastRecordLevelInfo()
	local levelInfo = DataCenter.jumpingHappyData:getLevelInfoById(self.levelId);
	if levelInfo == nil then
		return;
	end

	local recordInfo = levelInfo.game_info;
	if recordInfo == nil or #recordInfo <= 0 then
		return;
	end

	local item;
	local bLeft;
	local blockIndex;
	local distance = 0;
	local posX, posY = 0, 0;
	local interval_distance = 0;
	local cur_half_length = 0;
	local next_half_length = 0;
	local count = #recordInfo;
	local blockData = recordInfo[count];
	blockIndex = blockData and blockData.number or 0;
	self.curIndex = blockIndex;
	item = self:getJumpItemByIndex(blockIndex);
	item:setData(blockData);
	bLeft = item.direction == 1;
	interval_distance = item.distance;
	next_half_length = item.half_length;
	self.bLeft = bLeft;

	local curIndex = count - 1;
	blockData = recordInfo[curIndex];
	blockIndex = blockData and blockData.number or 0;
	local cur_item = self:getJumpItemByIndex(blockIndex);
	cur_item:setData(blockData);
	item:setSiblingIndex(0);
	local arr_pos_x = self.bLeft and self.arrivedItemPosX or -self.arrivedItemPosX;
	local arr_pos_y = self.arrivedItemPosY;
	cur_item:setLocation(arr_pos_x, arr_pos_y);
	cur_half_length = cur_item.half_length;
	distance = interval_distance + cur_half_length + next_half_length;
	posX, posY = self:calculatePos(arr_pos_x, arr_pos_y, distance, bLeft, 1);
	item:setLocation(posX, posY);
	self.lastArriveBlockIndex = curIndex;
	self:updateLastRecordModelPos(blockIndex, arr_pos_x, arr_pos_y, blockData.detail_x, blockData.detail_y);

	
	bLeft = cur_item.direction == 1;
	posX, posY = arr_pos_x, arr_pos_y;
	interval_distance = cur_item.distance;
	next_half_length = cur_half_length;
	local num = 2;
	for i = curIndex - 1, 1, -1 do
		if num >= self.maxItemCount then
			break;
		end
		num = num + 1;
		blockData = recordInfo[i];
		blockIndex = blockData and blockData.number or 0;
		item = self:getJumpItemByIndex(blockIndex);
		item:setSiblingIndex(num - 1);
		item:setData(blockData);
		cur_half_length = item.half_length;
		distance = interval_distance + cur_half_length + next_half_length;
		posX, posY = self:calculatePos(posX, posY, distance, bLeft, 2);
		item:setLocation(posX, posY);

		bLeft = item.direction == 1;
		interval_distance = item.distance;
		next_half_length = item.half_length;
	end
	self.modelShadowSp:setEnable(true);
	self:showModelItem(true);
end

function Lua_JumpHappyPlayWindow:updateLastRecordModelPos(arriveIndex, posX, posY, intervalX, intervalY)
	posX = posX or 0;
	posY = posY or 0;
	intervalX = intervalX or 0;
	intervalY = intervalY or 0;
	posX = posX + intervalX;
	posY = posY + intervalY;
	self.modelItem:setLocation(posX, posY);
	self.modelItem:setModelEffDir(self.bLeft);

	self:calLastBlockItemDir();
	self.curArriveBlockIndex = arriveIndex;
	self:calBlockEdgeDistance(self.modelItem.x, self.modelItem.y);
end

function Lua_JumpHappyPlayWindow:startGetServerData()
	if self._bGetServerData ~= true then
		self._bGetServerData = true;
		self.obtainServerDataCount = 0;

		self:addTimer("Lua_JumpHappyPlayWindow_GetServerData", self.checkSercerTime, self, self.onGetServerData);
		self:onGetServerData();
	end
end

function Lua_JumpHappyPlayWindow:onGetServerData()
	local curBDeath = DataCenter.jumpingHappyData.curBDeath;
	if curBDeath then
		Lua_WindowUtil.openWin("Lua_JumpHappyResultWindow", Lua_WinParam.ACTION_OPEN, self.levelId);
		self:endGetServerData();
		return;
	end

	local bCheckServerData = DataCenter.jumpingHappyData.bCheckServerData;
	if bCheckServerData ~= true then
		self.obtainServerDataCount = self.obtainServerDataCount + 1;
		if self.obtainServerDataCount >= self.checkServerDataCount then
			self:endGetServerData();
			LogManager.showLog("跳跳乐数据获取失败");
		end
	else
		DataCenter.jumpingHappyData.bCheckServerData = false;
		self.obtainServerDataCount = 0;
		self:endGetServerData();
		self:showServerData();
		if self.bCreatePointItem then
			self.bCreatePointItem = false;
			self:updateNextItem();
		end
	end
end

function Lua_JumpHappyPlayWindow:endGetServerData()
	if self._bGetServerData then
		self._bGetServerData = false;
		self:removeTimer(self, self.onGetServerData);
	end
end

function Lua_JumpHappyPlayWindow:showServerData()
	local curSorce = DataCenter.jumpingHappyData.curSorce;
	self:showMySelfScore(curSorce);	
	
	self.modelItem:updateResidueNum();
	if self.lastScore == nil or self.lastScore ~= curSorce then
		self.lastScore = curSorce;
		local curAddSorce = DataCenter.jumpingHappyData.curAddSorce or 0;
		local str = LanUtil.formateStr(791029, curAddSorce);
		self.modelItem:updateAddScore(str);
		self:showCenterEff();
	end
end

function Lua_JumpHappyPlayWindow:showCenterEff()
	local item = self:getJumpItemByIndex(self.curArriveBlockIndex);
	local intervalX, intervalY = self:calIntervalXY(item.x, item.y, self.modelItem.x, self.modelItem.y);
	local distance = Mathf.Sqrt(intervalX * intervalX + intervalY * intervalY);
	if distance <= item.half_center_distance then
		self.modelItem:showCenterDisplay(true);
		self:showModelCenterEff();
	end
	self.lastArriveBlockIndex = self.curArriveBlockIndex;
end

function Lua_JumpHappyPlayWindow:showMySelfScore(scoreValue)
	scoreValue = scoreValue or 0;
	self.scoreNum.num = scoreValue;
	local width = self.scoreNum:getTotalWidth();
	width = width / 2;

	local posX = self.scoreNum.x + 3 + width;
	self.selfScoreNumTxt:setLocation(posX, -164);
end

function Lua_JumpHappyPlayWindow:onBackBtnClick()
	local tipsData = {
		owner = self,
		des = 791030,
		btnType = 1,
		cancelLabel = 791031,
		sureLabel = 791032,
		cancelFun = self.sureAbandon,
		sureFun = self.saveGameInfo
	};
	Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_JumpHappyPlayWindow:sureAbandon()
	local activity_id = DataCenter.jumpingHappyData.activity_id;
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sJumpingHappyScore(activity_id, self.levelId, 3);
	DataCenter.jumpingHappyData.bPlayJumping = nil;
	self:hide();
end

function Lua_JumpHappyPlayWindow:saveGameInfo()
	local activity_id = DataCenter.jumpingHappyData.activity_id;
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sActivityInfo(activity_id);
	DataCenter.jumpingHappyData.bPlayJumping = nil;
	self:hide();
end

function Lua_JumpHappyPlayWindow:checkShowAssistLine()
	if DataCenter.jumpingHappyData.bTest then
		return true;
	end

	local curNum = DataCenter.jumpingHappyData.curJumpNum or 0;
	local maxLineNum = DataCenter.jumpingHappyData.maxLineNum or 0;
	return maxLineNum > curNum;
end

function Lua_JumpHappyPlayWindow:updateTemporaryData(index)
	local info = DataCenter.jumpingHappyData:getInstanceBlockInfo(index);
	-- if info == nil then
	-- 	print("无数据", index, getTraceback());
	-- else
	-- 	print("方块", info.number, info.direction, info.distance, info.block_id)
	-- end
	return info;
end

function Lua_JumpHappyPlayWindow:showModelCenterEff()
	if self.centerEffDic == nil then
		self.centerEffDic = {};
	end
	if self.centerEffArr == nil then
		self.centerEffArr = Array();
	end
	if self.idleCenterEffArr == nil then
		self.idleCenterEffArr = Array();
	end

	local centerEff;
	if self.idleCenterEffArr:getSize() > 0 then
		centerEff = self.idleCenterEffArr:remove();
	else
		centerEff = UICreate.createUIEffect(self.itemObj, "/effects/uiEffects/ttl_tx", "ttl_gq_01", 0, 0);
	end

	centerEff:setLocation(self.modelItem.x, self.modelItem.y);
	centerEff.siblingIndex = self.modelItem.siblingIndex;
	centerEff:setEnable(true);

	self:stopSound(Lua_JumpHappyPlayWindow.Sound_Center);
	self:playingSound(Lua_JumpHappyPlayWindow.Sound_Center);
	local time = getTime();
	self.centerEffDic[centerEff] = time;
	self.centerEffArr:add(centerEff);
	self:startCheckCenterEff();
end

function Lua_JumpHappyPlayWindow:hideCenterEff(effect)
	if self.centerEffDic == nil or effect == nil or self.centerEffDic[effect] == nil then
		return;
	end

	effect:setEnable(false);
	local center = self.centerEffDic[effect];
	self.centerEffDic[effect] = nil;
	self.centerEffArr:removeItem(effect);
	self.idleCenterEffArr:add(effect);
end

function Lua_JumpHappyPlayWindow:startCheckCenterEff()
	if self._bCheckCenterEff ~= true then
		self._bCheckCenterEff = true;

		self:addTimer("Lua_JumpHappyPlayWindow_MoveItemObj", 0.1, self, self.onCheckCenterEff, nil, -1, true);
	end
end

function Lua_JumpHappyPlayWindow:onCheckCenterEff()
	local len = self.centerEffArr:getSize();
	if len <= 0 then
		self:endCheckCenterEff();
	else
		local dt;
		local effect;
		local lastTime;
		local time = getTime();
		for i = 1, len do
			effect = self.centerEffArr[i];
			lastTime = self.centerEffDic[effect];
			dt = time - lastTime;
			if dt >= self.showCenterEffTime then
				self:hideCenterEff(effect);
			end
		end
	end
end

function Lua_JumpHappyPlayWindow:endCheckCenterEff()
	if self._bCheckCenterEff then
		self._bCheckCenterEff = false;
		self:removeTimer(self, self.onCheckCenterEff);
	end
end

function Lua_JumpHappyPlayWindow.Get:modelShadowSp()
	if self._modelShadowSp == nil then
		local posX, posY = self.modelItem.x - 1, self.modelItem.y -10;
		self._modelShadowSp = UICreate.createUIAtlasImage(self.itemObj, "jump_happy_atlas", "xui_ttl_widget_13", posX, posY, 130, 56);
		self._modelShadowSp.siblingIndex = self.modelItem:getModelSiblingIndex();
	end

	return self._modelShadowSp;
end

function Lua_JumpHappyPlayWindow:playingSound(soundId)
	-- if soundId == Lua_JumpHappyPlayWindow.Sound_Ready then
	-- 	print("蓄力音效start");
	-- elseif soundId == Lua_JumpHappyPlayWindow.Sound_Ready_Loop then
	-- 	print("蓄力循环音效start");
	-- elseif soundId == Lua_JumpHappyPlayWindow.Sound_Jump then
	-- 	print("起跳音效start");
	-- elseif soundId == Lua_JumpHappyPlayWindow.Sound_Center then
	-- 	print("落点音效start");
	-- end
	DataCenter.audioManager:play(soundId);
end

function Lua_JumpHappyPlayWindow:stopSound(soundId)
	-- if soundId == Lua_JumpHappyPlayWindow.Sound_Ready then
	-- 	print("蓄力音效end");
	-- elseif soundId == Lua_JumpHappyPlayWindow.Sound_Ready_Loop then
	-- 	print("蓄力循环音效end");
	-- elseif soundId == Lua_JumpHappyPlayWindow.Sound_Jump then
	-- 	print("起跳音效end");
	-- elseif soundId == Lua_JumpHappyPlayWindow.Sound_Center then
	-- 	print("落点音效end");
	-- end
	DataCenter.audioManager:stop(soundId);
end

function Lua_JumpHappyPlayWindow:updateTestLine()
	local distance = Mathf.Sqrt(self.jump_vec.x * self.jump_vec.x + self.jump_vec.y * self.jump_vec.y);
	local intervalX = self.jump_vec.x / distance;
	local intervalY = self.jump_vec.y ;

	local angle = Mathf.Acos(intervalY / distance) * Mathf.Rad2Deg
	angle = intervalX >= 0 and 90 - angle or 90 + angle;

	if self.testline == nil then
		self.testline = UICreate.createUIAtlasImage(self.itemObj, "common_altas_1", "ui_common_progress_001_f", 0, 0, 10, 10);
		self.testline.color = Color.black
		self.testline.pivotValue = 3;
	end

	self.testline:setLocation(self.modelItem.x, self.modelItem.y);
	self.testline:SetDimensions(distance, 10);
	self.testline:setRot(0,0, angle)

	if self.realLine == nil then
		self.realLine = UICreate.createUIAtlasImage(self.itemObj, "common_altas_1", "ui_common_progress_001_f", 0, 0, 10, 10);
		self.realLine.pivotValue = 3;
	end

	local param = self:calProjectVec(self.jump_vec, self.cur_blockDir);


	distance = Mathf.Sqrt(param.x * param.x + param.y * param.y);
	angle = Mathf.Acos(self.cur_blockDir.y) * Mathf.Rad2Deg
	angle = self.cur_blockDir.x >= 0 and 90 - angle or 90 + angle;

	local item = self:getJumpItemByIndex(self.curArriveBlockIndex);
	self.realLine:setLocation(item.x, item.y);
	self.realLine:SetDimensions(distance, 10);
	self.realLine:setRot(0,0, angle)
end

function Lua_JumpHappyPlayWindow:updateEdgeLine(posX, posY,distance,  angle)
	if self.edgeline == nil then
		self.edgeline = UICreate.createUIAtlasImage(self.itemObj, "common_altas_1", "ui_common_progress_003_f", 0, 0, 10, 10);
		self.edgeline.pivotValue = 3;
	end

	self.edgeline:setLocation(posX, posY);
	self.edgeline:SetDimensions(distance, 10);
	self.edgeline:setRot(0,0, angle)
end

function Lua_JumpHappyPlayWindow:showEdgePoint(pointX, pointY, distance)
	local bShow = DataCenter.jumpingHappyData.bTest
	if bShow then
		if self.edgePointSp == nil then
			self.edgePointSp = UICreate.createUIAtlasImage(self.itemObj, "common_altas_1", "ui_common_icon_41", 0, 0, 10, 10);
			self.edgePointSp.pivotValue = 3;
		end

		local angle = Mathf.Atan((self.cur_blockDir.y / self.cur_blockDir.x)) * Mathf.Rad2Deg;
		-- print("@@@", self.cur_blockDir.y / self.cur_blockDir.x, angle, "distance", distance, "self.bLeft", self.bLeft)
		angle = angle < 0 and 180 + angle or angle;
		self.edgePointSp:setRot(0, 0, angle);
		self.edgePointSp:setLocation(pointX, pointY);
		self.edgePointSp:SetDimensions(distance, 4);
		self.edgePointSp:setEnable(true);
	else
		if self.edgePointSp then
			self.edgePointSp:setEnable(false);
		end
	end
end

















----------------------------方块Item-------------------------------------
Lua_JumpHappyPlayItem = class("Lua_JumpHappyPlayItem", Lua_DisplayObject);
function Lua_JumpHappyPlayItem:ctor(p)
	self:superCall("ctor", p, "JumpHappyPlayItem_skin");
end

function Lua_JumpHappyPlayItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_JumpHappyPlayItem:dispose()
	self.data = nil;
	if self.effect then
		self.effect:dispose();
		self.effect = nil;
	end
	if self.waterEffect then 
		self.waterEffect:dispose();
		self.waterEffect = nil;
	end
	self:superCall("dispose");
end

function Lua_JumpHappyPlayItem:setData(data)
	self.data = data;
	self._half_center_distance = 0;
	self._total_length = 0;
	if data == nil then
		return;
	end

	local block_id = self.data.block_id;
	local blockInfo = DataCenter.jumpingHappyData:getBlockInfoById(block_id);
	if blockInfo == nil then
		return;
	end

	self.itemBg:setAltas(blockInfo.atlas, blockInfo.sprite);
	self.itemBg:SetDimensions(blockInfo.size[1], blockInfo.size[2]);

	local posX = blockInfo.sprite_pos and blockInfo.sprite_pos[1] or 0;
	local posY = blockInfo.sprite_pos and blockInfo.sprite_pos[2] or -24;
	self.itemBg:setLocation(posX, posY);

	self._half_center_distance = blockInfo.center_distance;
	self._total_length = blockInfo.length;
	self:updateEffect(blockInfo.effect_info);
	self:updateWaterEffect(blockInfo.edge_effect_info);
	self:showTestSp();
end

function Lua_JumpHappyPlayItem:updateEffect(effect_info)
	local bShow = effect_info and #effect_info > 0;
	if bShow then
		if self.effect == nil then
			self.effect = UICreate.createUIEffect(self.content, "/effects/uiEffects/ttl_tx", "ttl_ly_01", 0, 0);
			self.effect.siblingIndex = 0;
		end

		local posX = effect_info and effect_info[1] or 0;
		local posY = effect_info and effect_info[2] or -92;
		local scaleValue = effect_info and effect_info[3] or 1;
		self.effect:setLocation(posX, posY);
		self.effect:setScale(scaleValue, scaleValue, scaleValue);
		self.effect:setEnable(true);
	else
		if self.effect then
			self.effect:setEnable(false);
		end
	end
end

function Lua_JumpHappyPlayItem:updateWaterEffect(edge_effect_info)
	local bShow = edge_effect_info and #edge_effect_info > 0;
	if bShow then
		if self.waterEffect == nil then
			self.waterEffect = UICreate.createUIEffect(self.content, "/effects/uiEffects/ttl_tx", "ttl_ly_02", 0, 0);
			self.waterEffect.siblingIndex = 0;
		end

		local posX = edge_effect_info and edge_effect_info[1] or 0;
		local posY = edge_effect_info and edge_effect_info[2] or -55;
		local scaleValue = edge_effect_info and edge_effect_info[3] or 1;
		self.waterEffect:setLocation(posX, posY);
		self.waterEffect:setScale(scaleValue, scaleValue, scaleValue);
		self.waterEffect:setEnable(true);
	else
		if self.waterEffect then
			self.waterEffect:setEnable(false);
		end
	end
end

function Lua_JumpHappyPlayItem.Get:center_distance()
	return self.half_center_distance * 2;
end

function Lua_JumpHappyPlayItem.Get:half_center_distance()
	return self._half_center_distance or 0;
end

function Lua_JumpHappyPlayItem.Get:total_length()
	return self._total_length or 283;
end

function Lua_JumpHappyPlayItem.Get:half_length()
	return self.total_length / 2;
end

-- 序号
function Lua_JumpHappyPlayItem.Get:number()
	return self.data and self.data.number or 0;
end

-- 方向
function Lua_JumpHappyPlayItem.Get:direction()
	return self.data and self.data.direction or 1; -- 1 左 2右
end

-- 两方块相邻边缘之间的间隔
function Lua_JumpHappyPlayItem.Get:distance()
	return self.data and self.data.distance or 100; 
end

-- 间隔x
function Lua_JumpHappyPlayItem.Get:detail_x()
	return self.data and self.data.detail_x or 0; 
end

-- 间隔y
function Lua_JumpHappyPlayItem.Get:detail_y()
	return self.data and self.data.detail_y or 0; 
end

function Lua_JumpHappyPlayItem:showTestSp()
	local bShow = DataCenter.jumpingHappyData.bTest;
	self:showAreaSp(bShow);
	self:showCenterSp(bShow)
end


function Lua_JumpHappyPlayItem:showAreaSp(bShow)
	if bShow then
		if self.areaSp == nil then
			self.areaSp = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_icon_41", 0, 0, 0, 0);
		end

		self.areaSp:SetDimensions(self.total_length, self.total_length);
		self.areaSp:setEnable(true);
	else
		if self.areaSp then
			self.areaSp:setEnable(false);
		end
	end
end

function Lua_JumpHappyPlayItem:showCenterSp(bShow)
	if bShow then
		if self.centerSp == nil then
			self.centerSp = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_icon_41", 0, 0, 0, 0);
			self.centerSp.color = Color.black;
		end

		self.centerSp:SetDimensions(self.center_distance, self.center_distance);
		self.centerSp:setEnable(true);
	else
		if self.centerSp then
			self.centerSp:setEnable(false);
		end
	end
end














----------------------------模型Item-------------------------------------
Lua_JumpHappyPlayModelItem = class("Lua_JumpHappyPlayModelItem", Lua_DisplayObject);
function Lua_JumpHappyPlayModelItem:ctor(p)
	self:superCall("ctor", p, "JumpHappyPlayModelItem_skin");
end

function Lua_JumpHappyPlayModelItem:buildShowItem()
	self:superCall("buildShowItem");

	local model_dir = DataCenter.jumpingHappyData.model_dir;-- 模型转向角度
	self.leftAngle = model_dir and model_dir[1] or -60;
	self.rightAngle = model_dir and model_dir[2] or 25;
	self.addScoreTweenTime = 1;
	LuaUtil.setRectSize(self.content, 1, 1);
	local artifactVo = DataCenter.artifactUtil:getDefaultArtifact();
	self.modelImg = UICreate.createModelEffImg(self.content, artifactVo.modelUrl, artifactVo.modelSrc, 0, -3, 300, 300);
	self.modelImg.anchorValue = 1;
	self.modelImg:setCamField(1.2, 1, 100, true);
	self.modelImg:setCamPos(0, 4.01, -10);
	self.modelImg:setCamRot(21.66, 0, 0);
	self.modelImg.canRot = false;
	-- self.modelImg:addLuaAniCompleteFun(self, self.onModelAniComplete);
	self:setAction(0);

	self:updateAddScore(nil);
	self:showCenterDisplay(false);
	self:updateResidueNum();
end

function Lua_JumpHappyPlayModelItem:dispose()
	self.data = nil;
	self._transform = nil;
	TweenUtil.getInstance():stop(self.centerSp.mainContent);
	TweenUtil.getInstance():stop(self.addScoreTxt.mainContent);
	if self.modelImg then
		self:setAction(0);
		self.modelImg:dispose();
		self.modelImg = nil;
	end
	if self.accumulatePowerEffect_1 then
		self.accumulatePowerEffect_1:dispose();
		self.accumulatePowerEffect_1 = nil;
	end
	if self.accumulatePowerEffect_2 then
		self.accumulatePowerEffect_2:dispose();
		self.accumulatePowerEffect_2 = nil;
	end
	self:superCall("dispose");
end

function Lua_JumpHappyPlayModelItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end
end

function Lua_JumpHappyPlayModelItem:updateAddScore(addScoreValue)
	self.addScoreTxt.text = addScoreValue;
	TweenUtil.getInstance():stop(self.addScoreTxt.mainContent);
	if addScoreValue ~= nil then
		self:resetAddScoreTxt();
		TweenUtil.getInstance():addTweenTargetAlpha(self.addScoreTxt.mainContent, self.addScoreTweenTime, 0, -1, false);
		TweenUtil.getInstance():addTween(self.addScoreTxt.mainContent, self.addScoreTweenTime, 0, 
                0, 304, 0, 
                0, 0, 0, 
                1, 1, 1, 
                nil, nil, 0, false);
	end
end

function Lua_JumpHappyPlayModelItem:resetAddScoreTxt()
	self.addScoreTxt:setLocation(0, 242);
	self.addScoreTxt:setAlpha(1);
end

function Lua_JumpHappyPlayModelItem:updateResidueNum()
	local maxLineNum = DataCenter.jumpingHappyData.maxLineNum or 0;
	local num = DataCenter.jumpingHappyData.curJumpNum or 0;
	num = maxLineNum - num;
	num = num > 0 and num or nil;
	self.residueNumTxt.text = num;
end

function Lua_JumpHappyPlayModelItem:setModelEffDir(bLeft)
	local dirAngle = bLeft and self.leftAngle or self.rightAngle;
	self.modelImg:setModelEffDir(dirAngle);

	self:showTestSp();
end

function Lua_JumpHappyPlayModelItem:setAction(actionId, endActId)
	actionId = actionId or 0;
	endActId = endActId or 0;
	-- if actionId == Lua_JumpHappyPlayWindow.Action_Idle then
	-- 	print("待机", debug.traceback());
	-- elseif actionId == Lua_JumpHappyPlayWindow.Action_Jump_Pre then
	-- 	print("下蹲", debug.traceback());
	-- elseif actionId == Lua_JumpHappyPlayWindow.Action_Jump_Ready then
	-- 	print("蓄力", debug.traceback());
	-- elseif actionId == Lua_JumpHappyPlayWindow.Action_Jump_Up then
	-- 	print("起跳", debug.traceback());
	-- elseif actionId == Lua_JumpHappyPlayWindow.Action_Jump_Sky then
	-- 	print("空中循环", debug.traceback());
	-- elseif actionId == Lua_JumpHappyPlayWindow.Action_Jump_Down then
	-- 	print("下落", debug.traceback());
	-- elseif actionId == Lua_JumpHappyPlayWindow.Action_Jump_Success then
	-- 	print("下落成功，下落缓冲", debug.traceback());
	-- elseif actionId == Lua_JumpHappyPlayWindow.Action_Jump_Fail then
	-- 	print("下落死亡", debug.traceback());
	-- elseif actionId == Lua_JumpHappyPlayWindow.Action_Pre_To_Ready then
	-- 	print("下蹲切蓄力", debug.traceback());
	-- elseif actionId == Lua_JumpHappyPlayWindow.Action_Pre_To_Up then
	-- 	print("下蹲切起跳", debug.traceback());
	-- elseif actionId == Lua_JumpHappyPlayWindow.Action_Ready_To_Up then
	-- 	print("蓄力切起跳", debug.traceback());
	-- elseif actionId == Lua_JumpHappyPlayWindow.Action_Up_To_Sky then
	-- 	print("起跳切空中", debug.traceback());
	-- elseif actionId == Lua_JumpHappyPlayWindow.Action_Up_To_Down then
	-- 	print("起跳切下落", debug.traceback());
	-- elseif actionId == Lua_JumpHappyPlayWindow.Action_Sky_To_Down then
	-- 	print("空中切下落", debug.traceback());
	-- elseif actionId == Lua_JumpHappyPlayWindow.Action_Down_To_Success then
	-- 	print("下落切成功", debug.traceback());
	-- elseif actionId == Lua_JumpHappyPlayWindow.Action_Down_To_Fail then
	-- 	print("下落切失败", debug.traceback());
	-- end
	self.modelImg:setAction(actionId, endActId);
end

function Lua_JumpHappyPlayModelItem:onModelAniComplete(endAct, endActName)
	print("onModelAniComplete", endAct);
end

function Lua_JumpHappyPlayModelItem:showTestSp()
	local bShow = DataCenter.jumpingHappyData.bTest
	if bShow then
		if self.testSp == nil then
			self.testSp = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_icon_41", 0, 0, 10, 10);
		end

		self.testSp:setEnable(true);
	else
		if self.testSp then
			self.testSp:setEnable(false);
		end
	end
end

function Lua_JumpHappyPlayModelItem:showCenterDisplay(bShow)
	TweenUtil.getInstance():stop(self.centerSp.mainContent);
	if bShow then
		self.centerSp:setEnable(true);
		self.centerSp:setAlpha(1);
		TweenUtil.getInstance():addTweenTargetAlpha(self.centerSp.mainContent, self.addScoreTweenTime, 0, -1, false);
	else
		self.centerSp:setEnable(false);
	end
end

function Lua_JumpHappyPlayModelItem:showAccumulatePower(bShow)
	if bShow then
		if self.accumulatePowerEffect_1 == nil then
			self.accumulatePowerEffect_1 = UICreate.createUIEffect(self.content, "/effects/uiEffects/ttl_tx", "ttl_xl_02", 0, 0);
			self.accumulatePowerEffect_1.siblingIndex = 0;
		end

		if self.accumulatePowerEffect_2 == nil then
			self.accumulatePowerEffect_2 = UICreate.createUIEffect(self.content, "/effects/uiEffects/ttl_tx", "ttl_xl_01", 0, 46);
			self.accumulatePowerEffect_2.siblingIndex = 0;
		end

		self.accumulatePowerEffect_1:setEnable(true);
		self.accumulatePowerEffect_2:setEnable(true);
	else
		if self.accumulatePowerEffect_1 then
			self.accumulatePowerEffect_1:setEnable(false);
		end
		if self.accumulatePowerEffect_2 then
			self.accumulatePowerEffect_2:setEnable(false);
		end
	end
end

function Lua_JumpHappyPlayModelItem:getModelSiblingIndex()
	if self._transform == nil then
		self._transform = self.content.transform;
	end
	return self._transform:GetSiblingIndex();
end






















----------------------------pointItem-------------------------------------
Lua_JumpHappyPlayPointItem = class("Lua_JumpHappyPlayPointItem", Lua_DisplayObject);
function Lua_JumpHappyPlayPointItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_JumpHappyPlayPointItem:buildShowItem()
	self:superCall("buildShowItem");

	self.pointSp = UICreate.createUIAtlasImage(self.content, "jump_happy_atlas", "xui_ttl_widget_6", 0, 0, 23, 22);
end

function Lua_JumpHappyPlayPointItem:checkArriveBlockItem(bArrive)
	local spriteStr;
	if bArrive then
		spriteStr = "xui_ttl_widget_7";
	else
		spriteStr = "xui_ttl_widget_6";
	end

	self.pointSp:setAltas("jump_happy_atlas", spriteStr);
	self.pointSp:resetSize();
end

function Lua_JumpHappyPlayPointItem:dispose()
	if self.pointSp then
		self.pointSp:dispose();
		self.pointSp = nil;
	end
	self:superCall("dispose");
end
