-- 排名奖励界面
Lua_JumpHappyRankRewardWindow = class("Lua_JumpHappyRankRewardWindow", Lua_Window);
function Lua_JumpHappyRankRewardWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.windowName = "Lua_JumpHappyRankRewardWindow";
	self.skinName = "JumpHappyRankRewardWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_JumpHappyRankRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.actIdx = DataCenter.jumpingHappyData.activity_id;
	self.titleNameTxt:setLangValue(791006);
	self.descTxt:setLangValue(791007);
	self.dragList = Lua_DragList.new(self.content, 630, 564, Lua_AxisDefine.Vertical);
	self.dragList:setListCell(Lua_JumpHappyRankRewardItem, 629, 121, 1);
    self.dragList:setLocation(0, -50, 0);

    -- self.rankSp:addClickFuntion(self, self.onClickRankSp);
	self:addLuaEvent("UPDATE_JUMPINGHAPPY_RANK_REWARD_INFO", self, self.updateRewardInfo);

	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sJumpingHappyRankRewardInfo(self.actIdx);
end

function Lua_JumpHappyRankRewardWindow:dispose()
	if self.dragList then
		self.dragList:dispose();
		self.dragList = nil;
	end
	if self.myRewards then
		self.myRewards:dispose();
		self.myRewards = nil;
	end
	self:superCall("dispose");
end

-- function Lua_JumpHappyRankRewardWindow:onClickRankSp()
-- 	local actVo = DataCenter.backstageActData:getActVoByIdx(self.actIdx);
-- 	if DataCenter.backstageActData:checkActIsEnd(actVo) then
-- 		self:hide();
-- 		return;
-- 	end

-- 	if self.clickTime and getTime() - self.clickTime < 0.5 then
-- 		return;
-- 	end
-- 	self.clickTime = getTime();

-- 	DataCenter.funcPathUtil:gotoFunction(1187);
-- end

function Lua_JumpHappyRankRewardWindow:updateRewardInfo(msg)
	self.dragList:setArrayData(msg.rank_reward);

	local rankStr;
	local rankNum = msg.self_rank;
	local checkNone = rankNum == 0;
	if checkNone then
		rankStr = LanUtil.getValue(791008);
	else
		rankStr = rankNum;
	end
	self.rankNumTxt.text = rankStr;

	if checkNone ~= true then
		if self.myRewards == nil then
			self.myRewards = Lua_DragList.new(self.content, 403, 89, Lua_AxisDefine.Horizontal);
			self.myRewards:setListCell(Lua_JumpHappyRankRewardSubItem, 89, 89, 1);
	    	self.myRewards:setLocation(94, -411, 0);
		end
		self.myRewards:setEnable(true);
		self.myRewards:setArrayData(msg.self_rank_reward);
	else
		if self.myRewards then
			self.myRewards:setEnable(false);
		end
	end
end



























----------------------------排名奖励Item-------------------------------------
Lua_JumpHappyRankRewardItem = class("Lua_JumpHappyRankRewardItem", Lua_ListCell);
function Lua_JumpHappyRankRewardItem:ctor(p)
	self:superCall("ctor", p, "JumpHappyRankRewardItem_skin");
end

function Lua_JumpHappyRankRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 403, 89, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_JumpHappyRankRewardSubItem, 89, 89, 1);
    self.rewardList:setLocation(94, 0, 0);
    self:setSubList(self.rewardList);
end

function Lua_JumpHappyRankRewardItem:dispose()
	self.data = nil;
	if self.rewardList then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self:superCall("dispose");
end

function Lua_JumpHappyRankRewardItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.rewardList:setArrayData(data.reward);
	self:updateRankNum();
end

function Lua_JumpHappyRankRewardItem:updateRankNum()
	local sprite;
	local rankStr;
	local rankNum;
	if self.data.rank_left == self.data.rank_right then
		rankNum = self.data.rank_left;
	else
		rankNum = LanUtil.formateStr(791009, self.data.rank_left, self.data.rank_right);
	end

	if rankNum == "1" then
		sprite = "xui_jys_label_10";
	elseif rankNum == "2" then
		sprite = "xui_jys_label_11";
	elseif rankNum == "3" then
		sprite = "xui_jys_label_12";
	else
		rankStr = rankNum;
		sprite = "xui_jys_label_13";
	end
	self.rankNumTxt.text = rankStr;
	self.rankNumBg:setAltas("common_altas_4", sprite);
end










-------------------------------------
Lua_JumpHappyRankRewardSubItem = class("Lua_JumpHappyRankRewardSubItem", Lua_ItemIconCell)
function Lua_JumpHappyRankRewardSubItem:buildShowItem()
	self:superCall("buildShowItem")

	self.itemIcon:setScale(0.7, 0.7, 1)
end

function Lua_JumpHappyRankRewardSubItem:setData(data)
	self.data = data;
	if data == nil then
		self.tvo = nil;
		return;
	end

	if self.tvo == nil then
		self.tvo = Lua_ToolVo.createToolVo(data.key, data.value);
	else
		self.tvo:setData(data.key, data.value);
	end
	
	self.itemIcon:setData(self.tvo);
end

function Lua_JumpHappyRankRewardSubItem:onPressClick()
    if self.data == nil or self.tvo == nil then
        return;
    end

    DataCenter.packUtil:showItemInfo(self.tvo);
end

function Lua_JumpHappyRankRewardSubItem:dispose()
	self.data = nil;
	self.tvo = nil;
	if self.itemIcon then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self:superCall("dispose");
end
