Lua_JumpHappyShoppingWindow = class("Lua_JumpHappyShoppingWindow", Lua_Window);
function Lua_JumpHappyShoppingWindow:ctor(p)
	self:superCall("ctor");

	self.windowName = "Lua_JumpHappyShoppingWindow";
	self.skinName = "JumpHappyShoppingWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_JumpHappyShoppingWindow:buildShowItem()
	self:superCall("buildShowItem");

	local activity_id = DataCenter.jumpingHappyData.activity_id;
	self.act_vo = DataCenter.backstageActData:getActVoByIdx(activity_id);

	self.minCount = 1;
	self.maxCount = DataCenter.jumpingHappyData.buy_times or 1;
	self.selectCount = 1;
	self.costId = DataCenter.jumpingHappyData.costId;
	self.costNum = DataCenter.jumpingHappyData.costNum;
	local tvo = Lua_ToolVo.createToolVo(self.costId);
	self.costSp:setAltas(tvo.atlas, tvo.sprite);
	self:updateLimitMaxCount();
	self:updateCostTxt();

	self.numberInputItem = Lua_NumberInputItem.new(self.content);
	self.numberInputItem:setLocation(0, 16);
	self.numberInputItem:setCallBack(self, self.updateCount);
	self.numberInputItem:setMinMaxEnable(false, false);
	self.numberInputItem:setValue(self.selectCount, self.minCount, self.maxCount);

	self.btnSure:addClickFuntion(self, self.onClickSureBtn);
end

function Lua_JumpHappyShoppingWindow:dispose()
	self.act_vo = nil;
	if self.numberInputItem then
		self.numberInputItem:dispose();
		self.numberInputItem = nil;
	end
	self:superCall("dispose");
end

function Lua_JumpHappyShoppingWindow:updateLimitMaxCount()
	local hasCount = DataCenter.packData:getItemCountById(self.costId);
	local count = hasCount == 0 and 0 or Mathf.Floor(hasCount / self.costNum);
	self.canShop = count > 0;
	self.btnSure:setGray(self.canShop ~= true);
	if count <= 0 then
		count = 1;
	end

	count = count > self.maxCount and self.maxCount or count;
	self.maxCount = count;
end

function Lua_JumpHappyShoppingWindow:updateCostTxt()
	self.totalCostNum = self.selectCount * self.costNum;
	self.totalPriceTxt.text = self.totalCostNum;
end

function Lua_JumpHappyShoppingWindow:updateCount(count)
	self.selectCount = count;

	self:updateCostTxt();
end

function Lua_JumpHappyShoppingWindow:onClickSureBtn()
	if DataCenter.backstageActData:checkActIsEnd(self.act_vo) then
		self:hide();
		return;
	end

	if self.canShop ~= true then
		OperateAlert.showLangValue(791013);
		return;
	end

	if self.clickTime and getTime() - self.clickTime < 0.5 then
		return;
	end
	self.clickTime = getTime();

	if not self:openTipWins() then
		self:sendServer();
	end
end

function Lua_JumpHappyShoppingWindow:openTipWins()
	if DataCenter.neverTipData:getNeverValue(Lua_NeverTipDefine.JUMPINGHAPPY_SHOP) then
        return false;
    else
    	local str = spliceIconStrById(self.costId);
    	str = LanUtil.formateStr(791014, str, self.totalCostNum)
		local tipsData = { des = str, posY = 30, neverTip = Lua_NeverTipDefine.JUMPINGHAPPY_SHOP,
            btnType = 1, sureLabel = 791015, owner = self, cancelFun = self.hide, sureFun = self.sendServer
        };
        Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
        return true;
	end
end

function Lua_JumpHappyShoppingWindow:sendServer()
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sJumpingHappyPlayCount(self.act_vo.actIdx, self.selectCount);
	self:hide();
end

