-- 浣熊跳跳乐任务界面
Lua_JumpHappyTaskWindow = class("Lua_JumpHappyTaskWindow", Lua_Window);
function Lua_JumpHappyTaskWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_JumpHappyTaskWindow";
	self.skinName = "JumpHappyTaskWindow_skin";
	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.showClose = true;
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_JumpHappyTaskWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.actIdx = DataCenter.jumpingHappyData.activity_id;
	local arr = Array();
	arr:add({textStr = 791016, redPointId = Lua_RedPointList.JumpHappy_Task_Day});
	arr:add({textStr = 791017, redPointId = Lua_RedPointList.JumpHappy_Task_Total});

	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList:setButtonStyle("common_altas_1", "xui_common_tab_002", "xui_common_tab_001", 133, 77);
	self.btnList:setButtonText(0, 10, "7A6A5F", "8F5123", 28, 28, Lua_MyUISettings.huakangFontName);
	self.btnList:setRedPoint(56, 25);
	self.btnList:setButtonItem(135, 77);
	self.btnList:setSiblingIndex(0);
	self.btnList:setRectPivot(3);
	self.btnList:setLocation(-330, -570, 0);
	self.btnList:setClickCallBack(self, self.onBtnClick);
	self.btnList:setData(arr);

	self.taskList = Lua_DragList.new(self.content, 628, 700, Lua_AxisDefine.Vertical);
	-- self.taskList.tweenId = 2023;
	-- self.taskList.delayTween = true;
	self.taskList:setListCell(Lua_JumpHappyTaskItem, 628, 143, 1);
	self.taskList:setCellSpacing(0, 4);
	self.taskList:setLocation(0, -141, 0);

	self:addLuaEvent("UPDATE_JUMPINGHAPPY_TASK_INFO", self, self.updateTaskInfo);
	self:addLuaEvent("ON_JUMPHAPPY_DRAWREWARD_CLICK", self, self.onJumpHappyDrawRewardClick);

	self.btnList:setSelected(1);
end

-- function Lua_JumpHappyTaskWindow:showWin(param)
-- 	self:superCall("showWin", param);

-- 	self.btnList:setSelected(1);
-- end

function Lua_JumpHappyTaskWindow:onBtnClick(val)
	self.taskList.showTween = true;
	self.taskType = val;
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sJumpingHappyTaskInfo(self.actIdx, val);
end

function Lua_JumpHappyTaskWindow:updateTaskInfo(msg)
	if msg == nil or msg.type ~= self.taskType then
		return;
	end

	-- 可领取＞未达成＞已领取，info1：0未完成 1可领取 2已领取
	table.sort( msg.task_info,
		function(a, b)
			if a.info1 == b.info1 then
				return a.task_id < b.task_id;
			else
				local aWeight = (a.info1 + 1) % 3;
				local bWeight = (b.info1 + 1) % 3;
				return aWeight > bWeight;
			end
		end
	);
	self.taskList:setArrayData(msg.task_info);
	self.taskList:moveToIndex(1, true);
end

function Lua_JumpHappyTaskWindow:onJumpHappyDrawRewardClick(task_id)
	local actVo = DataCenter.backstageActData:getActVoByIdx(self.actIdx);
	if DataCenter.backstageActData:checkActIsEnd(actVo) then
		self:hide();
		return;
	end

	if self.taskType == nil or task_id == nil then
		return;
	end

	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sJumpingHappyTaskReward(self.actIdx, self.taskType, task_id);
end

function Lua_JumpHappyTaskWindow:dispose()
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.taskList ~= nil then
		self.taskList:dispose();
		self.taskList = nil;
	end
	self:superCall("dispose");
end










Lua_JumpHappyTaskItem = class("Lua_JumpHappyTaskItem", Lua_ListCell);
function Lua_JumpHappyTaskItem:ctor(p)
	self:superCall("ctor", p, "JumpHappyTaskItem_skin");
end

function Lua_JumpHappyTaskItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 360, 87, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_JumpHappyTaskRewardItem, 87, 87, 1);
	self.rewardList:setCellSpacing(9, 0);
	self.rewardList:setRectPivot(3);
	self.rewardList:setLocation(-280, -16, 0);
	self:setSubList(self.rewardList);

	self.stateBtn:addClickFuntion(self, self.onDrawRewardClick);
end

function Lua_JumpHappyTaskItem:setData(data)
	self.data = data;
	if self.data == nil then
		return;
	end

	self.titleTxt.text = data.dec;
	self.rewardList.canDrag = #data.award > 3;
	self.rewardList:setArrayData(data.award);
	self.progressBar:setMaxValue(data.info2);
	self.progressBar:setValue(data.info3);

	local str = LanUtil.formateStr(791020, data.info3, data.info2);
	self.progressBar:setText(str);

	if data.info1 == 0 then
		self.stateBtn:setLangValue(791018);
		self.stateBtn:setMouseEnable(false);
		self.stateBtn:setStyle(16);
	elseif data.info1 == 1 then
		self.stateBtn:setLangValue(791019);
		self.stateBtn:setMouseEnable(true);
		self.stateBtn:setStyle(1);
	end
	self.progressBar:setEnable(data.info1 ~= 2);
	self.stateBtn:setEnable(data.info1 ~= 2);
	self.drawedIcon:setEnable(data.info1 == 2);
end

function Lua_JumpHappyTaskItem:onDrawRewardClick(go)
	if self.data == nil then
		return;
	end

	if self.clickTime and getTime() - self.clickTime < 0.5 then
		return;
	end
	self.clickTime = getTime();

	Lua_MsgUtil.callFunc("ON_JUMPHAPPY_DRAWREWARD_CLICK", self.data.task_id);
end

function Lua_JumpHappyTaskItem:dispose()
	self.data = nil;
	if self.rewardList then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self:superCall("dispose");
end










Lua_JumpHappyTaskRewardItem = class("Lua_JumpHappyTaskRewardItem", Lua_ItemIconCell);
function Lua_JumpHappyTaskRewardItem:buildShowItem()
	self:superCall("buildShowItem");
	self.itemIcon:setScale(0.7, 0.7);
end