-- 登录福利-激活超值奖励界面
Lau_LoginRewardActRechargeWindow = class("Lau_LoginRewardActRechargeWindow", Lua_Window);
function Lau_LoginRewardActRechargeWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lau_LoginRewardActRechargeWindow";
	self.skinName = "LoginRewardActRechargeWindow_skin";
	self.layer = Lua_MainWinDefine.TIPS_WINDOW_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
	self.showCloseText = true;
	self.closeTextPosY = -440;
end

function Lau_LoginRewardActRechargeWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.desTxt:setLangValue(783011);
	self.titleTxt_1:setLangValue(783012);
	self.titleTxt_2:setLangValue(783013);

	-- 立得奖励
	self.instantList = Lua_DragList.new(self.content, 510, 124, Lua_AxisDefine.Horizontal);
	self.instantList:setListCell(Lau_LoginRewardActRechargeItem, 124, 124, 1);
	self.instantList:setCellSpacing(14, 0);
	-- 累计奖励
	self.totalList = Lua_DragList.new(self.content, 510, 124, Lua_AxisDefine.Horizontal);
	self.totalList:setListCell(Lau_LoginRewardActRechargeItem, 124, 124, 1);
	self.totalList:setCellSpacing(14, 0);

	self.rechargeBtn:addClickFuntion(self, self.onRechargeClick);
	self:addLuaEvent("UPDATE_LOGINREWARD_INFO", self, self.updateShowInfo);
	self:updateShowInfo();
end

function Lau_LoginRewardActRechargeWindow:showWin(param)
	self:superCall("showWin", param);

	local arr = DataCenter.loginRewardData.instantRewardArr;
	local len = arr:getSize();
	local posX = len > 3 and 0 or (510 - len * 138 + 14) / 2;
	self.instantList.canDrag = len > 3;
	self.instantList:setArrayData(arr);
	self.instantList:setLocation(posX, 92, 0);

	arr = DataCenter.loginRewardData.totalRewardArr;
	len = arr:getSize();
	posX = len > 3 and 0 or (510 - len * 138 + 14) / 2;
	self.totalList.canDrag = len > 3;
	self.totalList:setArrayData(arr);
	self.totalList:setLocation(posX, -112, 0);
end

function Lau_LoginRewardActRechargeWindow:updateShowInfo()
	if DataCenter.loginRewardData.isLock then
		local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(DataCenter.loginRewardData.rechargeId);
		self.rechargeBtn.label = LanUtil.formateStr(783014, tonumber(rechargeInfo.money));
		self.rechargeBtn:setStyle(1);
	else
		self.rechargeBtn:setLangValue(783015);
		self.rechargeBtn:setStyle(16);
	end
end

function Lau_LoginRewardActRechargeWindow:onRechargeClick(go)
	if DataCenter.loginRewardData.isLock then
		local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(DataCenter.loginRewardData.rechargeId);
		DataCenter.sdkInterface:PointOut(1, tonumber(rechargeInfo.money), tonumber(rechargeInfo.money_type),
			tonumber(rechargeInfo.id), rechargeInfo.gift_name, rechargeInfo.gold);
		self:hide();
	else
		OperateAlert.showLangValue(783015);
	end
end

function Lau_LoginRewardActRechargeWindow:dispose()
	if self.totalList then
		self.totalList:dispose()
		self.totalList = nil
	end
	self:superCall("dispose")
end










Lau_LoginRewardActRechargeItem = class("Lau_LoginRewardActRechargeItem", Lua_ItemIconCell);
function Lau_LoginRewardActRechargeItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lau_LoginRewardActRechargeItem:onPressClick()
	local checkItem = self:checkClick();
	if self.pressItem ~= nil and checkItem == self.pressItem then
		self.pressItem:onItemClick();
	end
end

function Lau_LoginRewardActRechargeItem:checkClick()
	local winPos = LuaUtil.getTouchPosInverseObj(self.mainContent);
	if self.itemIcon.isActive and self.itemIcon:checkInBound(winPos.x, winPos.y) then
		return self.itemIcon;
	end
	return nil;
end

function Lau_LoginRewardActRechargeItem:onMouseDownHandle()
	self.pressItem = self:checkClick();
	if self.pressItem ~= nil then
		self.pressItem:setScale(0.9, 0.9);
	end
end

function Lau_LoginRewardActRechargeItem:onMouseUpHandle()
	if self.pressItem ~= nil then
		self.pressItem:setScale(1, 1);
	end
end