-- 登录福利-登录
Lau_LoginRewardOfLoginPanel = class("Lau_LoginRewardOfLoginPanel", Lua_DisplayObject);
function Lau_LoginRewardOfLoginPanel:ctor(p)
	self:superCall("ctor", p, "LoginRewardOfLoginPanel_skin");
end

function Lau_LoginRewardOfLoginPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.dayList = Lua_DragList.new(self.content, 700, 730 + self.adaptHeight, Lua_AxisDefine.Vertical);
	-- self.dayList.tweenId = 2002;
	self.dayList:setListCell(Lau_LoginRewardOfLoginItem, 700, 135, 1);
	self.dayList:setCellSpacing(0, 8);
	self.dayList:setLocation(0, -165, 0);

	self.rechargeBg:addClickFuntion(self, self.onRechargeClick);
	self.drawBtn:addClickFuntion(self, self.onDrawClick);
end

function Lau_LoginRewardOfLoginPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
	self.dayList:setContentRect(700, 730 + adaptHeight);
end

function Lau_LoginRewardOfLoginPanel:updateData()
	if DataCenter.loginRewardData.isLock then
		local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(DataCenter.loginRewardData.rechargeId);
		self.rechargeTipsTxt.text = LanUtil.formateStr(783002, tonumber(rechargeInfo.money));
	else
		self.rechargeTipsTxt:setLangValue(783003);
	end
	self.rechargeLockIcon:setEnable(DataCenter.loginRewardData.isLock);
	self.drawBtn:setGray(not DataCenter.loginRewardData.loginRedState);
	self.dayList:setArrayData(DataCenter.loginRewardData.loginIdArr);
end

function Lau_LoginRewardOfLoginPanel:onRechargeClick()
	if DataCenter.loginRewardData.isLock then
		Lua_MsgUtil.callFunc("ON_LOGINREWARD_OPEN_UPGRADEREWARD_CLICK");
	else
		OperateAlert.showLangValue(783015);
	end
end

function Lau_LoginRewardOfLoginPanel:onDrawClick(go)
	if DataCenter.loginRewardData.loginRedState then
		Lua_MsgUtil.callFunc("ON_LOGINREWARD_DREWARD_LOGINREWARD_CLICK");
	else
		OperateAlert.showLangValue(783004);
	end
end

function Lau_LoginRewardOfLoginPanel:dispose()
	if self.dayList ~= nil then
		self.dayList:dispose();
		self.dayList = nil;
	end
	self:superCall("dispose");
end










Lau_LoginRewardOfLoginItem = class("Lau_LoginRewardOfLoginItem", Lua_ListCell);
function Lau_LoginRewardOfLoginItem:ctor(p)
	self:superCall("ctor", p, "LoginRewardOfLoginItem_skin");
end

function Lau_LoginRewardOfLoginItem:buildShowItem()
	self:superCall("buildShowItem");

	-- 签到奖励
	self.loginItemArr = Array();
	-- 超值奖励
	self.upgradeList = Lua_DragList.new(self.content, 195, 90, Lua_AxisDefine.Horizontal);
	self.upgradeList:setListCell(Lau_LoginRewardOfLoginRewardItem, 90, 90, 1);
	self.upgradeList:setSiblingIndex(1);
	self.upgradeList:setRectPivot(3);
	self.upgradeList:setCellSpacing(3, 0);
	self.upgradeList:setLocation(-53, 0, 0);
	self:setSubList(self.upgradeList);

	self.drawBtn:addClickFuntion(self, self.onDrawClick);
end

function Lau_LoginRewardOfLoginItem:setData(data)
	self._data = DataCenter.loginRewardData:getLoginReward(data);
	if data == nil or self._data == nil then
		return;
	end

	local signinReward = self._data.signinReward or {};
	local signinRewardList = signinReward.item or {};
	local hasLen = self.loginItemArr:getSize();
	local dataLen = #signinRewardList;
	local maxLen = dataLen > hasLen and dataLen or hasLen;
	local item;
	for i = 1, maxLen do
		item = self.loginItemArr[i];
		if i > dataLen then
			if item ~= nil then
				item:setEnable(false);
			end
		else
			if item == nil then
				item = Lau_LoginRewardOfLoginRewardItem.new(self.content);
				item.contentName = "Lau_LoginRewardOfLoginRewardItem"..i;
				item:setLocation(-210 + (i - 1) * 93, 0, 0);
				self.loginItemArr:add(item);
			end
			item:setEnable(true);
			item:setData({
				id = signinReward.id,
				state = signinReward.state,
				rewardType = 1,
				itemData = signinRewardList[i]
			});
		end
	end

	local upgradeReward = self._data.upgradeReward or {};
	local upgradeRewardList = upgradeReward.item or {};
	local arr = Array();
	for i = 1, #upgradeRewardList do
		arr:add({
			id = upgradeReward.id,
			state = upgradeReward.state,
			rewardType = 2,
			itemData = upgradeRewardList[i];
		})
	end
	self.upgradeList.canDrag = #upgradeRewardList > 2;
	self.upgradeList:setArrayData(arr);

	self.drawState = 0;
	if signinReward.state == 0 and upgradeReward.state == 0 then
		self.stateIcon:setAltas("login_reward_atlas", "xui_dlfl_label_1");
		self.stateIcon:setEnable(true);
		self.drawBtn:setEnable(false);
	else
		local isShowBtn = true;
		if signinReward.state == 1 or upgradeReward.state == 1 then
			self.drawState = 1;
			self.drawBtn:setLangValue(783005);
		else
			if signinReward.state == 2 and DataCenter.loginRewardData.isLock then
				self.drawState = 2;
				self.drawBtn:setLangValue(783006);
			else
				self.drawState = 3;
				isShowBtn = false;
			end
		end
		self.stateIcon:setAltas("common_altas_1", "xui_common_label_12");
		self.stateIcon:setEnable(not isShowBtn);
		self.drawBtn:setEnable(isShowBtn);
	end
	self.dayTxt.text = signinReward.title1;
	self.rechargeMask:setEnable(DataCenter.loginRewardData.isLock);
end

function Lau_LoginRewardOfLoginItem:onDrawClick(go)
	if self.drawState == 1 then
		Lua_MsgUtil.callFunc("ON_LOGINREWARD_DREWARD_LOGINREWARD_CLICK");
	elseif self.drawState == 2 then
		Lua_MsgUtil.callFunc("ON_LOGINREWARD_OPEN_UPGRADEREWARD_CLICK");
	elseif self.drawState == 3 then
		OperateAlert.showLangValue(783004);
	end
end

function Lau_LoginRewardOfLoginItem:onPressClick()
	local checkItem = self:checkClick();
	if self.pressItem ~= nil and checkItem == self.pressItem then
		self.pressItem:onUpClick();
	end
end

function Lau_LoginRewardOfLoginItem:checkClick()
	if self._data == nil then
		return nil;
	end

	local item, winPos;
	for i = 1, self.loginItemArr:getSize() do
		item = self.loginItemArr[i];
		winPos = LuaUtil.getTouchPosInverseObj(item.mainContent);
		if item.isActive and item.rewardItem:checkInBound(winPos.x, winPos.y) then
			return item;
		end
	end
	local showArr = self.upgradeList.showList;
	for i = 1, showArr:getSize() do
		winPos = LuaUtil.getTouchPosInverseObj(self.upgradeList.sub);
		if showArr[i].isActive then
			if showArr:getSize() > 2 then
				if showArr[i].rewardItem:checkInBound(winPos.x, winPos.y) then
					return showArr[i];
				end
			else
				if showArr[i]:checkInBound(winPos.x, winPos.y) then
					return showArr[i];
				end
			end
		end
	end
	return nil;
end

function Lau_LoginRewardOfLoginItem:onMouseDownHandle()
	self.pressItem = self:checkClick();
	if self.pressItem ~= nil then
		self.pressItem:setScale(0.9, 0.9);
	end
end

function Lau_LoginRewardOfLoginItem:onMouseUpHandle()
	if self.pressItem ~= nil then
		self.pressItem:setScale(1, 1);
	end
end

function Lau_LoginRewardOfLoginItem:dispose()
	if self.loginItemArr ~= nil then
		self.loginItemArr:dispose();
		self.loginItemArr:clear();
		self.loginItemArr = nil;
	end
	if self.upgradeList ~= nil then
		self.upgradeList:dispose();
		self.upgradeList = nil;
	end
	self._data = nil;
	self.pressItem = nil;
	self:superCall("dispose");
end










Lau_LoginRewardOfLoginRewardItem = class("Lau_LoginRewardOfLoginRewardItem", Lua_ListCell);
function Lau_LoginRewardOfLoginRewardItem:ctor(p)
	self:superCall("ctor", p);
end

function Lau_LoginRewardOfLoginRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardItem = Lua_ItemIcon.new(self.content);
	self.rewardItem:setCanClick(false);
end

function Lau_LoginRewardOfLoginRewardItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local redState = false;
	local drawState = false;
	if data.rewardType == 1 then
		redState = data.state == 1;
		drawState = data.state == 2;
	else
		redState = data.state == 1 and not DataCenter.loginRewardData.isLock;
		drawState = data.state == 2 and not DataCenter.loginRewardData.isLock;
	end
	local tvo = Lua_ToolVo.createToolVo(data.itemData.id, data.itemData.amount);
	tvo:fromServer(data.itemData);
	self.rewardItem:setData(tvo);
	self.rewardItem:setScale(0.72, 0.72);
	-- self.rewardItem:setEquipLock(data.rewardType == 2 and DataCenter.loginRewardData.isLock, -48, 45);
	self.rewardItem:setDrawMask(drawState);

	self:showRedDot(redState);-- 已解锁可领取
end

function Lau_LoginRewardOfLoginRewardItem:showRedDot(bShow)
	if bShow then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:createRedPointEff();
			self.redPoint:setLocation(27, 27, 0);
			self.redPoint:setScale(0.9, 0.9);
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lau_LoginRewardOfLoginRewardItem:onUpClick()
	if self._data == nil then
		return;
	end

	if self._data.rewardType == 1 then
		if self._data.state == 1 then
			Lua_MsgUtil.callFunc("ON_LOGINREWARD_DREWARD_LOGINREWARD_CLICK");
		else
			DataCenter.packUtil:showItemInfo(self.rewardItem.data);
		end
	else
		if DataCenter.loginRewardData.isLock then
			Lua_MsgUtil.callFunc("ON_LOGINREWARD_OPEN_UPGRADEREWARD_CLICK");
		else
			if self._data.state == 1 then
				Lua_MsgUtil.callFunc("ON_LOGINREWARD_DREWARD_LOGINREWARD_CLICK");
			else
				DataCenter.packUtil:showItemInfo(self.rewardItem.data);
			end
		end
	end
end

function Lau_LoginRewardOfLoginRewardItem:onPressClick()
	local checkItem = self:checkClick();
	if self.pressItem ~= nil and checkItem == self.pressItem then
		self:onUpClick();
	end
end

function Lau_LoginRewardOfLoginRewardItem:checkClick()
	local winPos = LuaUtil.getTouchPosInverseObj(self.mainContent);
	if self.isActive and self.rewardItem:checkInBound(winPos.x, winPos.y) then
		return self.rewardItem;
	end
	return nil;
end

function Lau_LoginRewardOfLoginRewardItem:onMouseDownHandle()
	self.pressItem = self:checkClick();
	if self.pressItem ~= nil then
		self.pressItem:setScale(0.65, 0.65);
	end
end

function Lau_LoginRewardOfLoginRewardItem:onMouseUpHandle()
	if self.pressItem ~= nil then
		self.pressItem:setScale(0.72, 0.72);
	end
end

function Lau_LoginRewardOfLoginRewardItem:dispose()
	if self.rewardItem ~= nil then
		self.rewardItem:dispose();
		self.rewardItem = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end