-- 登录福利-七天累充
Lau_LoginRewardOfRechargePanel = class("Lau_LoginRewardOfRechargePanel", Lua_DisplayObject);
function Lau_LoginRewardOfRechargePanel:ctor(p)
	self:superCall("ctor", p, "LoginRewardOfRechargePanel_skin");
end

function Lau_LoginRewardOfRechargePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.rechargeList = Lua_DragList.new(self.content, 700, 800 + self.adaptHeight, Lua_AxisDefine.Vertical);
	-- self.rechargeList.tweenId = 2002;
	self.rechargeList:setListCell(Lau_LoginRewardOfRechargeItem, 700, 166, 1);
	self.rechargeList:setCellSpacing(0, 10);
	self.rechargeList:setLocation(0, -90, 0);
end

function Lau_LoginRewardOfRechargePanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
	self.rechargeList:setContentRect(700, 800 + adaptHeight);
end

function Lau_LoginRewardOfRechargePanel:updateData()
	local rearDay = DataCenter.loginRewardData.rearDay;
	local list = DataCenter.loginRewardData.rechargeRewardList;
	local money = list[1].value1;
	self.tipsTxt.text = LanUtil.formateStr(783007, rearDay, money);
	self.tipsTxt:resetSize();
	if self.tipsTxt.width > 640 then
		self.tipsTxt:setEnable(false);
		if self.scrollText == nil then
			self.scrollText = Lua_ScrollText.new(self.content, Lua_AxisDefine.Horizontal, 640, 31);
			self.scrollText:setTextStyle(640, 31, Lua_MyUISettings.defaultFontName, 22, "FFFFFF", 0, "FFFFFF");
			self.scrollText:setRectAnchor(7);
			self.scrollText:setLocation(0, 202, 0);
		end
		self.scrollText:setEnable(true);
		self.scrollText:setShowTxt(self.tipsTxt.text);
	else
		self.tipsTxt:setEnable(true);
		if self.scrollText then
			self.scrollText:setEnable(false);
		end
	end

	self.rechargeTxt.text = LanUtil.formateStr(783008, DataCenter.loginRewardData.totalDay);
	self.rechargeList:setArrayData(list);
end

function Lau_LoginRewardOfRechargePanel:dispose()
	if self.rechargeList ~= nil then
		self.rechargeList:dispose();
		self.rechargeList = nil;
	end
	if self.scrollText ~= nil then
		self.scrollText:dispose();
		self.scrollText = nil;
	end
	self:superCall("dispose");
end










Lau_LoginRewardOfRechargeItem = class("Lau_LoginRewardOfRechargeItem", Lua_ListCell);
function Lau_LoginRewardOfRechargeItem:ctor(p)
	self:superCall("ctor", p, "LoginRewardOfRechargeItem_skin");
end

function Lau_LoginRewardOfRechargeItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 430, 90, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lau_LoginRewardOfRechargeRewardItem, 90, 90, 1);
	self.rewardList:setRectPivot(3);
	self.rewardList:setCellSpacing(10, 0);
	self.rewardList:setLocation(-320, -18, 0);
	self:setSubList(self.rewardList);

	self.stateBtn:addClickFuntion(self, self.onBtnClick);
end

function Lau_LoginRewardOfRechargeItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.titleTxt.text = data.title1;

	local showVal = data.value2 >= data.value1 and data.value1 or data.value2;
	local colorStr = showVal >= data.value1 and "52965D" or "ED4C30";
	self.progressBar:setMaxValue(data.value1);
	self.progressBar:setValue(showVal);
	self.progressBar:setText(showVal .."/".. data.value1);

	self.rewardList.canDrag = #data.item > 4;
	self.rewardList:setArrayData(data.item);

	if data.state == 0 then -- 未解锁
		self.stateIcon:setAltas("login_reward_atlas", "xui_dlfl_label_1");
		self.stateBtn:setEnable(false);
		self.progressBar:setEnable(false);
		self.stateIcon:setEnable(true);
	else
		self.stateIcon:setAltas("common_altas_1", "xui_common_label_12");
		if data.state == 1 then
			self.stateBtn:setLangValue(783009);
		else
			self.stateBtn:setLangValue(783010);
		end
		self.stateBtn:setEnable(data.state ~= 2);
		self.progressBar:setEnable(data.state ~= 2);
		self.stateIcon:setEnable(data.state == 2);
	end
end

function Lau_LoginRewardOfRechargeItem:onBtnClick(go)
	if self._data == nil then
		return;
	end
	if self._data.state == 1 then
		Lua_MsgUtil.callFunc("ON_LOGINREWARD_DREWARD_RECHARGEREWARD_CLICK", self._data.id);
	else
		DataCenter.funcPathUtil:gotoFunction(1024);
	end
end

function Lau_LoginRewardOfRechargeItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self:superCall("dispose");
end










Lau_LoginRewardOfRechargeRewardItem = class("Lau_LoginRewardOfRechargeRewardItem", Lua_ItemIconCell);
function Lau_LoginRewardOfRechargeRewardItem:buildShowItem()
	self:superCall("buildShowItem");
	self.itemIcon:setScale(0.72, 0.72);
end