-- 登录福利
checkRequire("Lau_LoginRewardOfLoginPanel");
checkRequire("Lau_LoginRewardOfRechargePanel");
Lua_LoginRewardPanel = class("Lua_LoginRewardPanel", Lua_DisplayObject);
function Lua_LoginRewardPanel:ctor(p, skinName)
	self:superCall("ctor", p, skinName);
end

function Lua_LoginRewardPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.ruleBtn:addClickFuntion(self, self.onRuleClick);
	self:addLuaEvent("UPDATE_LOGINREWARD_INFO", self, self.updateLoginRewardInfo);
	self:addLuaEvent("ON_LOGINREWARD_ITEM_CLICK", self, self.showLoginRewardInfo);
	self:addLuaEvent("ON_LOGINREWARD_DREWARD_LOGINREWARD_CLICK", self, self.onDrawLoginRewardClick);
	self:addLuaEvent("ON_LOGINREWARD_OPEN_UPGRADEREWARD_CLICK", self, self.onOpenUpgradeRewardClick);
	self:addLuaEvent("ON_LOGINREWARD_DREWARD_RECHARGEREWARD_CLICK", self, self.onDrawRechargeRewardClick);
end

function Lua_LoginRewardPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
	if self.showPanel then
		self.showPanel:onScreenResize(adaptHeight);
	end
end

function Lua_LoginRewardPanel:setData(actVo)
	self.actVo = actVo;
	self:startTimer();
	self:updateLeftTime();
end

function Lua_LoginRewardPanel:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		self:addTimer("Lua_LoginRewardPanel", 1, self, self.updateLeftTime);
	end
end

function Lua_LoginRewardPanel:updateLeftTime()
	local time = self.actVo.residueTime;
	if time <= 0 then
		time = 0;
		self:endTimer();
	end
	self.leftTimeTxt.text = Lua_TimeTransform.transSeconds20(time, true, true);
end

function Lua_LoginRewardPanel:endTimer()
	if self.bTimer == true then
		self.bTimer = false;
		self:removeTimer(self, self.updateLeftTime);
	end
end

function Lua_LoginRewardPanel:updateLoginRewardInfo(msg)
	if self.btnList == nil then
		if msg == nil then return; end
		local arr = Array();
		if #msg.daily_attendance > 0 then
			arr:add({langId = 783000, panel = Lau_LoginRewardOfLoginPanel, redPointId = Lua_RedPointList.LoginReward_Login});
		end
		if #msg.seven_day > 0 then
			arr:add({langId = 783001, panel = Lau_LoginRewardOfRechargePanel, redPointId = Lua_RedPointList.LoginReward_Recharge});
		end
		self.btnList = Lua_DragList.new(self.content, 652, 52, Lua_AxisDefine.Horizontal);
		self.btnList.canDrag = arr:getSize() > 3;
		self.btnList:setListCell(Lua_LoginRewardBtnItem, 172, 52, 1);
		self.btnList:setCellSpacing(18, 0);
		self.btnList:setRectAnchor(1);
		self.btnList:setLocation(0, -363, 0);
		self.btnList:setArrayData(arr);
		self.btnList:setSelectClick(1);
		self.btnList:setSelected(1);
		self.btnList:setEnable(arr:getSize() > 1);
	end
	if self.showPanel then
		self.showPanel:updateData();
	end
end

function Lua_LoginRewardPanel:showLoginRewardInfo(itemData)
	if self.showPanel ~= nil then
		self.showPanel:dispose();
		self.showPanel = nil;
	end
	self.showPanel = itemData.panel.new(self.content);
	self.showPanel:setRectAnchor(9);
	self.showPanel:updateData();
end

function Lua_LoginRewardPanel:onRuleClick(go)
	local tipData = { des = self.actVo.help_des, posX = 190, posY = -230 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_LoginRewardPanel:onDrawLoginRewardClick()
	self:onLoginRewardOperate(2);
end

function Lua_LoginRewardPanel:onOpenUpgradeRewardClick(go)
	self:onLoginRewardOperate(3);
end

function Lua_LoginRewardPanel:onDrawRechargeRewardClick(id)
	self:onLoginRewardOperate(4, id);
end

function Lua_LoginRewardPanel:onLoginRewardOperate(operateType, param)
	if DataCenter.backstageActData:checkActIsEnd(self.actVo) then
		return;
	end

	if operateType == 1 then -- 刷新
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sActivityInfo(self.actVo.actIdx);
	elseif operateType == 2 then -- 领取登录奖励
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sDrawLoginReward(1, -1, self.actVo.actIdx);
	elseif operateType == 3 then -- 打开超值奖励界面
		Lua_WindowUtil.openWin("Lau_LoginRewardActRechargeWindow", Lua_WinParam.ACTION_OPEN, self.actVo);
	elseif operateType == 4 then -- 领取累充奖励
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sDrawLoginReward(2, param, self.actVo.actIdx);
	end
end

function Lua_LoginRewardPanel:dispose()
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	self.actVo = nil;
	self:endTimer();
	self:superCall("dispose");
end










Lua_LoginRewardBtnItem = class("Lua_LoginRewardBtnItem", Lua_ListCell);
function Lua_LoginRewardBtnItem:ctor(p)
	self:superCall("ctor", p, "LoginRewardBtnItem_skin");
end

function Lua_LoginRewardBtnItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_LoginRewardBtnItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.btnTxt:setLangValue(data.langId);
	self:checkRedPoint();
end

function Lua_LoginRewardBtnItem:checkRedPoint()
	if self._data ~= nil and self._data.redPointId ~= nil then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content, self._data.redPointId);
			self.redPoint:setLocation(75, 13, 0);
		end
		self.redPoint:changeRedPoint(self._data.redPointId);
	else
		if self.redPoint then
			self.redPoint:setEnable(false);
		end
	end
end

function Lua_LoginRewardBtnItem:onPressClick()
	Lua_MsgUtil.callFunc("ON_LOGINREWARD_ITEM_CLICK", self._data);
	return true;
end

function Lua_LoginRewardBtnItem:onSelectionChange(bSelect)
	self:superCall("onSelectionChange", bSelect);

	if bSelect then
		self.btnBg:setAltas("common_altas_4", "xui_kfjj_toggle_002_f");
		self.btnTxt.colorStr = Lua_ColorDefine.transColor("8F5123");
	else
		self.btnBg:setAltas("common_altas_4", "xui_kfjj_toggle_002_b");
		self.btnTxt.colorStr = Lua_ColorDefine.transColor("F5DBB1");
	end
end

function Lua_LoginRewardBtnItem:dispose()
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end