-- 豪礼兑换 礼包 Window
Lua_LuxuryCashGiftWindow = class("Lua_LuxuryCashGiftWindow", Lua_Window);

function Lua_LuxuryCashGiftWindow:ctor()
	self:superCall("ctor");
	
	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.isFullSizeWin = true;
	self.showWinBg = true;
	self.winBgPath = "/images/cash_reward/xui_dhhd1_bg_3.jpg";

	self.windowName = "Lua_LuxuryCashGiftWindow";
	self.skinName = "LuxuryCashGiftWindow_skin";

	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
end

function Lua_LuxuryCashGiftWindow:buildPanel(go)
	self:superCall("buildPanel", go);
	self:addLuaEvent("UPDATE_LUXURYCASH_GIFT_INFO", self, self.onUpdateInfo);
	self:addLuaEvent("UPDATE_LUXURYCASH_INFO", self, self.onUpdateCost);
end

function Lua_LuxuryCashGiftWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.listBg:SetDimensions(700, 966 + self.adaptHeight);

	self.itemList = Lua_DragList.new(self.content, 672, 900 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.itemList:setListCell(Lua_LuxuryCashGiftItem, 672, 168, 1);
	self.itemList:setRectPivot(1);
	self.itemList:setRectAnchor(1);
	self.itemList:setLocation(0, -366);
	self.itemList.tweenId = 2002;
end

function Lua_LuxuryCashGiftWindow:showWin(param)
	if param == nil then
		self:hide();
		return;
	end
	self.actVo = param;
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sLuxuryCashGiftInfo(self.actVo.actIdx);

	local curActIdx = DataCenter.luxuryCashData.actIdx;
	if curActIdx == nil or curActIdx ~= self.actVo.actIdx then
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sActivityInfo(self.actVo.actIdx);
	else
		self:onUpdateCost();
	end
end

function Lua_LuxuryCashGiftWindow:onScreenResize()
	self:superCall("onScreenResize");

	self.listBg:SetDimensions(700, 966 + self.adaptHeight);
	self.itemList:setContentRect(672, 900 + self.adaptHeight);
end

function Lua_LuxuryCashGiftWindow:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	self.actVo = nil;
	self:superCall("dispose");
end

function Lua_LuxuryCashGiftWindow:onUpdateInfo(msg)
	if self.costId ~= nil then
		self.itemTxt.text = numberTrans(DataCenter.packData:getItemCountById(self.costId));
	end
	local list = msg.gift_info;
	table.sort(list,
		function(a, b)
			local aVal = a.limit_times > a.times and a.conf_id or a.conf_id + 100000;
			local bVal = b.limit_times > b.times and b.conf_id or b.conf_id + 100000;
			return aVal < bVal;
		end)
	self.itemList:setArrayData(list);
end

function Lua_LuxuryCashGiftWindow:onUpdateCost()
	local data = DataCenter.luxuryCashData;

	local itemVo = data:getCostItemVo(Lua_LuxuryCashData.advType);
	self.costId = itemVo.id;
	self.iconSp:setAltas(itemVo.iconAtlas, itemVo.iconSprite);
	self.itemTxt.text = numberTrans(DataCenter.packData:getItemCountById(self.costId));

	self.time = data.closeTime - DataCenter.roleData.serverTime;
	self:onTimer();
end

function Lua_LuxuryCashGiftWindow:onTimer()
	if self.time > 0 then
		if not self.isTimer then
			self.isTimer = true;
			self:addTimer("Lua_LuxuryCashGiftWindow_onTimer", 1, self, self.onTimer);
		end
	else
		if self.isTimer then
			self.isTimer = false;
			self:removeTimer(self, self.onTimer);
		end
		self.time = 0;
	end
	self.timeTxt.text = LanUtil.formateStr(795005, Lua_TimeTransform.transSeconds16(self.time, true, true, true, false));
	self.time = self.time - 1;
end

function Lua_LuxuryCashGiftWindow:onBackBtnClick(go)
	if not Lua_WindowUtil.isOpenWin("Lua_LuxuryCashShopWindow") then
		local param = {actVo = self.actVo, index = 2};
		Lua_WindowUtil.openWin("Lua_LuxuryCashShopWindow", Lua_WinParam.ACTION_OPEN, param);
	end
	self:hide();
end






































Lua_LuxuryCashGiftItem = class("Lua_LuxuryCashGiftItem", Lua_ListCell);

function Lua_LuxuryCashGiftItem:ctor(p)
    self:superCall("ctor", p, "LuxuryCashGiftItem_skin");
end

function Lua_LuxuryCashGiftItem:buildShowItem()
	self:superCall("buildShowItem");

	self.giftList = Lua_DragList.new(self.content, 420, 93, Lua_AxisDefine.Horizontal);
	self.giftList:setListCell(Lua_LuxuryCashGiftIcon, 93, 93, 1);
	self.giftList:setCellSpacing(5, 0);
	self.giftList:setLocation(-100, -8, 0);
	self.giftList:setSiblingIndex(5);
	self:setSubList(self.giftList);

	self.buyBtn:addClickFuntion(self, self.onBuyBtnClick);
end

function Lua_LuxuryCashGiftItem:dispose()
	if self.giftList ~= nil then
		self.giftList:dispose();
		self.giftList = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end

function Lua_LuxuryCashGiftItem:setData(data)
	self.data = data;

	self.titleTxt.text = data.name;
	self.limitTxt.text = LanUtil.formateStr(795006, data.times, data.limit_times);
	self.buyBtn.label = LanUtil.formateStr(795007, data.price);

	local state = data.limit_times > data.times;
	self.limitTxt:setEnable(state);
	self.buyBtn:setEnable(state);
	self.stateIcon:setEnable(not state);

	self.giftList:setArrayData(data.reward_item);
	self.giftList.canDrag = not self.giftList.isTheEnd;

	self:showRedPoint(data.price == 0);
end

function Lua_LuxuryCashGiftItem:showRedPoint(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:createRedPointEff();
			self.redPoint:setLocation(297, -5, 0);
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_LuxuryCashGiftItem:onBuyBtnClick()
	if self.data == nil then return end

	local actIdx = DataCenter.luxuryCashData.actIdx;
	local actVo = DataCenter.backstageActData:getActVoByIdx(actIdx);
	if actVo == nil or DataCenter.backstageActData:checkActIsEnd(actVo) then
		return;
	end

	if DataCenter.luxuryCashData.closeTime <= DataCenter.roleData.serverTime then
		OperateAlert.showLangValue(795008);
		return;
	end

	if self.data.limit_times <= self.data.times then
		OperateAlert.showLangValue(795004);
		return;
	end

	if self.data.recharge_id == 0 then
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sGetLuxuryCashGift(actIdx, self.data.conf_id);
	else
		local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(self.data.recharge_id);
		DataCenter.sdkInterface:PointOut(1, tonumber(rechargeInfo.money), tonumber(rechargeInfo.money_type),
			tonumber(rechargeInfo.id), rechargeInfo.gift_name, rechargeInfo.gold);
	end
end















Lua_LuxuryCashGiftIcon = class("Lua_LuxuryCashGiftIcon", Lua_ItemIconCell);

function Lua_LuxuryCashGiftIcon:buildShowItem()
	self:superCall("buildShowItem")
	self.itemIcon:setScale(0.75, 0.75);
end

function Lua_LuxuryCashGiftIcon:setData(data)
	self.data = Lua_ToolVo.createToolVo(data.key, data.value);
	self.itemIcon:setData(self.data);
end