-- 豪礼兑换 商店 Window
Lua_LuxuryCashShopWindow = class("Lua_LuxuryCashShopWindow", Lua_Window);

function Lua_LuxuryCashShopWindow:ctor()
	self:superCall("ctor");
	
	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.isFullSizeWin = true;
	self.showWinBg = true;
	self.winBgPath = "/images/cash_reward/xui_dhhd1_bg_2.jpg";

	self.windowName = "Lua_LuxuryCashShopWindow";
	self.skinName = "LuxuryCashShopWindow_skin";

	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
end

function Lua_LuxuryCashShopWindow:buildPanel(go)
	self:superCall("buildPanel", go);
	self:addLuaEvent("UPDATE_LUXURYCASH_INFO", self, self.onUpdateInfo);
	self:addLuaEvent("UPDATE_LUXURYCASH_GIFT_INFO", self, self.updateRedState);
	self:addLuaEvent("UPDATE_LUXURYCASH_TASK_INFO", self, self.updateRedState);

	self:addLuaEvent("MONEY_UPDATE", self, self.onItemUpdate); 
	self:addLuaEvent("PACK_ITEMS_UPDATE", self, self.onItemUpdate);
end

function Lua_LuxuryCashShopWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.listBg:SetDimensions(700, 966 + self.adaptHeight);

	self.itemList = Lua_DragList.new(self.content, 648, 900 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.itemList:setListCell(Lua_LuxuryCashShopItem, 324, 155, 2);
	self.itemList:setCellSpacing(10, 4);
	self.itemList:setRectPivot(1)
	self.itemList:setRectAnchor(1);
	self.itemList:setLocation(0, -366);
	self.itemList.tweenId = 2003;
	self.itemList.delayTween = true;

	local arr = Array();
	arr:add({showType = Lua_LuxuryCashData.norType, redPointId = Lua_RedPointList.LuxuryCash_Shop1, textAtlas = "cash_reward_atlas", textNormalSprite = "xui_dhhd1_zgnbutton_1_n", textSelectedSprite = "xui_dhhd1_zgnbutton_1_p"});
	arr:add({showType = Lua_LuxuryCashData.advType, redPointId = Lua_RedPointList.LuxuryCash_Shop2, textAtlas = "cash_reward_atlas", textNormalSprite = "xui_dhhd1_zgnbutton_2_n", textSelectedSprite = "xui_dhhd1_zgnbutton_2_p"});

	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList.pivot = -1;
	self.btnList:setRectAnchor(7);
	self.btnList:setLocation(252, 59, 0);
	self.btnList:setButtonStyle("common_altas_1", "xui_common_zgnbutton_07", "xui_common_zgnbutton_07", 108, 118, 0.01, 1);
	self.btnList:setButtonLine("common_altas_1", "ui_common_line_011", 2, 108, 0, 0, 1);
	self.btnList:setButtonItem(108, 118);
	self.btnList:setRedPoint(40, 40);
	self.btnList:setClickCallBack(self, self.onBtnClick);
	self.btnList:setData(arr);

	self.addBtn:addClickFuntion(self, self.onAddBtnClick);
	self.giftBtn:addClickFuntion(self, self.onGiftBtnClick);
end

function Lua_LuxuryCashShopWindow:showWin(param)
	self.actVo = param.actVo;

	self.time = self.actVo.residueTime;
	self:onTimer();

	local index = param.index;
	if index == nil then
		index = 1;
	end
	self.btnList:setSelected(index);
end

function Lua_LuxuryCashShopWindow:onScreenResize()
	self:superCall("onScreenResize");

	self.listBg:SetDimensions(700, 966 + self.adaptHeight);
	self.itemList:setContentRect(648, 900 + self.adaptHeight);
end

function Lua_LuxuryCashShopWindow:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self.actVo = nil;
	self:superCall("dispose");
end

function Lua_LuxuryCashShopWindow:onBtnClick(index, data)
	if self.curType ~= data.showType then
		self.curType = data.showType;
		self:onUpdateInfo(true);
	end
end

function Lua_LuxuryCashShopWindow:onUpdateInfo(isMove)
	if self.curType == nil then return end 
	local data = DataCenter.luxuryCashData;

	local itemVo = data:getCostItemVo(self.curType);
	self.costId = itemVo.id;
	self.iconSp:setAltas(itemVo.iconAtlas, itemVo.iconSprite);
	self.itemTxt.text = numberTrans(DataCenter.packData:getItemCountById(self.costId));

	local arr = data:getShopItemArr(self.curType);
	self.itemList:setArrayData(arr);
	if isMove then
		self.itemList.showTween = true;
		self.itemList:moveToIndex(1, true, false);
	end

	local state = data.closeTime > DataCenter.roleData.serverTime;
	self.addBtn:setEnable(state);
	self.giftBtn:setEnable(self.curType == Lua_LuxuryCashData.norType or state);

	self:updateRedState();
end

function Lua_LuxuryCashShopWindow:updateRedState()
	local redState;
	if self.curType == Lua_LuxuryCashData.norType then
		redState = DataCenter.luxuryCashData.taskRedState;
	else
		redState = DataCenter.luxuryCashData.giftRedState;
	end
	self:showRedPoint(redState);
end

function Lua_LuxuryCashShopWindow:onTimer()
	if self.time > 0 then
		if not self.isTimer then
			self.isTimer = true;
			self:addTimer("Lua_LuxuryCashShopWindow_onTimer", 1, self, self.onTimer);
		end
	else
		if self.isTimer then
			self.isTimer = false;
			self:removeTimer(self, self.onTimer);
		end
		self.time = 0;
	end
	self.timeTxt.text = LanUtil.formateStr(795002, Lua_TimeTransform.transSeconds16(self.time, true, true, true, false));
	self.time = self.time - 1;
end

function Lua_LuxuryCashShopWindow:onItemUpdate(dic)
	if self.costId == nil or dic == nil or dic[self.costId] == nil then return end
	self.itemTxt.text = numberTrans(DataCenter.packData:getItemCountById(self.costId));
	self.itemList:updateShowList();
end

function Lua_LuxuryCashShopWindow:onAddBtnClick()
	if self.costId == nil then return end
	DataCenter.packUtil:openPathWindow(self.costId, false);
end

function Lua_LuxuryCashShopWindow:onGiftBtnClick()
	if DataCenter.backstageActData:checkActIsEnd(self.actVo) then
		return;
	end

	if self.curType == Lua_LuxuryCashData.norType then
		Lua_WindowUtil.openWin("Lua_LuxuryCashTaskWindow", Lua_WinParam.ACTION_OPEN, self.actVo);
	else
		-- Lua_WindowUtil.openWin("Lua_LuxuryCashGiftWindow", Lua_WinParam.ACTION_OPEN, self.actVo);
		DataCenter.funcPathUtil:gotoFunction(1125);
	end
end

function Lua_LuxuryCashShopWindow:showRedPoint(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setRectAnchor(1);
			self.redPoint:createRedPointEff();
			self.redPoint:setLocation(-270, -255, 0);
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_LuxuryCashShopWindow:onBackBtnClick(go)
	DataCenter.funcPathUtil:gotoFunction(1198, false);
	self:hide();
end


























Lua_LuxuryCashShopItem = class("Lua_LuxuryCashShopItem", Lua_ListCell);

function Lua_LuxuryCashShopItem:ctor(p)
    self:superCall("ctor", p, "LuxuryCashShopItem_skin");
end

function Lua_LuxuryCashShopItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setScale(0.95, 0.95, 0.95);
	self.itemIcon:setLocation(-83,4);
	self.itemIcon:setSiblingIndex(4);
end

function Lua_LuxuryCashShopItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	if self.scrollText ~= nil then
		self.scrollText:dispose();
		self.scrollText = nil;
	end
	self.data = nil;
	self.costVo = nil;
	self:superCall("dispose");
end

function Lua_LuxuryCashShopItem:setData(data)
	self.data = data;

	self.costVo = DataCenter.luxuryCashData:getCostItemVo(data.grade);
	self.iconSp:setAltas(self.costVo.iconAtlas, self.costVo.iconSprite);

	local itemInfo = data.item_info[1];
	if self.itemVo == nil then
		self.itemVo = Lua_ToolVo.createToolVo(itemInfo.key, itemInfo.value);
	else
		self.itemVo:setData(itemInfo.key, itemInfo.value);
	end
	self.itemIcon:setData(self.itemVo);

	self.nameTxt.text = self.itemVo.name;
	self.nameTxt:resetSize();
    if self.nameTxt.width > 133 then
        if self.scrollText == nil then
            self.scrollText = Lua_ScrollText.new(self.content, Lua_AxisDefine.Horizontal, 133, 24);
            self.scrollText:setLocation(60, 41, 0);
            self.scrollText:setTextStyle(133, 24, Lua_MyUISettings.huakangFontName, 24, "6F5144", 0);
        end
        self.scrollText:setShowTxt(self.itemVo.name);
        self.scrollText:setEnable(true);
        self.nameTxt:setEnable(false);
    else
        if self.scrollText then
            self.scrollText:setEnable(false);
        end
        self.nameTxt:setEnable(true);
    end

    self.limitTxt.text = LanUtil.formateStr(795003, data.limit_times - data.times);
    self.recommondSp:setEnable(data.recommend == 1);
    self.maskBg:setEnable(data.limit_times <= data.times);
    self.sellOutSp:setEnable(data.limit_times <= data.times);

    self:updateData();
end

function Lua_LuxuryCashShopItem:updateData()
	local packNum = DataCenter.packData:getItemCountById(self.costVo.id);
	local colorStr = packNum >= self.data.recharge and "000000" or "FF0000";
	self.priceTxt.text = Lua_ColorDefine.getColorStr(colorStr, self.data.recharge);
end

function Lua_LuxuryCashShopItem:onPressClick()
	if self.data == nil then return end

	local winPos = LuaUtil.getTouchPosInverseObj(self.mainContent);
	if self.itemIcon:checkInBound(winPos.x, winPos.y) then
		DataCenter.packUtil:showItemInfo(self.itemVo);
		return;
	end

	local actVo = DataCenter.backstageActData:getActVoByIdx(DataCenter.luxuryCashData.actIdx);
	if actVo == nil or DataCenter.backstageActData:checkActIsEnd(actVo) then
		return;
	end

	if self.data.limit_times <= self.data.times then
		OperateAlert.showLangValue(795004);
		return;
	end
	
	local packNum = DataCenter.packData:getItemCountById(self.costVo.id);
	if packNum < self.data.recharge then
		if DataCenter.luxuryCashData.closeTime <= DataCenter.roleData.serverTime then
			OperateAlert.show(LanUtil.formateStr(795009, self.costVo.colorName));
		else
			DataCenter.packUtil:openPathWindow(self.costVo.id, false);
		end
	else
		local param = {
			id = self.itemVo.id, -- 购买道具id
			itemCount = self.itemVo.count, -- 购买一份商品所携带的数量
			showStyle = 2,
			limitCount = self.data.limit_times - self.data.times, -- 限购数量，小于0不显示， = 0显示不限购， 默认为1,
			costId = self.costVo.id, -- 消耗道具id
			costCount = self.data.recharge, -- 消耗道具数量
			tipStr = "",
			isShowTipWindow = true, -- 点击购买按钮时，是否显示提示窗口
			isShowBackBtn = false, -- 是否显示返回按钮
			cancelBtnStr = LanUtil.getValue(125051), -- 默认取消
			sureBtnStr = LanUtil.getValue(125052), -- 默认确定
			owner = self, 
			callFunc = self.onSureBuy, -- 回调事件
			priceStyle = 1, -- 价格显示类型
			font_size = 26, -- tipWindow文本字体大小
			iconWidth = 46,
			iconHeight = 46
		}; 
		Lua_WindowUtil.openWin("Lua_ShoppingGoodsWindow", Lua_WinParam.ACTION_OPEN, param);
	end
end

function Lua_LuxuryCashShopItem:onSureBuy(id, selectNum)
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sBuyLuxuryCashReward(DataCenter.luxuryCashData.actIdx, self.data.id, selectNum, self.data.grade);
end