-- 干脆面碰碰购买弹窗
Lua_MergeBlockBuyTimesWindow = class("Lua_MergeBlockBuyTimesWindow", Lua_Window);
function Lua_MergeBlockBuyTimesWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_MergeBlockBuyTimesWindow";
	self.skinName = "MergeBlockBuyTimesWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_MergeBlockBuyTimesWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.txtInput.keyboardTypeValue = 12;
	self.txtInput.contentTypeValue = 2; -- 内容类型
	self.txtInput.characterValidationValue = 1; -- 字符验证，数字样式(1整数)
	self.txtInput.text = 1;
	self.txtInput:onEndEdit(self, self.updateCount);

	self.lessBtn:addClickFuntion(self, self.onLessBtnClick);
	self.addBtn:addClickFuntion(self, self.onAddBtnClick);
	self.sureBtn:addClickFuntion(self, self.onBuyBtnClick);
end

function Lua_MergeBlockBuyTimesWindow:showWin(param)
	self:superCall("showWin", param);

	local times = DataCenter.mergeBlockData.limitBuyTimes;
	self.minTimes = 1;
	self.maxTimes = times > 0 and times or 999;
	self.limitBuyTxt.text = LanUtil.formateStr(773005, self.maxTimes);
	self.limitBuyTxt:setEnable(times > 0); -- -1无限制不显示
	self:updateShowInfo(self.minTimes);
end

function Lua_MergeBlockBuyTimesWindow:updateShowInfo(showTimes)
	if self.buyTimes == showTimes then
		return;
	end
	self.buyTimes = showTimes;
	self.txtInput.text = showTimes;

	local itemId = DataCenter.mergeBlockData.itemCostInfo[1];
	local itemNum = DataCenter.mergeBlockData.itemCostInfo[2];
	local hasCount = DataCenter.packData:getItemCountById(itemId);
	local needCount = showTimes * itemNum;
	local colorStr = hasCount >= needCount and "726763" or "ED4C30";
	self.totalPriceTxt.text = LanUtil.formateStr("<color=#{1}>{2}</color>", colorStr, needCount);
	self.isCanBuy = hasCount >= needCount;
end

function Lua_MergeBlockBuyTimesWindow:updateCount()
	if self.txtInput.text == "" then
		val = self.minTimes;
	else
		val = tonumber(self.txtInput.text);
	end
	if val > self.maxTimes then
		val = self.maxTimes;
	elseif val < self.minTimes then
		val = self.minTimes;
	end
	self:updateShowInfo(val);
end

function Lua_MergeBlockBuyTimesWindow:onLessBtnClick(go)
	if self.buyTimes <= self.minTimes then
		return;
	end
	self:updateShowInfo(self.buyTimes - 1);
end

function Lua_MergeBlockBuyTimesWindow:onAddBtnClick(go)
	if self.buyTimes >= self.maxTimes then
		OperateAlert.showLangValue(773006);
		return;
	end
	self:updateShowInfo(self.buyTimes + 1);
end

function Lua_MergeBlockBuyTimesWindow:onBuyBtnClick()
	if DataCenter.backstageActData:checkActIsEnd(self.showData) then
		self:hide();
		return;
	end

	if self.isCanBuy then
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sBuyMergeBlockTimes(self.showData.actIdx, self.buyTimes);
		self:hide();
	else
		local itemId = DataCenter.mergeBlockData.itemCostInfo[1];
		DataCenter.packUtil:openPathWindow(itemId);
	end
end

function Lua_MergeBlockBuyTimesWindow:dispose()
	self:superCall("dispose");
end