-- 干脆面碰碰
Lua_MergeBlockPanel = class("Lua_MergeBlockPanel", Lua_DisplayObject);
function Lua_MergeBlockPanel:ctor(p, skinName)
	self:superCall("ctor", p, skinName);
end

function Lua_MergeBlockPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.taskRedPoint = Lua_RedPointIcon.new(self.content, Lua_RedPointList.MergeBlock_Task);
	self.taskRedPoint:setRectAnchor(1);
	self.taskRedPoint:setLocation(330, -190, 0);

	self.mergeBlockList = Lua_DragList.new(self.content, 716, 469, Lua_AxisDefine.Vertical);
	self.mergeBlockList.tweenId = 2002;
	self.mergeBlockList:setListCell(Lua_MergeBlockItem, 716, 153, 1);
	self.mergeBlockList:setCellSpacing(0, 5);
	self.mergeBlockList:setRectAnchor(7);
	self.mergeBlockList:setLocation(0, 410, 0);

	-- 策划要求屏蔽
	self.ruleBtn:setEnable(false);
	self.ruleBtn:addClickFuntion(self, self.onRuleClick);
	self.operateBtn:addClickFuntion(self, self.onOperateClick);
	self.taskBtn:addClickFuntion(self, self.onTaskClick);
	self.rankBtn:addClickFuntion(self, self.onRankClick);

	self:addLuaEvent("UPDATE_MERGEBLOCK_INFO", self, self.updateMergeBlockInfo);
	self:addLuaEvent("ON_MERGEBLOCK_REFRESH_CLICK", self, self.onMergeBlockRefreshClick);
	self:addLuaEvent("ON_MERGEBLOCK_CHALLENGE_CLICK", self, self.onMergeBlockChallengeClick);
	self:addLuaEvent("ON_MERGEBLOCK_END_CHALLENGE", self, self.onMergeBlockEndChallengeClick);
	self:addLuaEvent("ON_MERGEBLOCK_PROGRESS_CLICK", self, self.onMergeBlockProgressClick);
end

function Lua_MergeBlockPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
end

function Lua_MergeBlockPanel:setData(actVo)
	self.actVo = actVo;
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sMergeBlockTaskInfo(actVo.actIdx, 1); -- 每日任务红点
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sMergeBlockTaskInfo(actVo.actIdx, 2); -- 累计任务红点

	self.titleTxt.text = actVo.title;
	self:startTimer();
	self:updateLeftTime();
end

function Lua_MergeBlockPanel:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		self:addTimer("Lua_MergeBlockPanel", 1, self, self.updateLeftTime);
	end
end

function Lua_MergeBlockPanel:updateLeftTime()
	local time = self.actVo.residueTime;
	if time <= 0 then
		time = 0;
		self:endTimer();
	end
	self.leftTimeTxt.text = LanUtil.formateStr(773000, Lua_TimeTransform.transSeconds16(time, true, true, true));
end

function Lua_MergeBlockPanel:endTimer()
	if self.bTimer == true then
		self.bTimer = false;
		self:removeTimer(self, self.updateLeftTime);
	end
end

function Lua_MergeBlockPanel:updateMergeBlockInfo()
	if DataCenter.mergeBlockData.isFirst then
		self:onOperateClick();
	end

	self.timesTxt.text = LanUtil.formateStr(773001, DataCenter.mergeBlockData.challengeTimes);
	local arr = DataCenter.mergeBlockData.mergeBlockDiffTypeArr;
	self.mergeBlockList.canDrag = arr:getSize() > 3;
	self.mergeBlockList:setArrayData(arr);

	-- 购买后跳到之前选择的难度关卡
	-- if self.levelInfo then
	-- 	self:onMergeBlockChallengeClick(self.levelInfo);
	-- 	self.levelInfo = nil;
	-- end
end

function Lua_MergeBlockPanel:onRuleClick(go)
	local tipData = { des = self.actVo.help_des, posX = 180, posY = -240 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_MergeBlockPanel:onOperateClick(go)
	Lua_WindowUtil.openWin("Lua_MergeBlockExplainWindow", Lua_WinParam.ACTION_OPEN, self.actVo);
end

function Lua_MergeBlockPanel:onTaskClick(go)
	self:onMergeBlockOperate(1);
end

function Lua_MergeBlockPanel:onRankClick(go)
	self:onMergeBlockOperate(2);
end

function Lua_MergeBlockPanel:onMergeBlockRefreshClick()
	self:onMergeBlockOperate(3);
end

function Lua_MergeBlockPanel:onMergeBlockChallengeClick(param)
	self:onMergeBlockOperate(4, param);
end

function Lua_MergeBlockPanel:onMergeBlockEndChallengeClick()
	self:onMergeBlockOperate(5);
end

function Lua_MergeBlockPanel:onMergeBlockProgressClick(param)
	self:onMergeBlockOperate(6, param);
end

function Lua_MergeBlockPanel:onMergeBlockOperate(operateType, param)
	if self.actVo == nil or DataCenter.backstageActData:checkActIsEnd(self.actVo) then
		return;
	end

	local vo = DataCenter.mergeBlockData.saveInfo;
	if operateType == 1 then
		Lua_WindowUtil.openWin("Lua_MergeBlockTaskWindow", Lua_WinParam.ACTION_OPEN, self.actVo);
	elseif operateType == 2 then
		Lua_WindowUtil.openWin("Lua_MergeBlockRankWindow", Lua_WinParam.ACTION_OPEN, self.actVo);
	elseif operateType == 3 then
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sActivityInfo(self.actVo.actIdx); -- 开启刷新
	elseif operateType == 4 then
		if vo.game_info then
			if #vo.game_info > 0 then
				Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sActivityInfo(self.actVo.actIdx); -- 最高记录刷新
				Lua_WindowUtil.openWin("Lua_MergeBlockChallengeWindow", Lua_WinParam.ACTION_OPEN, {actVo = self.actVo, levelInfo = vo});
			else
				if DataCenter.mergeBlockData.challengeTimes <= 0 then
					Lua_WindowUtil.openWin("Lua_MergeBlockBuyTimesWindow", Lua_WinParam.ACTION_OPEN, self.actVo);
					self.levelInfo = param;
				else
					Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sActivityInfo(self.actVo.actIdx); -- 最高记录刷新
					Lua_WindowUtil.openWin("Lua_MergeBlockChallengeWindow", Lua_WinParam.ACTION_OPEN, {actVo = self.actVo, levelInfo = param});
				end
			end
		end
	elseif operateType == 5 then
		if vo.game_info then
			local blockArr = Array();
			local gameArr = Array();
			for i = 1, #vo.game_info do
				if vo.game_info[i] == 0 then
					blockArr:add(i);
				end
				gameArr:add(vo.game_info[i]);
			end
			Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sComputeMergeBlockScore(self.actVo.actIdx,
				vo.diffType, vo.last_score, blockArr, gameArr, 3, 0);
		end
	elseif operateType == 6 then
		if param.data.drawState == 1 then
			Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sDrawMergeBlockStageReward(self.actVo.actIdx, param.data.diffType);
		else
			local winPos = LuaUtil.getTouchPosInverseObj(self.content);
			param.posY = winPos.y;
			Lua_WindowUtil.openWin("Lua_MergeBlockProgressRewardWindow", Lua_WinParam.ACTION_OPEN, param);
		end
	end
end

function Lua_MergeBlockPanel:dispose()
	if self.taskRedPoint ~= nil then
		self.taskRedPoint:dispose();
		self.taskRedPoint = nil;
	end
	if self.mergeBlockList ~= nil then
		self.mergeBlockList:dispose();
		self.mergeBlockList = nil;
	end
	self.actVo = nil;
	self:endTimer();
	self:superCall("dispose");
end











Lua_MergeBlockItem = class("Lua_MergeBlockItem", Lua_ListCell);
function Lua_MergeBlockItem:ctor(p)
	self:superCall("ctor", p, "MergeBlockItem_skin");
end

function Lua_MergeBlockItem:buildShowItem()
	self:superCall("buildShowItem");

	self.showTime = 0;
	self.progressItemArr = Array();
	self.challengeBtn:addClickFuntion(self, self.onChallengeClick);
end

function Lua_MergeBlockItem:setData(data)
	self._data = DataCenter.mergeBlockData:getDiffTypeInfoByDiffType(data);
	if self._data == nil then
		return;
	end

	self.levelTxt.text = LanUtil.formateStr(773002, self._data.diffType);
	self.scoreTxt.text = self._data.top_score;

	local isLock = self._data.timeCond;
	if isLock then -- 未开启
		self.itemBg:setAltas("activities_atlas_4", "xui_bfbz_widget_6");
		self.levelBg.alpha = 0.6;
		self.openTxt:setEnable(true);
		self.openObj:SetActive(false);

		self.showTime = self._data.open_time;
		self:startTimer();
		self:updateOpenTime();
	else
		self.itemBg:setAltas("activities_atlas_4", "xui_bfbz_widget_5");
		self.levelBg.alpha = 1;
		self.openTxt:setEnable(false);
		self.openObj:SetActive(true);
		self:stopTimer();

		-- 进度条
		local score = self._data.top_score;
		local list = self._data.progressRewardDic;
		local dataLen = #list;
		local maxValue = list[dataLen].score;
		local value = 0;
		local index = 1;
		if score >= maxValue then
			value = maxValue;
		else
			local stepSpace = maxValue / dataLen;
			for i = 1, dataLen do
				if list[i].score >= score then
					index = i;
					break;
				end
			end
			value = value + stepSpace * (index - 1);
			local num;
			if index <= 1 then
				num = stepSpace / list[index].score;
				value = value + score * num;
			else
				num = stepSpace / (list[index].score - list[index - 1].score);
				value = value + (score - list[index - 1].score) * num;
			end
		end
		self.scoreBar:setMaxValue(maxValue);
		self.scoreBar:setValue(value);

		-- 阶段奖励
		local width = 72;
		local vo;
		for i = 1, dataLen do
			vo = self.progressItemArr[i];
			if vo == nil then
				vo = Lua_MergeBlockScoreItem.new(self.openObj);
				self.progressItemArr:add(vo);
			end
			vo:setData(list[i]);
			vo:setLocation(-123 + (i - 1) * width, 0, 0);
		end
	end
	self.lockIcon:setEnable(isLock);
end

function Lua_MergeBlockItem:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		self:addTimer("Lua_MergeBlockItem", 1, self, self.updateOpenTime);
	end
end

function Lua_MergeBlockItem:updateOpenTime()
	self.showTime = self.showTime - 1;
	local openTime;
	if self.showTime >= 86400 then
		openTime = LanUtil.formateStr(773003, Mathf.Ceil(self.showTime / 86400));
	else
		openTime = Lua_TimeTransform.transSeconds6(self.showTime, true, true, true);
	end
	self.openTxt.text = LanUtil.formateStr(773004, openTime);
	
	if self.showTime <= 0 then
		self:stopTimer();
	end
end

function Lua_MergeBlockItem:stopTimer()
	if self.bTimer == true then
		self.bTimer = false;
		self:removeTimer(self, self.updateOpenTime);
	end
end

function Lua_MergeBlockItem:onChallengeClick(go)
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.5 then
		return;
	end
	self.clickTime = getTime();
	
	local vo = DataCenter.mergeBlockData.saveInfo;
	if vo.game_info and #vo.game_info > 0 then
		local tipsData = {
			owner = self,
			des = LanUtil.formateStr(773012, vo.diffType);
			btnType = 1,
			cancelLabel = LanUtil.getValue(773013),
			sureLabel = LanUtil.getValue(773014),
			cancelFun = self.showChallengeResult,
			sureFun = self.onChallengeFun
		};
		Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
	else
		self:onChallengeFun();
	end
end

function Lua_MergeBlockItem:showChallengeResult()
	local vo = DataCenter.mergeBlockData.saveInfo;
	Lua_MsgUtil.callFunc("ON_MERGEBLOCK_END_CHALLENGE");
	Lua_WindowUtil.openWin("Lua_MergeBlockResultWindow", Lua_WinParam.ACTION_OPEN, {levelInfo = vo, result = vo.last_score});
end

function Lua_MergeBlockItem:onChallengeFun()
	Lua_MsgUtil.callFunc("ON_MERGEBLOCK_CHALLENGE_CLICK", self._data);
end

function Lua_MergeBlockItem:dispose()
	if self.progressItemArr ~= nil then
		self.progressItemArr:dispose();
		self.progressItemArr = nil;
	end
	self._data = nil;
	self:stopTimer();
	self:superCall("dispose");
end










Lua_MergeBlockScoreItem = class("Lua_MergeBlockScoreItem", Lua_ListCell);
function Lua_MergeBlockScoreItem:ctor(p)
	self:superCall("ctor", p, "MergeBlockScoreItem_skin");
end

function Lua_MergeBlockScoreItem:buildShowItem()
	self:superCall("buildShowItem");
	self.stateIcon:addClickFuntion(self, self.onShowRewardClick);
end

function Lua_MergeBlockScoreItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local stateSprite;
	local pointSprite;
	if data.drawState == 0 then -- 未达成
		stateSprite = "xui_ppgcm_widget_2";
		pointSprite = "xui_bfbz_widget_10";
	elseif data.drawState == 1 then -- 可领取
		stateSprite = "xui_ppgcm_widget_4";
		pointSprite = "xui_bfbz_widget_11";
	else -- 已领取
		stateSprite = "xui_ppgcm_widget_3";
		pointSprite = "xui_bfbz_widget_10";
	end
	self.stateIcon:setAltas("merge_block_atlas_1", stateSprite);
	self.pointIcon:setAltas("activities_atlas_4", pointSprite);

	self.scoreTxt.text = data.score;
	self:showRedDot(data.drawState == 1);
end

function Lua_MergeBlockScoreItem:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:createRedPointEff();
			self.redPoint:setLocation(20, 40, 0);
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_MergeBlockScoreItem:onShowRewardClick(go)
	Lua_MsgUtil.callFunc("ON_MERGEBLOCK_PROGRESS_CLICK", {data = self._data, posX = self.posX});
end

function Lua_MergeBlockScoreItem:dispose()
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end