-- 干脆面碰碰结算界面
Lua_MergeBlockResultWindow = class("Lua_MergeBlockResultWindow", Lua_Window);
function Lua_MergeBlockResultWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_MergeBlockResultWindow";
	self.skinName = "MergeBlockResultWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_MergeBlockResultWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.clickTime = getTime();
	self.sureBtn:addClickFuntion(self, self.hide);
end

function Lua_MergeBlockResultWindow:showWin(param)
	self:superCall("showWin", param);

	local historyScore = param.levelInfo.top_score or 0;
	self.myScoreTxt.text = param.result;
	self.historyTxt.text = LanUtil.formateStr(773018, historyScore);
	self.newIcon:setEnable(historyScore < param.result);

	self:startCloseTimer();
end

function Lua_MergeBlockResultWindow:startCloseTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		self.showTime = 11;
		self:updateCloseTimer();
		self:addTimer("Lua_MergeBlockResultWindow", 1, self, self.updateCloseTimer);
	end
end

function Lua_MergeBlockResultWindow:updateCloseTimer()
	self.showTime = self.showTime - 1;
	if self.showTime <= 0 then
		self:endCloseTimer();
	end
	self.closeTimeTxt.text = LanUtil.formateStr(773019, self.showTime);
end

function Lua_MergeBlockResultWindow:endCloseTimer()
	if self.bTimer == true then
		self.bTimer = false;
		self:hide();
		self:removeTimer(self, self.updateCloseTimer);
	end
end

function Lua_MergeBlockResultWindow:hide()
	if self.clickTime == nil or getTime() - self.clickTime < 0.5 then
		return;
	end
	Lua_MsgUtil.callFunc("ON_MERGEBLOCK_REFRESH_CLICK");
	Lua_WindowUtil.openWin("Lua_MergeBlockChallengeWindow", Lua_WinParam.ACTION_CLOSE);
	self:superCall("hide");
end

function Lua_MergeBlockResultWindow:dispose()
	self:endCloseTimer();
	self:superCall("dispose");
end