-- 干脆面碰碰合成规则弹窗
Lua_MergeBlockRuleWindow = class("Lua_MergeBlockRuleWindow", Lua_Window);
function Lua_MergeBlockRuleWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_MergeBlockRuleWindow";
	self.skinName = "MergeBlockRuleWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_MergeBlockRuleWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.ruleList = Lua_DragList.new(self.content, 628, 780, Lua_AxisDefine.Vertical);
	self.ruleList.tweenId = 2023;
	self.ruleList.delayTween = true;
	self.ruleList:setListCell(Lua_MergeBlockRuleItem, 628, 155, 1);
	self.ruleList:setCellSpacing(0, 4);
	self.ruleList:setLocation(0, -43, 0);
end

function Lua_MergeBlockRuleWindow:showWin(param)
	self:superCall("showWin", param);
	DataCenter.mergeBlockData.theme = param.theme;
	self.ruleList:setArrayData(DataCenter.mergeBlockData.ruleList);
end

function Lua_MergeBlockRuleWindow:dispose()
	if self.ruleList ~= nil then
		self.ruleList:dispose();
		self.ruleList = nil;
	end
	self:superCall("dispose");
end










Lua_MergeBlockRuleItem = class("Lua_MergeBlockRuleItem", Lua_ListCell);
function Lua_MergeBlockRuleItem:ctor(p)
	self:superCall("ctor", p, "MergeBlockRuleItem_skin");
end

function Lua_MergeBlockRuleItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_MergeBlockRuleItem:setData(data)
	self._data = data;
	if self._data == nil then
		return;
	end

	local theme = DataCenter.mergeBlockData.theme;
	self.iconBg_2:setAltas("merge_block_atlas_1", "xui_ppgcm_icon_bg_" .. data.int1);
	self.icon:setAltas("merge_block_atlas_1", "xui_ppgcm_icom_" .. theme * 10000 + data.int1);
	self.icon:resetSize();
	self.numTxt.text = data.int1;
	self.nameTxt.text = data.str1;
	self.desTxt.text = data.str2;
	self.scoreTxt.text = LanUtil.formateStr(773020, data.int2);
end

function Lua_MergeBlockRuleItem:dispose()
	self._data = nil;
	self:superCall("dispose");
end