-- 英雄试炼增益信息窗口
Lua_HeroTrialBuffInfoWindow = class("Lua_HeroTrialBuffInfoWindow", Lua_Window);
function Lua_HeroTrialBuffInfoWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_HeroTrialBuffInfoWindow";
	self.skinName = "HeroTrialBuffInfoWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
	self.showClose = false;
	self.blackAlpha = 0.01;
	self.isFullSizeWin = true;
end

function Lua_HeroTrialBuffInfoWindow:buildShowItem()
	self:superCall("buildShowItem");

	LuaUtil.setObjPos(self.content, -50, 350 + self.adaptHeight / 2, 0);

	local buffInfo = DataCenter.newHeroActData.buffInfo;
	if buffInfo then
		self.skillNameTxt.text = LanUtil.formateStr("{1}Lv{2}", buffInfo.buff_name, buffInfo.buff_lvl);

		local indent = Lua_SpaceDefine.SPACE .. Lua_SpaceDefine.SPACE;
		local info = buffInfo.skill_info;
		local skillInfo = Lua_SkillConfigData.getConfigData(info.key);
		local skillStr = "";
		if skillInfo ~= nil then
			skillStr = "，" .. LanUtil.formateStr(750011, skillInfo.name, info.value, Mathf.Floor(info.other * 100));
		end
		local str = LanUtil.formateStr("{1}{2}{3}", indent, self:getDesInfo(buffInfo.hero_add, 1), skillStr);
		self.heroAddTxt.text = LanUtil.formateStr("{1}\n{2}{3}", str, indent, self:getDesInfo(buffInfo.all_add, 2));
		self.heroAddTxt:resetSize();
		self.nextLevelTxt:resetSize();
		self.nextLevelTxt:setLocation(-140, self.heroAddTxt.posY - self.heroAddTxt.height - 33);
		self.allHeroAddTxt:setLocation(0, self.nextLevelTxt.posY - self.nextLevelTxt.height + 15);
		if #buffInfo.next_hero_add > 0 then
			info = buffInfo.next_skill_info;
			skillInfo = Lua_SkillConfigData.getConfigData(info.key);
			skillStr = "";
			if skillInfo ~= nil then
				skillStr = LanUtil.formateStr(750011, skillInfo.name, info.value, Mathf.Floor(info.other * 100))
			end
			str = LanUtil.formateStr("{1}{2}{3}", indent, self:getDesInfo(buffInfo.next_hero_add, 1), skillStr); 
			self.allHeroAddTxt.text = LanUtil.formateStr("{1}\n{2}{3}", str, indent, self:getDesInfo(buffInfo.next_all_add, 2));
			self.allHeroAddTxt:resetSize();

			self.tipTxt:setLocation(-140, self.allHeroAddTxt.posY - self.allHeroAddTxt.height - 34);
			self.winBg:SetDimensions(430, -self.tipTxt.posY + 42);
			self.nextLevelTxt:setEnable(true);
		else
			self.tipTxt:setLocation(-140, self.heroAddTxt.posY - self.heroAddTxt.height - 34);
			self.winBg:SetDimensions(430, -self.tipTxt.posY + 42);
			self.nextLevelTxt:setEnable(false);
		end
	end
end

function Lua_HeroTrialBuffInfoWindow:getDesInfo(attribute, upType)
	local str;
	if upType == 1 then
		local heroVo = getConfig("hero", tonumber(DataCenter.newHeroActData.buffInfo.hero_id));
		str = LanUtil.formateStr(750012, heroVo.name);
	else
		str = LanUtil.getValue(750013);
	end

	local attrDic = {};
	for i = 1, #attribute do
		attrDic[attribute[i].name] = attribute[i].value;
	end

	local desArr = DataCenter.attributesUtil:getAttrArrByDic(attrDic);
	for i = 1, desArr:getSize() do
		str = str .. desArr[i].show_name .. "+" .. desArr[i].showValue;
		if i ~= desArr:getSize() then
			str = str .. "，";
		end
	end
	return str;
end

function Lua_HeroTrialBuffInfoWindow:onScreenResize()
	self:superCall("onScreenResize");
	LuaUtil.setObjPos(self.content, -50, 350 + self.adaptHeight / 2, 0);
end

function Lua_HeroTrialBuffInfoWindow:dispose()
	self:superCall("dispose");
end