-- 英雄试炼增益升级弹框
Lua_HeroTrialBuffUpWindow = class("Lua_HeroTrialBuffUpWindow", Lua_Window);
function Lua_HeroTrialBuffUpWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_HeroTrialBuffUpWindow";
	self.skinName = "HeroTrialBuffUpWindow_skin";
	self.layer = Lua_MainWinDefine.TIPS_WINDOW_LAYER;
	self.showWinBg = true;
	self.isFullSizeWin = true;
	self.winBgPath = "/images/common/xui_common_bg_002.jpg";
end

function Lua_HeroTrialBuffUpWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.allUpDesContainer = Lua_DragContainer.new(self.content, 720, 160, Lua_AxisDefine.Vertical);
	self.allUpDesContainer:setCellPivot(1);
	self.allUpDesContainer:setLocation(0, 82, 0);
	self.allUpDesContainer:setSiblingIndex(11);

	self.upDesContainer = Lua_DragContainer.new(self.content, 720, 160, Lua_AxisDefine.Vertical);
	self.upDesContainer:setCellPivot(1);
	self.upDesContainer:setLocation(0, -163, 0);
	self.upDesContainer:setSiblingIndex(11);
    
    self.winBg.anchorValue = 1;
    self.winBg.pivotValue = 1;
    self.winBg:setLocation(0, 0);
	self.winBg:addClickFuntion(self, self.hide);
end

function Lua_HeroTrialBuffUpWindow:showWin(param)
	self:superCall("showWin", param);

	self.preLvTxt.text = LanUtil.formateStr(750014, param.buff_lvl);
	self.curLvTxt.text = LanUtil.formateStr(750014, param.buff_lvl + 1);
	local skillInfo = Lua_SkillConfigData.getConfigData(param.skill_info.key);
	if skillInfo then
		self.powerDesTxt.text = LanUtil.formateStr(750015, skillInfo.name, param.next_buff_lvl);
	end

	local desArr = self:getAttributeInfo(param.all_add, param.next_all_add);
	for i = 1, desArr:getSize() do
		self.allUpDesContainer:addSubContainer(Lua_HeroTrialBuffUpAttItem, desArr[i]);
	end
	self.allUpDesContainer:updateChildPos();
	self.allUpDesContainer.canDrag = not self.allUpDesContainer.isTheEnd;

	desArr = self:getAttributeInfo(param.hero_add, param.next_hero_add);
	for i = 1, desArr:getSize() do
		self.upDesContainer:addSubContainer(Lua_HeroTrialBuffUpAttItem, desArr[i]);
	end
	self.upDesContainer:updateChildPos();
	self.upDesContainer.canDrag = not self.upDesContainer.isTheEnd;
end

function Lua_HeroTrialBuffUpWindow:getAttributeInfo(preAttrList, curAttrList)
	local preAttrDic = {};
	local curAttrDic = {};
	for i = 1, #preAttrList do
		preAttrDic[preAttrList[i].name] = preAttrList[i].value;
	end
	for i = 1, #curAttrList do
		if preAttrDic[curAttrList[i].name] == nil then
			preAttrDic[preAttrList[i].name] = 0;
		end
		curAttrDic[curAttrList[i].name] = curAttrList[i].value;
	end

	local desArr = DataCenter.attributesUtil:getAttrArrByDic(preAttrDic, curAttrDic);
	return desArr;
end

function Lua_HeroTrialBuffUpWindow:dispose()
	if self.allUpDesContainer ~= nil then
		self.allUpDesContainer:dispose();
		self.allUpDesContainer = nil;
	end
	if self.upDesContainer ~= nil then
		self.upDesContainer:dispose();
		self.upDesContainer = nil;
	end
	self:superCall("dispose");
end










Lua_HeroTrialBuffUpAttItem = class("Lua_HeroTrialBuffUpAttItem", Lua_DragContainerItem);
function Lua_HeroTrialBuffUpAttItem:ctor(p)
	self:superCall("ctor", p, "HeroTrialBuffUpAttItem_skin");
end

function Lua_HeroTrialBuffUpAttItem:setData(data)
	self.attNameTxt.text = LanUtil.formateStr("{1}：", data.show_name);
	self.attValueTxt.text = data.showValue;
	self.curAttValueTxt.text = data.showNextValue;
end

function Lua_HeroTrialBuffUpAttItem:setCellSeqIndex(idx)
	self:superCall("setCellSeqIndex", idx);
	self.bg:setEnable(idx % 2 ~= 0);
end

function Lua_HeroTrialBuffUpAttItem:getWidth()
	return self.bg.width;
end

function Lua_HeroTrialBuffUpAttItem:getHeight()
	return self.bg.height;
end

function Lua_HeroTrialBuffUpAttItem:dispose()
	self:superCall("dispose");
end