-- 皮肤直购
Lua_SkinPurchasePanel = class("Lua_SkinPurchasePanel", Lua_DisplayObject);
function Lua_SkinPurchasePanel:ctor(p, skinName)
	self:superCall("ctor", p, skinName);
end

function Lua_SkinPurchasePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.buySp_2:setEnable(false);
	self.buySp_3:setEnable(false);
	self.buyTxt:setEnable(false);
	self.buyTxt_1:setEnable(false);
	self.buyTxt_2:setEnable(false);

	self.listHeight = 100;
	self.itemWeight = 96;
	self.distanceX = 2;
	local weight = 4.5 * self.itemWeight + 3 * self.distanceX;
	self.itemList = Lua_DragList.new(self.content, weight, self.listHeight, Lua_AxisDefine.Horizontal);
	self.itemList:setRectAnchor(7);
	self.itemList:setRectPivot(3);
	self.itemList:setLocation(-338, 318);
	self.itemList:setListCell(Lua_SkinPurchaseItem, self.itemWeight, 100, 1);
	self.itemList:setCellSpacing(self.distanceX, 0);

	self.propList = Lua_DragList.new(self.content, 150, 62, Lua_AxisDefine.Vertical);
	self.propList:setRectAnchor(1);
	self.propList:setRectPivot(0);
	self.propList:setLocation(-353, -185);
	self.propList:setListCell(Lua_SkinPurchasePropItem, 150, 30, 1);
	self.propList:setCellSpacing(10, 0);

	self.buySp_1:addClickFuntion(self, self.onClickBuySp);
    self.tipSp:addClickFuntion(self, self.onClickTipSp);

    self.recordSp.clickScale = false;
	self.recordSp:addClickFuntion(self, self.onClickRecordSp);
    self.recordSp:addMousDownFuntion(self, self.onMouseDownRecordSp);
	self.recordSp:addMouseUpFuntion(self, self.onMouseUpRecordSp);

	self:addLuaEvent("UPDATE_SKINPURCHASE_INFO", self, self.updatePanel);
end

function Lua_SkinPurchasePanel:dispose()	
	self:endTimer();
	self:returnModel();
	self.data = nil;
	self.msgData = nil;
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	if self.propList ~= nil then
		self.propList:dispose();
		self.propList = nil;
	end

	self:superCall("dispose");
end

-- function Lua_SkinPurchasePanel:onScreenResize(adaptHeight)
-- 	if self.adaptHeight == adaptHeight then
-- 		return;
-- 	end

-- 	self:superCall("onScreenResize", adaptHeight);
-- end

function Lua_SkinPurchasePanel:onClickTipSp()
	local tipData = { des = 788000, posX = 195, posY = -271 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_SkinPurchasePanel:onClickRecordSp()
	if self.data == nil then
		return;
	end

	if self.clickTime ~= nil and getTime() - self.clickTime < 0.5 then
		return;
	end

	local active_id = self.data.actIdx;
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sSkinPurchase(active_id);
end

function Lua_SkinPurchasePanel:onMouseDownRecordSp(go)
	LuaUtil.setObjScale(self.recordObj, 0.95, 0.95, 0.95);
end 

function Lua_SkinPurchasePanel:onMouseUpRecordSp(go)
	LuaUtil.setObjScale(self.recordObj, 1, 1, 1);
end

function Lua_SkinPurchasePanel:onClickBuySp()
	if DataCenter.backstageActData:checkActIsEnd(self.data) then
		return;
	end

	if self.clickTime ~= nil and getTime() - self.clickTime < 0.5 then
		return;
	end
	self.clickTime = getTime();

	local can_buy = self.msgData.has_draw ~= 1;
	if can_buy ~= true then
		OperateAlert.showLangValue(788001);
		return;
	end

	local hasSkin = self.msgData.has_cloth == 1;
	if hasSkin then
		Lua_WindowUtil.openWin("Lua_SkinPurchaseSureShopWindow", Lua_WinParam.ACTION_OPEN, {msgData = self.msgData, activity_vo = self.data});
	else
		self:onSureShop();
	end
end

function Lua_SkinPurchasePanel:onSureShop()
	local shopBuyId = self.msgData.recharge_id;
	local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(shopBuyId);
	DataCenter.sdkInterface:PointOut(1, tonumber(rechargeInfo.money), tonumber(rechargeInfo.money_type),
				tonumber(rechargeInfo.id), rechargeInfo.gift_name, rechargeInfo.gold);
end

function Lua_SkinPurchasePanel:setData(data)
	self.data = data;

	self.actEndTime = self.data and self.data.end_tick or 0;
end

function Lua_SkinPurchasePanel:updateSkinNameSp()
	if self.data == nil then
		return;
	end

	local cfg = Lua_HeroFashionConfigData.getConfig(self.skinId);
	if cfg == nil then
		return;
	end

	local spriteSp;
	local heroId = cfg.heroId;
	if heroId == 103000205 then -- 林冲
		spriteSp = "xui_pfzg_title_4";
	elseif heroId == 102000805 then -- 程咬金
		spriteSp = "xui_pfzg_title_5";
	elseif heroId == 101000305 then -- 姜子牙
		spriteSp = "xui_pfzg_title_6";
	elseif heroId == 102001505 then -- 武则天
		spriteSp = "xui_pfzg_title_7";
	end

	self.skinNameSp:setAltas("skin_purchase_atlas", spriteSp);
end

function Lua_SkinPurchasePanel:updatePanel(msg)
	self.msgData = msg
	self:initSkinId();
	self:updateSkinNameSp();
	self:updateShopBtnInfo();
	self:updateItemList();
	self:updateProps();
	self:onTimer();
	self:starTimer();
end

function Lua_SkinPurchasePanel:initSkinId()
	self.skinId = DataCenter.skinPurchaseData.skinId;
end

function Lua_SkinPurchasePanel:updateShopBtnInfo()
	local shopBuyId = self.msgData.recharge_id;
	local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(shopBuyId);
	local moneyNum = rechargeInfo and rechargeInfo.money or 0;
	self.buyTxt.text = LanUtil.formateStr(788002, moneyNum);

	local can_buy = self.msgData.has_draw ~= 1;
	local spriteStr = can_buy and "xui_pfzg_button_1" or "xui_pfzg_button_3";
	self.buySp_1:setAltas("skin_purchase_atlas", spriteStr);
	self.buySp_2:setEnable(can_buy);
	self.buySp_3:setEnable(can_buy);
	self.buyTxt:setEnable(can_buy);
	self.buyTxt_1:setEnable(can_buy);
	self.buyTxt_2:setEnable(can_buy ~= true);
end

function Lua_SkinPurchasePanel:updateProps()
	if self.skinId == nil then
		return;
	end

	local cfg = Lua_HeroFashionConfigData.getConfig(self.skinId);
	if cfg == nil then
		return;
	end

	local props = cfg.curProp;
	local propArr = DataCenter.attributesUtil:getAttrArrByDic(props);
	self.propList:setArrayData(propArr);
	self.propList.canDrag = propArr:getSize() > 2;
end

function Lua_SkinPurchasePanel:updateItemList()
	local itemList = self.msgData.recharge_reward.item_list;
	self.itemList:setArrayData(itemList);

	local weight;
	local count = itemList and #itemList or 0;
	if count > 4 then
		weight = 4.5 * self.itemWeight + 3 * self.distanceX;
	else
		weight = count * self.itemWeight + (count - 1) * self.distanceX;
	end

	self.itemList:setContentRect(weight, self.listHeight);
	self.itemList.canDrag = count > 4;
end

function Lua_SkinPurchasePanel:starTimer()
	if self.sTime ~= false then
		self.sTime = true;
		self:addTimer("Lua_SkinPurchasePanel", 1, self, self.onTimer);
	end
end

function Lua_SkinPurchasePanel:onTimer()
	local residueTime = self.actEndTime - DataCenter.roleData.serverTime;
	if residueTime > 0 then
		self.timeTxt.text = LanUtil.formateStr(788003, Lua_TimeTransform.transSeconds18(residueTime));
	else
		self:endTimer();
		self.timeTxt.text = nil;
	end
end

function Lua_SkinPurchasePanel:endTimer()
	if self.sTime == true then
		self.sTime = false;
		self:removeTimer(self, self.onTimer);
	end
end

function Lua_SkinPurchasePanel:setModelShow(param)
	if self.modelScenePanel == nil then
		local skinId = DataCenter.skinPurchaseData.skinId;
		local data = DataCenter.heroFashionData:getHeroFashionVo(skinId);
	    if data == nil then
	        data = DataCenter.heroFashionData:getDefaultFashionVo(skinId);
	    end

		if param ~= nil then
			self.modelScenePanel = param;
		else
			self.modelScenePanel = Lua_ModelScenePanel.new();
		end
		self.modelScenePanel:setParent(self.content);
		self.modelScenePanel:setRotBgDimensions(720, 720);
		self.modelScenePanel:setRotBgPos(0, 195);
		
		if not self.modelScenePanel.bShowModel then
			self.modelScenePanel:setModelDir(data.uiModelDir); -- 模型rotate
			self.modelScenePanel:setModelScale(data.uiModelScale); -- 模型scale
			self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UIWAIT, data.poseActEffs); -- ui待机wait
			self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UISHOW, data.showActEffs); -- ui展示show
			self.modelScenePanel:showModelScene(data.uiSceneId, data.uiModelUrl, data.uiModelAvatarName, data.uiModelCamController, true);
			self.modelScenePanel:setModelAct(data.uiShowAct, Lua_ThingDefine.UIWAIT, true);
			self.modelScenePanel:setFurEffShow(self.classname, data.bShowFur);
		end
	end
end

function Lua_SkinPurchasePanel:returnModel()
	if self.modelScenePanel ~= nil then
		self.modelScenePanel:dispose()
		self.modelScenePanel = nil
	end
end









---------增益属性item-----------
Lua_SkinPurchasePropItem = class("Lua_SkinPurchasePropItem", Lua_ListCell);
function Lua_SkinPurchasePropItem:ctor(p)
	self:superCall("ctor", p, "SkinPurchasePropItem_skin");
end

function Lua_SkinPurchasePropItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_SkinPurchasePropItem:setData(data)
    if data == nil then
		return;
	end

	self.attr_value.text = LanUtil.formateStr(788004, data.show_name, data.showValue);
end

function Lua_SkinPurchasePropItem:dispose()
    self:superCall("dispose");
end
























---------道具item-----------
Lua_SkinPurchaseItem = class("Lua_SkinPurchaseItem", Lua_ListCell);
function Lua_SkinPurchaseItem:ctor(p)
	self:superCall("ctor", p, "SkinPurchaseItem_skin");
end

function Lua_SkinPurchaseItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setScale(0.7, 0.7, 0.7);
	self.itemIcon:setSiblingIndex(0);
end

function Lua_SkinPurchaseItem:setData(data)
    if data == nil then
    	self.tvo = nil;
		return;
	end

	local itemId = tonumber(data.id);
	if self.tvo == nil then
		self.tvo = Lua_ToolVo.createToolVo(itemId);
	end
	self.tvo:fromServer(data);

	local skinItemId = DataCenter.skinPurchaseData.skinItemId;
	local has_cloth = DataCenter.skinPurchaseData.has_cloth and skinItemId == itemId;
	self.hasSp:setEnable(has_cloth);
	self.itemIcon:setData(self.tvo);
end

function Lua_SkinPurchaseItem:onPressClick()
	if self.tvo == nil then
		return;
	end

	DataCenter.packUtil:showItemInfo(self.tvo);
end

function Lua_SkinPurchaseItem:dispose()
	self.tvo = nil;
	if self.itemIcon then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
    self:superCall("dispose");
end