-- 异兽争胜 排行奖励panel
Lua_StrangeBeastMatchRankRewardPanel = class("Lua_StrangeBeastMatchRankRewardPanel", Lua_DisplayObject);

function Lua_StrangeBeastMatchRankRewardPanel:ctor(p)
	self:superCall("ctor", p, "StrangeBeastMatchRankRewardPanel_skin");
end

function Lua_StrangeBeastMatchRankRewardPanel:buildPanel()
	self:superCall("buildPanel");
	self:addLuaEvent("UPDATE_STRANGEBEASTMATCH_RANK_REWARD_INFO", self, self.onUpdateInfo);
end

function Lua_StrangeBeastMatchRankRewardPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.dragList = Lua_DragList.new(self.content, 700, 850 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.dragList:setListCell(Lua_StrangeBeastMatchRankRewardItem, 700, 121, 1);
	self.dragList:setCellSpacing(0, 3);
	self.dragList:setLocation(0, -175, 0);

	self.tipBtn:addClickFuntion(self, self.onTipBtnClick);
end

function Lua_StrangeBeastMatchRankRewardPanel:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self:superCall("dispose");
end

function Lua_StrangeBeastMatchRankRewardPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);

	self.dragList:setContentRect(700, 850 + adaptHeight);
end

function Lua_StrangeBeastMatchRankRewardPanel:setData(actVo)
	self.actVo = actVo;
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sStrangeBeastMatchRankRewardInfo(actVo.actIdx);
end

function Lua_StrangeBeastMatchRankRewardPanel:onTipBtnClick()
	local tipData = { des = LanUtil.getValue(786007), posX = 170, posY = -215 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_StrangeBeastMatchRankRewardPanel:onUpdateInfo(msg)
	self.dragList:setArrayData(msg.rank_reward);
end



















Lua_StrangeBeastMatchRankRewardItem = class("Lua_StrangeBeastMatchRankRewardItem", Lua_ListCell);

function Lua_StrangeBeastMatchRankRewardItem:ctor(p)
	self:superCall("ctor", p, "StrangeBeastMatchRankRewardItem_skin");
end

function Lua_StrangeBeastMatchRankRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_ItemIconList.new(self.content);
	self.rewardList.pivot = 1;
	self.rewardList:setLocation(-35, 0, 0);
	self.rewardList:setLayout(130, 130, 999);
	self.rewardList.canClick = true;
	self.rewardList.scaleVal = 0.75;
end

function Lua_StrangeBeastMatchRankRewardItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end

function Lua_StrangeBeastMatchRankRewardItem:setData(data)
	self.data = data;

	local index = data.rank_left;
	if index <= 3 then
		self.rankSp:setAltas("common_altas_4", "xui_jys_label_" .. (9 + index));
	else
		local str = data.rank_left;
		local isDis = data.rank_right ~= nil and data.rank_left ~= data.rank_right;
		if isDis then
			if str > 10 then
				str = str .. "-\n" .. data.rank_right;
			else
				str = str .. "-" .. data.rank_right;
			end
		end
		self.rankTxt.text = str;
		self.rankTxt.fontSize = isDis and 30 or 50;
	end
	self.rankSp:setEnable(index <= 3);
	self.rankBg:setEnable(index > 3);
	self.rankTxt:setEnable(index > 3);

	local rewardList = data.reward;
	local arr = Array();
	local vo;
	for i = 1, #rewardList do
		vo = Lua_ToolVo.createToolVo(rewardList[i].key, rewardList[i].value);
		arr:add(vo);
	end
	self.rewardList:setArrayData(arr);
end