-- 异兽争胜 排行window
Lua_StrangeBeastMatchRankWindow = class("Lua_StrangeBeastMatchRankWindow", Lua_Window);

function Lua_StrangeBeastMatchRankWindow:ctor()
	self:superCall("ctor");

	self.isFullSizeWin = true;
	self.isFullPaving = true;
	self.showBlackMask = true;
	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	
	self.windowName = "Lua_StrangeBeastMatchRankWindow";
	self.skinName = "StrangeBeastMatchRankWindow_skin";
end

function Lua_StrangeBeastMatchRankWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.panelDic = {};

	self.downBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_widget_005", 0, 60.5, 720, 121);
	self.downBg.anchorValue = 7;
	self.downBg.siblingIndex = 0;

	local arr = Array();
	arr:add({panelStr = "Lua_StrangeBeastMatchRankPanel", textAtlas = "common_altas_5", textNormalSprite = "xui_sysl_zgnbutton_2_n", textSelectedSprite = "xui_sysl_zgnbutton_2_p", winBgPath = "/images/common/xui_common_bg_001.jpg"});
	arr:add({panelStr = "Lua_StrangeBeastMatchRankRewardPanel", textAtlas = "activities_atlas_4", textNormalSprite = "xui_yszs_zgnbutton_1_n", textSelectedSprite = "xui_yszs_zgnbutton_1_p", winBgPath = "/images/activities/xui_yszs_bg_1.jpg"});

	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList.pivot = -1;
	self.btnList:setRectAnchor(7);
	self.btnList:setLocation(252, 59, 0);
	self.btnList:setButtonStyle("common_altas_1", "xui_common_zgnbutton_07", "xui_common_zgnbutton_07", 108, 118, 0.01, 1);
	self.btnList:setButtonLine("common_altas_1", "ui_common_line_011", 2, 108, 0, 0, 1);
	self.btnList:setButtonItem(108, 118);
	self.btnList:setRedPoint(40, 40);
	self.btnList:setClickCallBack(self, self.onBtnClick);
	self.btnList:setData(arr);
end

function Lua_StrangeBeastMatchRankWindow:showWin(param)
	self:superCall("showWin", param);
	self.btnList:setSelected(1);
end

function Lua_StrangeBeastMatchRankWindow:dispose()
	if self.panelDic ~= nil then
		for k, v in pairs(self.panelDic) do
			v:dispose();
			v = nil;
		end
		self.panelDic = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.downBg ~= nil then
		self.downBg:dispose();
		self.downBg = nil;
	end
	self:superCall("dispose");
end

function Lua_StrangeBeastMatchRankWindow:onScreenResize()
	self:superCall("onScreenResize");
	
	for k, v in pairs(self.panelDic) do
		v:onScreenResize(self.adaptHeight);
	end
end

function Lua_StrangeBeastMatchRankWindow:onBtnClick(index, data)
	if self.curIdx ~= nil then
		if self.curIdx == index then 
			return;
		end
		if self.panelDic[self.curIdx] ~= nil then
			self.panelDic[self.curIdx]:setEnable(false);
		end
	end
	self.curIdx = index;

	local panel = self.panelDic[index];
	if panel == nil then
		local checkPanel = checkRequire(data.panelStr);
		panel = checkPanel.new(self.content);
		panel:setRectAnchor(9);
		panel:setData(self.showData);
		self.panelDic[index] = panel;
	else
		panel:setEnable(true);
	end

	if data.winBgPath ~= nil then
		self.winBg:setUrl(data.winBgPath);
	end
	self.topImg:setEnable(self.curIdx == 2);
end
