-- 异兽争胜 任务Window
Lua_StrangeBeastMatchTaskWindow = class("Lua_StrangeBeastMatchTaskWindow", Lua_Window);

function Lua_StrangeBeastMatchTaskWindow:ctor()
	self:superCall("ctor");

	self.showClose = true;
	self.showBlackMask = true;
	self.isClickClose = true;

	self.windowName = "Lua_StrangeBeastMatchTaskWindow";
	self.skinName = "StrangeBeastMatchTaskWindow_skin";
end

function Lua_StrangeBeastMatchTaskWindow:buildPanel(go)
	self:superCall("buildPanel", go);

	self:addLuaEvent("UPDATE_STRANGEBEASTMATCH_TASK_INFO", self, self.onUpdateInfo);
	self:addLuaEvent("GET_STRANGEBEASTMATCH_TASK_REWARD", self, self.onGetReward);
end

function Lua_StrangeBeastMatchTaskWindow:buildShowItem()
	self:superCall("buildShowItem");

	local arr = Array();
	arr:add({textStr = LanUtil.getValue(786008), redPointId = Lua_RedPointList.StrangeBeastMatchTaskDaily});
	arr:add({textStr = LanUtil.getValue(786009), redPointId = Lua_RedPointList.StrangeBeastMatchTaskCumulate});

	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList:setButtonStyle("common_altas_1", "xui_common_tab_002", "xui_common_tab_001", 133, 77);
	self.btnList:setButtonText(0, 10, "7A6A5F", "8F5123", 28, 28, Lua_MyUISettings.huakangFontName);
	self.btnList:setRedPoint(55, 25);
	self.btnList:setButtonItem(135, 77);
	self.btnList:setSiblingIndex(0);
	self.btnList:setRectPivot(3);
	self.btnList:setLocation(-330, -570, 0);
	self.btnList:setClickCallBack(self, self.onBtnClick);
	self.btnList:setData(arr);

	self.taskList = Lua_DragList.new(self.content, 628, 700, Lua_AxisDefine.Vertical);
	self.taskList:setListCell(Lua_StrangeBeastMatchTaskItem, 628, 143, 1);
	self.taskList:setCellSpacing(0, 4);
	self.taskList:setLocation(0, -141, 0);
end

function Lua_StrangeBeastMatchTaskWindow:showWin(param)
	self:superCall("showWin", param);
	self.btnList:setSelected(1);
end

function Lua_StrangeBeastMatchTaskWindow:dispose()
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.taskList ~= nil then
		self.taskList:dispose();
		self.taskList = nil;
	end
	self:superCall("dispose");
end

function Lua_StrangeBeastMatchTaskWindow:onBtnClick(index, data)
	if DataCenter.backstageActData:checkActIsEnd(self.showData) then
		self:hide();
		return;
	end
	self.curIdx = index;
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sStrangeBeastMatchTaskInfo(self.showData.actIdx, index);
end

function Lua_StrangeBeastMatchTaskWindow:onUpdateInfo(msg)
	if msg == nil or msg.type ~= self.curIdx then return end

	local list = msg.task_info;
	table.sort(list,
		function(a, b)
			if a.info1 == b.info1 then
				return a.task_id < b.task_id;
			else
				local aWeight = (a.info1 + 1) % 3;
				local bWeight = (b.info1 + 1) % 3;
				return aWeight > bWeight;
			end
		end
	);
	self.taskList:setArrayData(list);
	self.taskList:moveToIndex(1, true, false);
end

function Lua_StrangeBeastMatchTaskWindow:onGetReward(data)
	if DataCenter.backstageActData:checkActIsEnd(self.showData) then
		self:hide();
		return;
	end
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sGetStrangeBeastMatchTaskReward(self.showData.actIdx, self.curIdx, data.task_id);
end






















Lua_StrangeBeastMatchTaskItem = class("Lua_StrangeBeastMatchTaskItem", Lua_ListCell);

function Lua_StrangeBeastMatchTaskItem:ctor(p)
	self:superCall("ctor", p, "StrangeBeastMatchTaskItem_skin");
end

function Lua_StrangeBeastMatchTaskItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 360, 87, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_StrangeBeastMatchTaskRewardItem, 87, 87, 1);
	self.rewardList:setCellSpacing(5, 0);
	self.rewardList:setRectPivot(3);
	self.rewardList:setLocation(-280, -16, 0);
	self:setSubList(self.rewardList);

	self.stateBtn:addClickFuntion(self, self.onGetRewardClick);
end

function Lua_StrangeBeastMatchTaskItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end


function Lua_StrangeBeastMatchTaskItem:setData(data)
	self.data = data;

	self.titleTxt.text = data.dec;

	self.rewardList.canDrag = #data.award > 3;
	self.rewardList:setArrayData(data.award);

	self.progressBar:setMaxValue(data.info2);
	self.progressBar:setValue(data.info3);
	self.progressBar:setText(data.info3 .. "/" .. data.info2);

	if data.info1 == 0 then
		self.stateBtn:setLangValue(786010);
		self.stateBtn:setStyle(16);
	elseif data.info1 == 1 then
		self.stateBtn:setLangValue(786004);
		self.stateBtn:setStyle(1);
	end
	self.progressBar:setEnable(data.info1 ~= 2);
	self.stateBtn:setEnable(data.info1 ~= 2);
	self.drawedIcon:setEnable(data.info1 == 2);

	self:updateRedDot(data.info1 == 1);
end

function Lua_StrangeBeastMatchTaskItem:updateRedDot(bShow)
	if bShow and self.redPoint == nil then
		self.redPoint = Lua_RedPointIcon.new(self.content);
		self.redPoint:createRedPointEff();
		self.redPoint:setLocation(270, 5, 0);
	end
	
	if self.redPoint ~= nil then
		self.redPoint:updateRedPointShow(bShow);
	end
end

function Lua_StrangeBeastMatchTaskItem:onGetRewardClick(go)
	if self.data.info1 == 0 then
		DataCenter.funcPathUtil:gotoFunction(self.data.func_path_id, true);
	elseif self.data.info1 == 1 then
		Lua_MsgUtil.callFunc("GET_STRANGEBEASTMATCH_TASK_REWARD", self.data);
	end
end















Lua_StrangeBeastMatchTaskRewardItem = class("Lua_StrangeBeastMatchTaskRewardItem", Lua_ItemIconCell);

function Lua_StrangeBeastMatchTaskRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon:setScale(0.7, 0.7);
end