-- 见缝插刀排行奖励界面
Lua_ThrowKnifeRankRewardWindow = class("Lua_ThrowKnifeRankRewardWindow", Lua_Window);
function Lua_ThrowKnifeRankRewardWindow:ctor(p)
	self:superCall("ctor");

	self.windowName = "Lua_ThrowKnifeRankRewardWindow";
	self.skinName = "ThrowKnifeRankRewardWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_ThrowKnifeRankRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.itemList = Lua_DragList.new(self.content, 620, 690, Lua_AxisDefine.Vertical);
	self.itemList:setListCell(Lua_ThrowKnifeRankRewardItem, 620, 120, 1);
	self.itemList:setLocation(0, -114, 0);
	self.itemList:setCellSpacing(0, 5);

	self:addLuaEvent("UPDATE_THROWTKNIFE_RANK_REWARD", self, self.updateShowInfo);
end

function Lua_ThrowKnifeRankRewardWindow:showWin(param)
	self:superCall("showWin", param);
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sThrowKnifeRankReward(self.showData.actIdx);
end

function Lua_ThrowKnifeRankRewardWindow:updateShowInfo(msg)
	if msg == nil then
		return;
	end
	table.sort( msg.rank_reward, function(a, b) return a.rank_left < b.rank_left; end );
	self.itemList:setArrayData(msg.rank_reward);
end

function Lua_ThrowKnifeRankRewardWindow:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	if self.myRewardList ~= nil then
		self.myRewardList:dispose();
		self.myRewardList = nil;
	end
	self:superCall("dispose");
end










Lua_ThrowKnifeRankRewardItem = class("Lua_ThrowKnifeRankRewardItem", Lua_ListCell);
function Lua_ThrowKnifeRankRewardItem:ctor(p)
	self:superCall("ctor", p, "ThrowKnifeRankRewardItem_skin");
end

function Lua_ThrowKnifeRankRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 400, 87, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_ThrowKnifeRankRewardIconItem, 87, 87, 1);
	self.rewardList:setLocation(80, 0, 0);
	self.rewardList:setCellSpacing(5, 0);
	self:setSubList(self.rewardList);
end

function Lua_ThrowKnifeRankRewardItem:setData(data)
	if data == nil then
		return;
	end

	if data.rank_left == data.rank_right then
		self.rankBg:setAltas("common_altas_4", "xui_jys_label_1"..(data.rank_left - 1));
		self.rankTxt:setEnable(false);
	else
		self.rankTxt:setEnable(true);
		self.rankBg:setAltas("common_altas_4", "xui_jys_label_13");
		local rightStr;
		if data.rank_right == -1 then
			rightStr = "+";
		else
			if data.rank_right > 100 then
				rightStr = "-\n"..data.rank_right;
			else
				rightStr = "-"..data.rank_right;
			end
		end
		self.rankTxt.text = data.rank_left..rightStr;
	end

	local tvo;
	local tvoArr = Array();
	for i = 1, #data.reward do
		tvo = Lua_ToolVo.createToolVo(data.reward[i].key, data.reward[i].value);
		tvoArr:add(tvo);
	end
	self.rewardList:setArrayData(tvoArr);
	self.rewardList.canDrag = tvoArr:getSize() > 3;
end

function Lua_ThrowKnifeRankRewardItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self:superCall("dispose");
end










Lua_ThrowKnifeRankRewardIconItem = class("Lua_ThrowKnifeRankRewardIconItem", Lua_ItemIconCell)
function Lua_ThrowKnifeRankRewardIconItem:buildShowItem()
	self:superCall("buildShowItem");
	self.itemIcon:setScale(0.7, 0.7);
end