-- 见缝插刀结算界面
Lua_ThrowKnifeResultWindow = class("Lua_ThrowKnifeResultWindow", Lua_Window);
function Lua_ThrowKnifeResultWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ThrowKnifeResultWindow";
	self.skinName = "ThrowKnifeResultWindow_skin";
	self.showBlackMask = true;
end

function Lua_ThrowKnifeResultWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.resultBtn:addClickFuntion(self, self.onResultClick);
	self.reviveBtn:addClickFuntion(self, self.onReviveClick);
end

function Lua_ThrowKnifeResultWindow:showWin(param)
	self:superCall("showWin", param);

	local historyScore = DataCenter.throwKnifeData.topGrade;
	local allTimes = DataCenter.throwKnifeData.allTimes;
	self.myScoreTxt.text = param.result;
	self.historyTxt.text = LanUtil.formateStr(776013, historyScore);
	self.buyTimesTxt.text = LanUtil.formateStr(776014, param.reviveTimes, allTimes);

	-- 0失败，1通关，2结算
	self.reviveBtn:setMouseEnable(param.state ~= 2);
	self.reviveBtn:setGray(param.reviveTimes <= 0 or param.state == 2);
	self.newIcon:setEnable(historyScore < param.result);
	self.buyTimesTxt:setEnable(param.state == 0 and param.reviveTimes > 0);
	self:startCloseTimer();
end

function Lua_ThrowKnifeResultWindow:startCloseTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		self.showTime = 11;
		self:updateCloseTimer();
		self:addTimer("Lua_ThrowKnifeResultWindow", 1, self, self.updateCloseTimer);
	end
end

function Lua_ThrowKnifeResultWindow:updateCloseTimer()
	if not self.bPauseTimer then
		self.showTime = self.showTime - 1;
		if self.showTime <= 0 then
			self:onResultClick();
			self:endCloseTimer();
		end
		self.closeTimeTxt.text = LanUtil.formateStr(776017, self.showTime);
	end
end

function Lua_ThrowKnifeResultWindow:endCloseTimer()
	if self.bTimer == true then
		self.bTimer = false;
		self:removeTimer(self, self.updateCloseTimer);
	end
end

function Lua_ThrowKnifeResultWindow:onResultClick()
	Lua_MsgUtil.callFunc("ON_THROWTKNIFE_RESULT_CLICK", self.showData.state);
	Lua_MsgUtil.callFunc("ON_THROWTKNIFE_REFRESH_CLICK");
	self:hide();
end

function Lua_ThrowKnifeResultWindow:onReviveClick()
	if self.showData.state == 0 then
		if self.showData.reviveTimes > 0 then
			local allTimes = DataCenter.throwKnifeData.allTimes;
			local itemCostNum = DataCenter.throwKnifeData.itemUseList[allTimes - self.showData.reviveTimes + 1];
			if DataCenter.moneyData:isMoneyEnough(DataCenter.throwKnifeData.itemCostId, itemCostNum, true) then
				self.bPauseTimer = true;
				local desStr;
				if itemCostNum <= 0 then
					desStr = LanUtil.getValue(776025);
				else
					local tvo = Lua_ToolVo.createToolVo(DataCenter.throwKnifeData.itemCostId);
					local str = spliceIconStr(tvo.iconAtlas, tvo.iconSprite, tvo.iconWidth * 0.8, tvo.iconHeight * 0.8);
					desStr = LanUtil.formateStr(776026, str, itemCostNum);
				end
				local tipsData = {
					owner = self,
					des = desStr;
					btnType = 1,
					onFunType = 2,
					cancelLabel = LanUtil.getValue(776023),
					sureLabel = LanUtil.getValue(776016),
					cancelFun = self.onResultClick,
					sureFun = self.onSureFun,
					ownerFun = self.onOwnerFun
				};
				Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
			end
		else
			OperateAlert.showLangValue(776018);
		end
	elseif self.showData.state == 1 then
		OperateAlert.showLangValue(776015);
	end
end

function Lua_ThrowKnifeResultWindow:onSureFun()
	Lua_MsgUtil.callFunc("ON_THROWTKNIFE_REVICE_CLICK");
	self:hide();
end

function Lua_ThrowKnifeResultWindow:onOwnerFun()
	self.bPauseTimer = false;
end

function Lua_ThrowKnifeResultWindow:dispose()
	self:endCloseTimer();
	self:superCall("dispose");
end