-- 见缝插刀任务界面
Lua_ThrowKnifeTaskWindow = class("Lua_ThrowKnifeTaskWindow", Lua_Window);
function Lua_ThrowKnifeTaskWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ThrowKnifeTaskWindow";
	self.skinName = "ThrowKnifeTaskWindow_skin";
	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.showClose = true;
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_ThrowKnifeTaskWindow:buildShowItem()
	self:superCall("buildShowItem");

	local arr = Array();
	arr:add({textStr = LanUtil.getValue(776019), redPointId = Lua_RedPointList.ThrowKnife_Task_Daily});
	arr:add({textStr = LanUtil.getValue(776020), redPointId = Lua_RedPointList.ThrowKnife_Task_Cumulate});

	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList:setButtonStyle("common_altas_1", "xui_common_tab_002", "xui_common_tab_001", 133, 77);
	self.btnList:setButtonText(0, 10, "7A6A5F", "8F5123", 28, 28, Lua_MyUISettings.huakangFontName);
	self.btnList:setRedPoint(45, 15);
	self.btnList:setButtonItem(135, 77);
	self.btnList:setSiblingIndex(0);
	self.btnList:setRectPivot(3);
	self.btnList:setLocation(-330, -570, 0);
	self.btnList:setClickCallBack(self, self.onBtnClick);
	self.btnList:setData(arr);

	self.taskList = Lua_DragList.new(self.content, 628, 700, Lua_AxisDefine.Vertical);
	self.taskList.tweenId = 2023;
	self.taskList.delayTween = true;
	self.taskList:setListCell(Lua_ThrowKnifeTaskItem, 628, 143, 1);
	self.taskList:setCellSpacing(0, 4);
	self.taskList:setLocation(0, -141, 0);

	self:addLuaEvent("UPDATE_THROWTKNIFE_TASK_INFO", self, self.updateThrowKnifeTaskInfo);
	self:addLuaEvent("ON_THROWTKNIFE_DRAWREWARD_CLICK", self, self.onThrowKnifeDrawRewardClick);
end

function Lua_ThrowKnifeTaskWindow:showWin(param)
	self:superCall("showWin", param);
	self.btnList:setSelected(1);
end

function Lua_ThrowKnifeTaskWindow:onBtnClick(val)
	self.taskList.showTween = true;
	self.taskType = val;
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sThrowKnifeTaskInfo(self.showData.actIdx, val);
end

function Lua_ThrowKnifeTaskWindow:updateThrowKnifeTaskInfo(msg)
	if msg == nil or msg.type ~= self.taskType then
		return;
	end

	-- 可领取＞未达成＞已领取，info1：0未完成 1可领取 2已领取
	table.sort( msg.task_info,
		function(a, b)
			if a.info1 == b.info1 then
				return a.task_id < b.task_id;
			else
				local aWeight = (a.info1 + 1) % 3;
				local bWeight = (b.info1 + 1) % 3;
				return aWeight > bWeight;
			end
		end
	);
	self.taskList:setArrayData(msg.task_info);
	self.taskList:moveToIndex(1, true, false);
end

function Lua_ThrowKnifeTaskWindow:onThrowKnifeDrawRewardClick(data)
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sDrawThrowKnifeTaskReward(self.showData.actIdx, self.taskType, data.task_id);
end

function Lua_ThrowKnifeTaskWindow:dispose()
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.taskList ~= nil then
		self.taskList:dispose();
		self.taskList = nil;
	end
	self:superCall("dispose");
end










Lua_ThrowKnifeTaskItem = class("Lua_ThrowKnifeTaskItem", Lua_ListCell);
function Lua_ThrowKnifeTaskItem:ctor(p)
	self:superCall("ctor", p, "ThrowKnifeTaskItem_skin");
end

function Lua_ThrowKnifeTaskItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 360, 87, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_ThrowKnifeTaskRewardItem, 87, 87, 1);
	self.rewardList:setCellSpacing(9, 0);
	self.rewardList:setRectPivot(3);
	self.rewardList:setLocation(-280, -16, 0); -- -242
	self:setSubList(self.rewardList);

	self.stateBtn:addClickFuntion(self, self.onDrawRewardClick);
end

function Lua_ThrowKnifeTaskItem:setData(data)
	self._data = data;
	if self._data == nil then
		return;
	end

	self.titleTxt.text = data.dec;
	self.rewardList.canDrag = #data.award > 3;
	self.rewardList:setArrayData(data.award);
	self.progressBar:setMaxValue(data.info2);
	self.progressBar:setValue(data.info3);
	self.progressBar:setText(data.info3 .. "/" .. data.info2);

	if data.info1 == 0 then
		self.stateBtn:setLangValue(776021);
		self.stateBtn:setMouseEnable(false);
		self.stateBtn:setStyle(16);
	elseif data.info1 == 1 then
		self.stateBtn:setLangValue(776022);
		self.stateBtn:setMouseEnable(true);
		self.stateBtn:setStyle(1);
	end
	self.progressBar:setEnable(data.info1 ~= 2);
	self.stateBtn:setEnable(data.info1 ~= 2);
	self.drawedIcon:setEnable(data.info1 == 2);
end

function Lua_ThrowKnifeTaskItem:onDrawRewardClick(go)
	Lua_MsgUtil.callFunc("ON_THROWTKNIFE_DRAWREWARD_CLICK", self._data);
end

function Lua_ThrowKnifeTaskItem:dispose()
	self._data = nil;
	self:superCall("dispose");
end










Lua_ThrowKnifeTaskRewardItem = class("Lua_ThrowKnifeTaskRewardItem", Lua_ItemIconCell);
function Lua_ThrowKnifeTaskRewardItem:buildShowItem()
	self:superCall("buildShowItem");
	self.itemIcon:setScale(0.7, 0.7);
end