-- 见缝插刀Demo界面
Lua_ThrowKnifeTestWindow = class("Lua_ThrowKnifeTestWindow", Lua_Window);
function Lua_ThrowKnifeTestWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ThrowKnifeTestWindow";
	self.skinName = "ThrowKnifeTestWindow_skin";
	self.isFullSizeWin = true;
	self.showWinBg = true;
	self.showBackBtn = true;
	self.winBgPath = "/images/common/ui_common_bg_001.jpg";
end

function Lua_ThrowKnifeTestWindow:buildShowItem()
	self:superCall("buildShowItem");

	-- self.targetEff_1 = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_jfcd_yp_01", "ui_jfcd_yp_01", 0, 0);
	-- self.targetEff_2 = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_jfcd_yp_02", "ui_jfcd_yp_02", 0, 0);
	-- self.targetEff_3 = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_jfcd_yp_03", "ui_jfcd_yp_03", 0, 0);
	-- self.uiEffect_1 = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_jfcd_xd_01", "ui_jfcd_xd_01", 0, 0); -- 小刀
	-- self.uiEffect_2 = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_jfcd_sg_01", "ui_jfcd_sg_01", 0, 0); -- 水果

	self.reStartBtn:setEnable(false);
	self.upImg:setParent(self.turntableImg.mainContent);
	self.upImg:setLocation(0, 0, 0);
	self:initGame();

	self.speedInput.keyboardTypeValue = 12;
	self.speedInput.contentTypeValue = 2; -- 内容类型
	self.speedInput.characterValidationValue = 2; -- 字符验证，数字样式(允许 . 和 -)
	self.speedInput.defaultText = "输入速度倍率";
	self.speedInput.text = self.rotateSpeed;
	self.speedInput:onEndEdit(self, self.updateSpeed);

	self.timeInput.keyboardTypeValue = 12;
	self.timeInput.contentTypeValue = 2; -- 内容类型
	self.timeInput.characterValidationValue = 2; -- 字符验证，数字样式(允许 . 和 -)
	self.timeInput.defaultText = "输入速度倍率";
	self.timeInput.text = self.moveKnifeTime;
	self.timeInput:onEndEdit(self, self.updateTime);

	self.intervalInput.keyboardTypeValue = 12;
	self.intervalInput.contentTypeValue = 2; -- 内容类型
	self.intervalInput.characterValidationValue = 2; -- 字符验证，数字样式(允许 . 和 -)
	self.intervalInput.defaultText = "输入刀间隔时间";
	self.intervalInput.text = self.intervalKnifeTime;
	self.intervalInput:onEndEdit(self, self.updateInterval);

	-- 计算最大角度
	local miniRadius = self.fruitIcon.width / 2; -- 水果半径
	local miniPosX = 0; -- 水果圆心X坐标
	local miniPosY = self.radius; -- 水果圆心Y坐标
	local minusWidth = miniPosY * miniPosY - miniRadius * miniRadius; -- 底圆到水果顶点的距离
	-- 直角向量法 (x1 - x2)(x3 - x2) + (y1 - y2)(y3 - y2) = 0，底圆圆心坐标为原点(0，0)
	-- a. (0 - needPosX) * (miniPosX - needPosX) + (0 - needPosY) * (miniPosY - needPosY) = 0;
	-- b. needPosX * needPosX + needPosY * needPosY - miniPosY * needPosY = 0;
	-- c. needPosX * needPosX + needPosY * needPosY = minusWidth;
	-- minusWidth - needPosY * miniPosY = 0;
	local needPosY = minusWidth / miniPosY;
	local needPosX = Mathf.Sqrt(minusWidth - needPosY * needPosY);
	local needAngle = Mathf.Atan2(needPosY, needPosX) * 180 / Mathf.PI;
	self.fruitMaxAngle = 90 - needAngle;

	-- 计算最大角度
	miniRadius = self.knifeIcon.width / 2; -- 小刀半径
	miniPosX = 0; -- 小刀圆心X坐标
	miniPosY = self.radius - self.fruitIcon.width / 2; -- 小刀圆心Y坐标
	minusWidth = miniPosY * miniPosY - miniRadius * miniRadius; -- 底圆到小刀顶点的距离
	needPosY = minusWidth / miniPosY;
	needPosX = Mathf.Sqrt(minusWidth - needPosY * needPosY);
	needAngle = Mathf.Atan2(needPosY, needPosX) * 180 / Mathf.PI;
	self.knifeMaxAngle = 90 - needAngle;
	self.maxAngleTxt.text = LanUtil.formateStr("靶子圆心和水果顶点最大角度：{1}和小刀顶点最大角度{2}",
		string.format("%.2f", self.fruitMaxAngle), string.format("%.2f", self.knifeMaxAngle));

	Lua_CommonUtil.addTimer("Lua_ThrowKnifeTestWindow", 0.01, self, self.onRotateFun, nil, -1, true);
	self.mask:addClickFuntion(self, self.onThrowClick);
	self.reStartBtn:addClickFuntion(self, self.onReStartClick);
end

function Lua_ThrowKnifeTestWindow:initGame()
	self.recordTime = getTime();
	self.idxArr = Array();
	self.remainTime = getTime();
	self.isFail = false;

	self.curIdx = 0;
	self.radius = 226;
	self._angle = 0;
	self.rotateSpeed = 50;
	self.recordInfoArr = Array(); -- iconType：1刀，2水果，resultAngle：停止时的角度

	self.startPosY = -300;
	self.moveKnifeTime = 0.5;
	self.intervalKnifeTime = 0.2;
	self.distance = self.turntableImg.posY - self.radius - self.startPosY;
	self.isNewRound = true; -- 是否是新一轮
	self:createKnifeFun();
end

function Lua_ThrowKnifeTestWindow:onRotateFun()
	local time = getTime();
	local dt = time - self.remainTime;
	self.remainTime = time;

	local changeAngle = dt * self.rotateSpeed;
	self.angle = self.angle + changeAngle;

	if self.isThrowKnife then
		local angle = self.angle;
		local idx, moveTime, moveDistance, moveY, isResult, resultAngle, itemPosX;
		for i = 1, self.idxArr:getSize() do
			idx = self.idxArr[i];
			moveTime = self.recordInfoArr[idx].moveTime;
			moveTime = moveTime - dt;
			self.recordInfoArr[idx].moveTime = moveTime;

			moveDistance = 1 - moveTime / self.moveKnifeTime;
			moveY = self.distance * moveDistance;
			self.recordInfoArr[idx]:setLocation(0, self.startPosY + moveY, 0);
			if moveTime <= 0 then
				isResult = true;

				resultAngle = 270 - angle; -- 刀初始在270度
				resultAngle = resultAngle < 0 and resultAngle + 360 or resultAngle;
				-- itemPosX = self.radius * Mathf.Cos(Mathf.Rad(resultAngle));
				-- itemPosY = self.radius * Mathf.Sin(Mathf.Rad(resultAngle));
				itemPosX = (self.turntableImg.posY - moveY - self.startPosY) * Mathf.Cos(Mathf.Rad(resultAngle));
				itemPosY = (self.turntableImg.posY - moveY - self.startPosY) * Mathf.Sin(Mathf.Rad(resultAngle));

				self.recordInfoArr[idx].knifeState = 2;
				self.recordInfoArr[idx].resultAngle = resultAngle;
				self.recordInfoArr[idx]:setParent(self.turntableImg.mainContent);
				self.recordInfoArr[idx]:setSiblingIndex(idx - 1);
				self.recordInfoArr[idx]:setLocation(itemPosX, itemPosY, 0);
				self.recordInfoArr[idx]:setIconRot(resultAngle + 90);
			end
		end
		if isResult then
			self:judgeResult();
		end
	end
end

function Lua_ThrowKnifeTestWindow.Get:angle()
	return self._angle;
end

function Lua_ThrowKnifeTestWindow.Set:angle(val)
	if val and self._angle ~= val % 360 then
		self._angle = val % 360;
		self.turntableImg:setRot(0, 0, val);
	end
end

function Lua_ThrowKnifeTestWindow.Get:isThrowKnife()
	for i = 1, self.curIdx do
		if self.recordInfoArr[i].knifeState == 1 then
			return true;
		end
	end
	return false;
end

function Lua_ThrowKnifeTestWindow:judgeResult()
	local state = 1; -- 成功得分
	local actIdx = 1;
	local minMinus, hitFruitIdx;
	if self.curIdx > 1 then
		local idx, curItem, compareItem, angleMinus;
		for i = 1, self.idxArr:getSize() do
			idx = self.idxArr[actIdx];
			curItem = self.recordInfoArr[idx];
			actIdx = actIdx + 1;
			if curItem.knifeState == 2 then
				actIdx = actIdx - 1;
				self.idxArr:shift();
			elseif curItem.knifeState == 1 then
				break;
			end
			for j = 1, idx - 1 do
				compareItem = self.recordInfoArr[j];
				if compareItem.isActive then
					angleMinus = Mathf.Abs(curItem.resultAngle - compareItem.resultAngle);
					angleMinus = angleMinus > 180 and 360 - angleMinus or angleMinus;
					if minMinus == nil or minMinus > angleMinus then
						minMinus = angleMinus;
						if compareItem.iconType == 1 then -- 障碍物
							if minMinus <= self.knifeMaxAngle then
								state = 0; -- 失败
								break;
							end
						else
							if minMinus <= self.fruitMaxAngle + self.knifeMaxAngle then
								state = 1; -- 成功得水果分
								hitFruitIdx = j; -- 击中水果
							end
						end
					end
				end
			end
			if state == 0 then
				break;
			end
		end
	end
	self.angleMinusTxt.text = LanUtil.formateStr("当前相差最小角度：{1}", minMinus);

	-- 播放闪光特效
	self.turntableImg:setScale(1.05, 1.05, 1);
	TweenUtil.getInstance():addTweenTargetScale(self.turntableImg.mainContent,
		0.1, 0, 1, 1, 1, self, self.stopScaleTween);
	if hitFruitIdx then
		self.recordInfoArr[hitFruitIdx]:setEnable(false); 
		-- 播放水果被分开的特效
	end
	if state == 0 then
		self.isFail = true;
		self.reStartBtn:setEnable(true);
		Lua_CommonUtil.removeTimer(self, self.onRotateFun, true);
	end
end

function Lua_ThrowKnifeTestWindow:stopScaleTween()
	-- self.turntableImg:setScale(1, 1, 1);
	TweenUtil.getInstance():stop(self.turntableImg.mainContent);
end

function Lua_ThrowKnifeTestWindow:setNewRoundInfo()
	for i = 1, self.recordInfoArr:getSize() do
		self.recordInfoArr[i].moveTime = self.moveKnifeTime;
		self.recordInfoArr[i].knifeState = 0;
		self.recordInfoArr[i]:setEnable(false);
	end
end

function Lua_ThrowKnifeTestWindow:createKnifeFun()
	-- 创建障碍物或水果
	if self.isNewRound then
		self.isNewRound = false;
		self:createNewRoundInfo();
	end

	-- 创建小刀
	self.curIdx = self.curIdx + 1;
	local item = self.recordInfoArr[self.curIdx];
	if item == nil then
		item = Lua_ThrowKnifeTestItem.new(self.content);
		item.contentName = "Lua_ThrowKnifeTestItem_" .. self.curIdx;
		self.recordInfoArr:add(item);
	end
	item.knifeState = 0;
	item.moveTime = self.moveKnifeTime;
	item:setParent(self.content);
	item:setSiblingIndex(1);
	item:setLocation(0, self.startPosY, 0);
	item:setData({iconType = 1, angle = 270});
	item:setEnable(true);
end

function Lua_ThrowKnifeTestWindow:createNewRoundInfo()
	local list = {
		{iconType = 1, angle = 30},
		{iconType = 2, angle = 70},
		{iconType = 2, angle = 130},
		{iconType = 1, angle = 200},
		{iconType = 1, angle = 260},
		{iconType = 2, angle = 300},
		{iconType = 1, angle = 340}
	};

	local item, itemPosX, itemPosY;
	local dataLen = Mathf.Random(0, #list);
	local arrLen = self.recordInfoArr:getSize();
	local maxLen = dataLen > arrLen and dataLen or arrLen;
	self.curIdx = 0;
	for i = 1, maxLen do
		item = self.recordInfoArr[i];
		if i > dataLen then
			if item ~= nil then
				item:setEnable(false);
			end
		else
			self.curIdx = self.curIdx + 1;

			itemPosX = self.radius * Mathf.Cos(Mathf.Rad(list[i].angle));
			itemPosY = self.radius * Mathf.Sin(Mathf.Rad(list[i].angle));
			if item == nil then
				item = Lua_ThrowKnifeTestItem.new(self.turntableImg.mainContent);
				item:setSiblingIndex(i - 1);
				item.contentName = "Lua_ThrowKnifeTestItem_" .. i;
				self.recordInfoArr:add(item);
			end
			item.knifeState = 0;
			item.moveTime = self.moveKnifeTime;
			item:setLocation(itemPosX, itemPosY, 0);
			item:setData(list[i]);
			item:setEnable(true);
		end
	end
end

function Lua_ThrowKnifeTestWindow:updateSpeed()
	if self.speedInput.text == "" then
		val = 1;
	else
		val = tonumber(self.speedInput.text);
	end
	self.rotateSpeed = val;
end

function Lua_ThrowKnifeTestWindow:updateTime()
	if self.timeInput.text == "" then
		val = 1;
	else
		val = tonumber(self.timeInput.text);
	end
	self.moveKnifeTime = val;
end

function Lua_ThrowKnifeTestWindow:updateInterval()
	if self.intervalInput.text == "" then
		val = 1;
	else
		val = tonumber(self.intervalInput.text);
	end
	self.intervalKnifeTime = val;
end

function Lua_ThrowKnifeTestWindow:onThrowClick(go)
	local newTime = getTime();
	if not self.isFail and newTime - self.recordTime > self.intervalKnifeTime then
		self.recordTime = newTime;
		self.recordInfoArr[self.curIdx].knifeState = 1;
		self.idxArr:add(self.curIdx);
		self:createKnifeFun();
	end
	print(self.recordTime, newTime);
end

function Lua_ThrowKnifeTestWindow:onReStartClick(go)
	self.isFail = false;
	self.isNewRound = true;
	self.idxArr:clear();
	self.reStartBtn:setEnable(false);
	self:setNewRoundInfo();
	self:createKnifeFun();
	Lua_CommonUtil.addTimer("Lua_ThrowKnifeTestWindow", 0.01, self, self.onRotateFun, nil, -1, true);
end

function Lua_ThrowKnifeTestWindow:dispose()
	if self.recordInfoArr ~= nil then
		self.recordInfoArr:dispose();
		self.recordInfoArr:clear();
		self.recordInfoArr = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.onRotateFun, true);
	self:superCall("dispose");
end










Lua_ThrowKnifeTestItem = class("Lua_ThrowKnifeTestItem", Lua_DisplayObject);
function Lua_ThrowKnifeTestItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_ThrowKnifeTestItem:buildShowItem()
	self:superCall("buildShowItem");
	self.icon = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
end

function Lua_ThrowKnifeTestItem:setData(data)
	if data == nil then
		return;
	end

	self.iconType = data.iconType;
	self.resultAngle = data.angle;

	local showAngle;
	if data.iconType == 1 then
		showAngle = data.angle + 90; -- 刀初始显示为90度
		self.icon:setAltas("throw_knife_atlas", "xui_jfcd_widget_6");
	else
		showAngle = data.angle - 90; -- 水果初始显示为-90度
		self.icon:setAltas("throw_knife_atlas", "xui_jfcd_widget_4");
	end
	self.icon:resetSize();
	self:setIconRot(showAngle);
end

function Lua_ThrowKnifeTestItem:setIconRot(angle)
	self.icon:setRot(0, 0, angle);
end

function Lua_ThrowKnifeTestItem.Get:iconType()
	return self._iconType or 1;
end

function Lua_ThrowKnifeTestItem.Set:iconType(val)
	self._iconType = val;
end

function Lua_ThrowKnifeTestItem.Get:moveTime()
	return self._moveTime or 0;
end

function Lua_ThrowKnifeTestItem.Set:moveTime(val)
	self._moveTime = val;
end

-- 0未射击，1射击中，2射中靶子
function Lua_ThrowKnifeTestItem.Get:knifeState()
	return self._knifeState or 0;
end

function Lua_ThrowKnifeTestItem.Set:knifeState(val)
	self._knifeState = val;
end

function Lua_ThrowKnifeTestItem.Get:resultAngle()
	return self._resultAngle or 0;
end

function Lua_ThrowKnifeTestItem.Set:resultAngle(val)
	self._resultAngle = val;
end

function Lua_ThrowKnifeTestItem:dispose()
	if self.icon ~= nil then
		self.icon:dispose();
		self.icon = nil;
	end
	self:superCall("dispose");
end