-- 图腾招募
Lua_TotemRecruitPanel = class("Lua_TotemRecruitPanel", Lua_DisplayObject);
function Lua_TotemRecruitPanel:ctor(p, skinName)
	self:superCall("ctor", p, skinName);
end

function Lua_TotemRecruitPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.recruitType = 1;
	self.isNeedPlayTween = true;
	self.moneyItemArr = Array();
	self.showItemArr = Array();

	self.boxModelEffImg_1 = UICreate.createModelEffImg(self.content, "/model/ttmb/ttmb_baoxiang", "baoxiang_01", -202, -41, 0, 0);
	self.boxModelEffImg_1.canRot = false;
	-- self.boxModelEffImg_1:setScale(0.5, 0.5, 0.5);
	self.boxModelEffImg_1:setCamField(1.7, 1, 100, true);
	self.boxModelEffImg_1:setCamPos(-2.6, 2.4, -5.88);
	self.boxModelEffImg_1:setCamRot(19.6, 23.8, 1);
	self.boxModelEffImg_1:setModelEffDir(180);
	self.boxModelEffImg_1:setActionName("close");
	-- self.boxModelEffImg_1:setShader("Default No-Alpha");

	self.boxModelEffImg_2 = UICreate.createModelEffImg(self.content, "/model/ttmb/ttmb_baoxiang", "baoxiang_02", 0, -128, 0, 0);
	self.boxModelEffImg_2.canRot = false;
	-- self.boxModelEffImg_2:setScale(0.5, 0.5, 0.5);
	self.boxModelEffImg_2:setCamField(1.7, 1, 100, true);
	self.boxModelEffImg_2:setCamPos(-2.6, 2.4, -5.88);
	self.boxModelEffImg_2:setCamRot(19.6, 23.8, 1);
	self.boxModelEffImg_2:setModelEffDir(180);
	self.boxModelEffImg_2:setActionName("close");
	-- self.boxModelEffImg_2:setShader("Default No-Alpha");

	self.boxModelEffImg_3 = UICreate.createModelEffImg(self.content, "/model/ttmb/ttmb_baoxiang", "baoxiang_03", 217, -41, 0, 0);
	self.boxModelEffImg_3.canRot = false;
	-- self.boxModelEffImg_3:setScale(0.5, 0.5, 0.5);
	self.boxModelEffImg_3:setCamField(1.7, 1, 100, true);
	self.boxModelEffImg_3:setCamPos(-2.6, 2.4, -5.88);
	self.boxModelEffImg_3:setCamRot(19.6, 23.8, 1);
	self.boxModelEffImg_3:setModelEffDir(180);
	self.boxModelEffImg_3:setActionName("close");
	-- self.boxModelEffImg_3:setShader("Default No-Alpha");

	self.taskRedPoint = Lua_RedPointIcon.new(self.content, Lua_RedPointList.TotemRecruit_Task);
	self.taskRedPoint:setRectAnchor(1);
	self.taskRedPoint:setLocation(330, -267, 0);

	self.primaryRedPoint = Lua_RedPointIcon.new(self.content, Lua_RedPointList.TotemRecruit_Primary);
	self.primaryRedPoint:setLocation(-155, 55, 0);

	self.intermediateRedPoint = Lua_RedPointIcon.new(self.content, Lua_RedPointList.TotemRecruit_Intermediate);
	self.intermediateRedPoint:setLocation(47, -32, 0);

	self.seniorRedPoint = Lua_RedPointIcon.new(self.content, Lua_RedPointList.TotemRecruit_Senior);
	self.seniorRedPoint:setLocation(264, 55, 0);

	self.drawOneRedPoint = Lua_RedPointIcon.new(self.content, Lua_RedPointList.TotemRecruit_Primary_One);
	self.drawOneRedPoint:setRectAnchor(7);
	self.drawOneRedPoint:setLocation(-72, 362, 0);

	self.drawMoreRedPoint = Lua_RedPointIcon.new(self.content, Lua_RedPointList.TotemRecruit_Primary_More);
	self.drawMoreRedPoint:setRectAnchor(7);
	self.drawMoreRedPoint:setLocation(246, 362, 0);

	self.timesNum = Lua_NumberImage.new(self.content);
	self.timesNum.pivot = 0;
	self.timesNum.numAtlas = "number"
	self.timesNum.preStr = "xui_ttmb_number_";
	self.timesNum.numOffsetX = -22;
	self.timesNum:setRectAnchor(7);
	self.timesNum:setLocation(-143.5, 452, 0);

	self.recruitBtn_1.alpha = 0.01;
	self.recruitBtn_2.alpha = 0.01;
	self.recruitBtn_3.alpha = 0.01;
	self.ruleBtn:addClickFuntion(self, self.onRuleClick);
	self.recruitBtn_1:addClickFuntion(self, self.onRecruit1Click);
	self.recruitBtn_2:addClickFuntion(self, self.onRecruit2Click);
	self.recruitBtn_3:addClickFuntion(self, self.onRecruit3Click);
	self.previewBtn:addClickFuntion(self, self.onPreviewClick);
	self.taskBtn:addClickFuntion(self, self.onTaskClick);
	self.oneDrawBtn:addClickFuntion(self, self.onOneDrawClick);
	self.moreDrawBtn:addClickFuntion(self, self.onMoreDrawClick);
	self.readBtn:addClickFuntion(self, self.onReadClick);

	self:addLuaEvent("UPDATE_TOTEMRECRUIT_INFO", self, self.updateTotemRecruitInfo);
	self:addLuaEvent("PACK_ITEMS_UPDATE", self, self.updateTotemRecruitCost);
	self:addLuaEvent("MONEY_UPDATE", self, self.updateTotemRecruitCost);
	self:addLuaEvent("UPDATE_TOTEMRECRUIT_RECORD_INFO", self, self.updateTotemRecruitRecordInfo);
	self:addLuaEvent("REQUEST_TOTEMRECRUIT_ONE_DRAW", self, self.onOneDrawClick);
	self:addLuaEvent("REQUEST_TOTEMRECRUIT_MORE_DRAW", self, self.onMoreDrawClick);
end

function Lua_TotemRecruitPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
end

function Lua_TotemRecruitPanel:setData(actVo)
	self.actVo = actVo;
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sTotemRecruitRecordInfo(self.actVo.actIdx, self.recruitType);
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sTotemRecruitTaskInfo(self.actVo.actIdx, 1);
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sTotemRecruitTaskInfo(self.actVo.actIdx, 2);

	self:startTimer();
	self:updateLeftTime();
end

function Lua_TotemRecruitPanel:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		self:addTimer("Lua_TotemRecruitPanel", 1, self, self.updateLeftTime);
	end
end

function Lua_TotemRecruitPanel:updateLeftTime()
	local time = self.actVo.residueTime;
	self.leftTimeTxt.text = LanUtil.formateStr(784000, Lua_TimeTransform.transSeconds20(time, true, true));
	if time <= 0 then
		self.leftTimeTxt:setLangValue(784001);
		self:endTimer();
	end
end

function Lua_TotemRecruitPanel:endTimer()
	if self.bTimer == true then
		self.bTimer = false;
		self:removeTimer(self, self.updateLeftTime);
	end
end

function Lua_TotemRecruitPanel:updateTotemRecruitInfo(msg)
	if msg == nil then
		return;
	end

	if msg.index == self.recruitType then
		if self.recruitType == 1 then -- 初级
			self.drawOneRedPoint:changeRedPoint(Lua_RedPointList.TotemRecruit_Primary_One);
			self.drawMoreRedPoint:changeRedPoint(Lua_RedPointList.TotemRecruit_Primary_More);
		elseif self.recruitType == 2 then -- 中级
			self.drawOneRedPoint:changeRedPoint(Lua_RedPointList.TotemRecruit_Intermediate_One);
			self.drawMoreRedPoint:changeRedPoint(Lua_RedPointList.TotemRecruit_Intermediate_More);
		else -- 高级
			self.drawOneRedPoint:changeRedPoint(Lua_RedPointList.TotemRecruit_Senior_One);
			self.drawMoreRedPoint:changeRedPoint(Lua_RedPointList.TotemRecruit_Senior_More);
		end
		self:onOpenAniFun();
		self:showTotemRecruitInfo();
	end
	self:setBtnShowSelect();
end

function Lua_TotemRecruitPanel:onOpenAniFun()
	Lua_MsgUtil.callFunc("OPERATIONAL_ACTIVITIES_CLICKLIMIT", 3);
	if self.recruitType == 1 then
		self.boxModelEffImg_1:setActionName("open");
	elseif self.recruitType == 2 then
		self.boxModelEffImg_2:setActionName("open");
	else
		self.boxModelEffImg_3:setActionName("open");
	end

	local closeType = self.preType or 1;
	if closeType == 1 then
		self.boxModelEffImg_1:setActionName("close");
		self.boxModelEffImg_1:removeHangerEff("ttmb_cjdh_01_wait");
	elseif closeType == 2 then
		self.boxModelEffImg_2:setActionName("close");
		self.boxModelEffImg_2:removeHangerEff("ttmb_cjdh_02_wait");
	else
		self.boxModelEffImg_3:setActionName("close");
		self.boxModelEffImg_3:removeHangerEff("ttmb_cjdh_03_wait");
	end
	self.preType = self.recruitType;
	Lua_CommonUtil.removeTimer(self, self.onWaitAniFun);
	Lua_CommonUtil.delayCall(0.3, self, self.onWaitAniFun);
end

function Lua_TotemRecruitPanel:onWaitAniFun()
	Lua_MsgUtil.callFunc("OPERATIONAL_ACTIVITIES_CLICKLIMIT", 0);
	if self.recruitType == 1 then
		self.boxModelEffImg_1:setActionName("wait");
		self.boxModelEffImg_1:addHangerEff("ttmb_cjdh_01_wait");
	elseif self.recruitType == 2 then
		self.boxModelEffImg_2:setActionName("wait");
		self.boxModelEffImg_2:addHangerEff("ttmb_cjdh_02_wait");
	else
		self.boxModelEffImg_3:setActionName("wait");
		self.boxModelEffImg_3:addHangerEff("ttmb_cjdh_03_wait");
	end
	self:startPlayTween();
end

function Lua_TotemRecruitPanel:startPlayTween()
	if not self.isNeedPlayTween then
		return;
	end
	self.isNeedPlayTween = false;

	-- Lua_MsgUtil.callFunc("OPERATIONAL_ACTIVITIES_CLICKLIMIT", 1);
	for i = 1, self.showItemArr:getSize() do
		TweenUtil.getInstance():stop(self.showItemArr[i].mainContent);
		self.showItemArr[i]:setEnable(false);
	end

	local startPosX, startPosY, idx, item;
	if self.recruitType == 1 then
		startPosX = -206;
		startPosY = 48;
	elseif self.recruitType == 2 then
		startPosX = 0;
		startPosY = -37;
	else
		startPosX = 213;
		startPosY = 48;
	end
	local posList = {{0, 420}, {194, 349}, {276, 185}, {0, 126}, {-276, 185}, {-194, 349}};
	local info = DataCenter.totemRecruitData:getCurTypeRecruitInfo(self.recruitType);
	local list = info.show_reward;
	local showList = {};
	for i = 1, #list do
		idx = tonumber(tostring(list[i].sub));
		showList[idx] = {list[i].key, list[i].value, idx == 1};
	end

	for i = 1, #posList do
		item = self.showItemArr[i];
		if item == nil then
			item = Lua_TotemRecruitShowItem.new(self.content);
			item.contentName = "Lua_TotemRecruitShowItem_" .. i;
			self.showItemArr:add(item);
		end
		item:setEnable(true);
		item:setData(showList[i]);
		item:setScale(0.1, 0.1);
		item:setLocation(startPosX, startPosY);

		-- 播放动画：播放时间，延迟时间，位置，旋转，缩放，回调函数，偏移
		TweenUtil.getInstance():addTween(item.mainContent, 0.5, 0,
		posList[i][1], posList[i][2], 0,
		0, 0, 0,
		1, 1, 1,
		self, self.endPlayTween, 0, false, i);
	end
end

function Lua_TotemRecruitPanel:endPlayTween(idx)
	TweenUtil.getInstance():stop(self.showItemArr[idx].mainContent);
	-- if idx == self.showItemArr:getSize() then
	-- 	Lua_MsgUtil.callFunc("OPERATIONAL_ACTIVITIES_CLICKLIMIT", 0);
	-- end
end

function Lua_TotemRecruitPanel:showTotemRecruitInfo()
	local info = DataCenter.totemRecruitData:getCurTypeRecruitInfo(self.recruitType);
	self.timesNum.num = info.reward_times;
	self.oneDrawBtn.label = LanUtil.formateStr(784002, 1);
	self.moreDrawBtn.label = LanUtil.formateStr(784002, info.act_multi_draw);

	local colorStr = info.cost_times > 0 and "9CE476" or "ED4C30";
	self.payLeftTimesTxt.text = LanUtil.formateStr(784003, info.cost_times, info.max_cost_times);
	self.payLeftTimesTxt:setEnable(info.max_cost_times > 0);
	self:updateTotemRecruitCost();
end

function Lua_TotemRecruitPanel:updateTotemRecruitCost()
	local info = DataCenter.totemRecruitData:getCurTypeRecruitInfo(self.recruitType);
	local hasCount = DataCenter.packData:getItemCountById(info.act_item);
	local tvo = Lua_ToolVo.createToolVo(info.act_item);
	local str = spliceIconStr(tvo.atlas, tvo.sprite, tvo.iconWidth, tvo.iconHeight);
	if hasCount >= 1 then
		self.oneCostTxt.text = LanUtil.formateStr(784004, str, "FFFFFF", 1);
	else
		if info.cost_times >= 1 then
			local itemId = tonumber(tostring(info.draw_once.key));
			local itemNum = tonumber(tostring(info.draw_once.value));
			local payTvo = Lua_ToolVo.createToolVo(itemId);
			local payStr = spliceIconStr(payTvo.atlas, payTvo.sprite, payTvo.iconWidth, payTvo.iconHeight);
			self.oneCostTxt.text = LanUtil.formateStr(784004, payStr, "FFFFFF", itemNum);
		else
			self.oneCostTxt.text = LanUtil.formateStr(784004, str, "ED4C30", 1);
		end
	end
	if hasCount >= info.act_multi_cost then
		self.moreCostTxt.text = LanUtil.formateStr(784004, str, "FFFFFF", info.act_multi_cost);
	else
		if info.cost_times >= info.act_multi_cost then
			local itemId = tonumber(tostring(info.draw_ten.key));
			local itemNum = tonumber(tostring(info.draw_ten.value));
			local payTvo = Lua_ToolVo.createToolVo(itemId);
			local payStr = spliceIconStr(payTvo.atlas, payTvo.sprite, payTvo.iconWidth, payTvo.iconHeight);
			self.moreCostTxt.text = LanUtil.formateStr(784004, payStr, "FFFFFF", itemNum);
		else
			self.moreCostTxt.text = LanUtil.formateStr(784004, str, "ED4C30", info.act_multi_cost);
		end
	end
end

function Lua_TotemRecruitPanel:setBtnShowSelect()
	local info_1 = DataCenter.totemRecruitData:getCurTypeRecruitInfo(1);
	local info_2 = DataCenter.totemRecruitData:getCurTypeRecruitInfo(2);
	local info_3 = DataCenter.totemRecruitData:getCurTypeRecruitInfo(3);
	if info_1 == nil or info_2 == nil or info_3 == nil then
		return;
	end

	local info;
	if self.recruitType == 1 then -- 初级
		info = info_1;
		self.recruitBtn_1:setAltas(info_1.str_list[3], info_1.str_list[5]);
		self.recruitBtn_2:setAltas(info_2.str_list[3], info_2.str_list[4]);
		self.recruitBtn_3:setAltas(info_3.str_list[3], info_3.str_list[4]);
	elseif self.recruitType == 2 then -- 中级
		info = info_2;
		self.recruitBtn_1:setAltas(info_1.str_list[3], info_1.str_list[4]);
		self.recruitBtn_2:setAltas(info_2.str_list[3], info_2.str_list[5]);
		self.recruitBtn_3:setAltas(info_3.str_list[3], info_3.str_list[4]);
	else -- 高级
		info = info_3;
		self.recruitBtn_1:setAltas(info_1.str_list[3], info_1.str_list[4]);
		self.recruitBtn_2:setAltas(info_2.str_list[3], info_2.str_list[4]);
		self.recruitBtn_3:setAltas(info_3.str_list[3], info_3.str_list[5]);
	end
	self.tipsIcon_2:setAltas(info.str_list[1], info.str_list[2]);

	local list = {tonumber(tostring(info.act_item)), tonumber(tostring(info.draw_once.key))}
	local item;
	for i = 1, #list do
		item = self.moneyItemArr[i];
		if item == nil then
			item = Lua_MoneyItem.new(self.content);
			item:setRectAnchor(1);
			item:setLocation(249 - (i - 1) * 190, -26, 0);
			item:setCanClick(true);
			self.moneyItemArr:add(item);
		end
		item:setMoney(list[i]);
	end
end

function Lua_TotemRecruitPanel:updateTotemRecruitRecordInfo(msg)
	if msg == nil or msg.index ~= self.recruitType then
		return;
	end

	local info = msg.record_list and msg.record_list[1] or msg.record;
	if info then
		local tvo = Lua_ToolVo.createToolVo(info.item_id, info.amount);
		if tvo.count > 1 then
			self.recordTxt.text = LanUtil.formateStr(784015, info.player_name, tvo.colorStr, tvo.name, tvo.count);
		else
			self.recordTxt.text = LanUtil.formateStr(784016, info.player_name, tvo.colorStr, tvo.name);
		end
		self.recordTxt:resetSize();
		self.readBtn:setLocation(self.recordTxt.width / 2 + self.readBtn.width, 191);
	else
		self.recordTxt.text = "";
		self.readBtn:setLocation(170, 191);
	end
end

function Lua_TotemRecruitPanel:onRuleClick(go)
	local tipData = { des = self.actVo.help_des, posX = 170, posY = -245 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_TotemRecruitPanel:onRecruit1Click(go)
	self:requestTotemRecruitInfo(1);
end

function Lua_TotemRecruitPanel:onRecruit2Click(go)
	self:requestTotemRecruitInfo(2);
end

function Lua_TotemRecruitPanel:onRecruit3Click(go)
	self:requestTotemRecruitInfo(3);
end

function Lua_TotemRecruitPanel:requestTotemRecruitInfo(recruitType)
	if self.recruitType == recruitType then
		return;
	end
	self.isNeedPlayTween = true;
	self.recruitType = recruitType;
	self:onTotemRecruitOperate(1, recruitType);
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sTotemRecruitRecordInfo(self.actVo.actIdx, recruitType);
end

function Lua_TotemRecruitPanel:onPreviewClick(go)
	self:onTotemRecruitOperate(2);
end

function Lua_TotemRecruitPanel:onTaskClick(go)
	self:onTotemRecruitOperate(3);
end

function Lua_TotemRecruitPanel:onOneDrawClick(go)
	self:onTotemRecruitOperate(4);
end

function Lua_TotemRecruitPanel:onMoreDrawClick(go)
	self:onTotemRecruitOperate(5);
end

function Lua_TotemRecruitPanel:onReadClick(go)
	self:onTotemRecruitOperate(6);
end

function Lua_TotemRecruitPanel:onTotemRecruitOperate(operateType, param)
	if DataCenter.backstageActData:checkActIsEnd(self.actVo) then
		return;
	end
	local info = DataCenter.totemRecruitData:getCurTypeRecruitInfo(self.recruitType);
	if info == nil then
		return;
	end

	if operateType == 1 then -- 刷新
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sActivityInfo(self.actVo.actIdx, param);
	elseif operateType == 2 then -- 预览界面
		Lua_WindowUtil.openWin("Lua_TotemRecruitPreviewWindow", Lua_WinParam.ACTION_OPEN, self.actVo);
	elseif operateType == 3 then -- 任务界面
		Lua_WindowUtil.openWin("Lua_TotemRecruitTaskWindow", Lua_WinParam.ACTION_OPEN, self.actVo);
	elseif operateType == 4 then -- 单抽
		local hasCount = DataCenter.packData:getItemCountById(info.act_item);
		local payItemId = tonumber(tostring(info.draw_once.key));
		local payHasCount = DataCenter.packData:getItemCountById(payItemId);
		self.drawTimes = 1;
		self.payCostNum = tonumber(tostring(info.draw_once.value));
		if hasCount >= 1 then
			self:onSureDrawFun();
		elseif info.cost_times >= 1 and payHasCount >= self.payCostNum then
			self:reconfirmFun();
		else
			DataCenter.packUtil:openPathWindow(tonumber(tostring(info.act_item)));
		end
	elseif operateType == 5 then -- 多抽
		local hasCount = DataCenter.packData:getItemCountById(info.act_item);
		local payItemId = tonumber(tostring(info.draw_ten.key));
		local payHasCount = DataCenter.packData:getItemCountById(payItemId);
		self.drawTimes = info.act_multi_draw;
		self.payCostNum = tonumber(tostring(info.draw_ten.value));
		if hasCount >= info.act_multi_cost then
			self:onSureDrawFun();
		elseif info.cost_times >= info.act_multi_draw and payHasCount >= self.payCostNum then
			self:reconfirmFun();
		else
			DataCenter.packUtil:openPathWindow(tonumber(tostring(info.act_item)));
		end
	elseif operateType == 6 then -- 记录界面
		Lua_WindowUtil.openWin("Lua_TotemRecruitRecordWindow", Lua_WinParam.ACTION_OPEN, {actVo = self.actVo, recruitType = self.recruitType});
	end
end

function Lua_TotemRecruitPanel:reconfirmFun()
	local info = DataCenter.totemRecruitData:getCurTypeRecruitInfo(self.recruitType);
	local payItemId = tonumber(tostring(info.draw_once.key));
	local tipsData = {
		owner = self,
		des = LanUtil.formateStr(784005, spliceIconStrById(payItemId), self.payCostNum, self.drawTimes),
		btnType = 1,
		sureFun = self.onSureDrawFun
	}
	Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_TotemRecruitPanel:onSureDrawFun()
	if self.clickTime and getTime() - self.clickTime < 0.5 then
		return;
	end
	self.clickTime = getTime();

	if Lua_WindowUtil.isWindowShowing("Lua_TotemRecruitShowRewardWindow") then -- 再抽N次
		Lua_WindowUtil.openWin("Lua_TotemRecruitShowRewardWindow", Lua_WinParam.ACTION_CLOSE);
	end
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sTotemRecruitDrawRecruitReward(self.actVo.actIdx, self.recruitType, self.drawTimes);
end

function Lua_TotemRecruitPanel:dispose()
	if self.moneyItemArr ~= nil then
		self.moneyItemArr:dispose();
		self.moneyItemArr:clear();
		self.moneyItemArr = nil;
	end
	if self.showItemArr ~= nil then
		self.showItemArr:dispose();
		self.showItemArr:clear();
		self.showItemArr = nil;
	end
	if self.taskRedPoint ~= nil then
		self.taskRedPoint:dispose();
		self.taskRedPoint = nil;
	end
	if self.primaryRedPoint ~= nil then
		self.primaryRedPoint:dispose();
		self.primaryRedPoint = nil;
	end
	if self.intermediateRedPoint ~= nil then
		self.intermediateRedPoint:dispose();
		self.intermediateRedPoint = nil;
	end
	if self.seniorRedPoint ~= nil then
		self.seniorRedPoint:dispose();
		self.seniorRedPoint = nil;
	end
	if self.drawOneRedPoint ~= nil then
		self.drawOneRedPoint:dispose();
		self.drawOneRedPoint = nil;
	end
	if self.drawMoreRedPoint ~= nil then
		self.drawMoreRedPoint:dispose();
		self.drawMoreRedPoint = nil;
	end
	if self.timesNum ~= nil then
		self.timesNum:dispose();
		self.timesNum = nil;
	end
	if self.boxModelEffImg_1 ~= nil then
		self.boxModelEffImg_1:dispose();
		self.boxModelEffImg_1 = nil;
	end
	if self.boxModelEffImg_2 ~= nil then
		self.boxModelEffImg_2:dispose();
		self.boxModelEffImg_2 = nil;
	end
	if self.boxModelEffImg_3 ~= nil then
		self.boxModelEffImg_3:dispose();
		self.boxModelEffImg_3 = nil;
	end
	self.actVo = nil;
	self:endTimer();
	Lua_CommonUtil.removeTimer(self, self.onWaitAniFun);
	self:superCall("dispose");
end










Lua_TotemRecruitShowItem = class("Lua_TotemRecruitShowItem", Lua_DisplayObject);
function Lua_TotemRecruitShowItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_TotemRecruitShowItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemBg = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);

	self.itemIcon = Lua_ItemIcon.new(self.content);

	self.numTxt = UICreate.createLabel(self.content, nil, 50, -35, 100, 31, 22);
	self.numTxt.pivotValue = 5;
	self.numTxt.fontName = Lua_MyUISettings.huakangFontName;
	self.numTxt.alignmentValue = 5;
	self.numTxt.colorStr = Lua_ColorDefine.transColorStr("F9FDFE");
	self.numTxt.effectStyle = 2;
	self.numTxt.effectColorStr = Lua_ColorDefine.transColorStr("45342C");
	self.numTxt:setEffectDistance(2, 2);

	self.itemBg:addClickFuntion(self, self.onBtnClick);
end

function Lua_TotemRecruitShowItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local scale = data[3] and 1.2 or 0.7;
	local posY = data[3] and 7 or 0;
	local tvo = Lua_ToolVo.createToolVo(tonumber(tostring(data[1])), tonumber(tostring(data[2])));
	self.itemIcon:setData(tvo);
	self.itemIcon:showNum(nil);
	self.itemIcon:setIconBg(nil, nil);
	self.itemIcon:setScale(scale, scale);
	self.itemIcon:setLocation(0, posY, 0);

	local atlas = "totem_recruit_atlas_1";
	local sprite = data[3] and "xui_ttmb_widget_1" or "xui_ttmb_widget_2";
	self.itemBg:setAltas(atlas, sprite);
	self.itemBg:resetSize();

	local posX = data[3] and 50 or 40;
	local posY = data[3] and -35 or -30;
	self.numTxt.text = tvo.count;
	self.numTxt:setLocation(posX, posY);
	self.numTxt:setEnable(tvo.count > 1);
end

function Lua_TotemRecruitShowItem:onBtnClick(go)
	if self._data then
		self.itemIcon:onItemClick();
	end
end

function Lua_TotemRecruitShowItem:dispose()
	if self.itemBg ~= nil then
		self.itemBg:dispose();
		self.itemBg = nil;
	end
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	if self.numTxt ~= nil then
		self.numTxt:dispose();
		self.numTxt = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end