-- 图腾招募-预览界面
Lua_TotemRecruitPreviewWindow = class("Lua_TotemRecruitPreviewWindow", Lua_Window);
function Lua_TotemRecruitPreviewWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_TotemRecruitPreviewWindow";
	self.skinName = "TotemRecruitPreviewWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_TotemRecruitPreviewWindow:buildShowItem()
	self:superCall("buildShowItem");

	local btnInfo = Array();
	btnInfo:add({textStr = 784006});
	btnInfo:add({textStr = 784007});
	btnInfo:add({textStr = 784008});

	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList:setButtonCell(Lua_CommonButtonItem2);
	self.btnList:setButtonItem(160, 67);
	self.btnList:setClickCallBack(self, self.onBtnClick);
	self.btnList:setLocation(0, 291, 0);
	self.btnList:setData(btnInfo);

	self.wishList = Lua_DragList.new(self.content, 635, 680, Lua_AxisDefine.Vertical);
	self.wishList:setListCell(Lua_TotemRecruitPreviewItem, 127, 166, 5);
	self.wishList:setCellSpacing(0, 8);
	self.wishList:setLocation(0, -106, 0);

	self:addLuaEvent("UPDATE_TOTEMRECRUIT_PREVIEW_INFO", self, self.updateTotemRecruitPreviewInfo);
end

function Lua_TotemRecruitPreviewWindow:showWin(param)
	self:superCall("showWin", param);
	self.btnList:setSelected(1);
end

function Lua_TotemRecruitPreviewWindow:onBtnClick(val)
	if DataCenter.backstageActData:checkActIsEnd(self.showData) then
		return;
	end
	self.recruitType = val;
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sTotemRecruitPreviewInfo(self.showData.actIdx, val);
end

function Lua_TotemRecruitPreviewWindow:updateTotemRecruitPreviewInfo(msg)
	if msg == nil or msg.index ~= self.recruitType then
		return;
	end
	-- self.wishList.canDrag = #msg.rate_info > 15;
	self.wishList:setArrayData(msg.rate_info);
	self.wishList:moveToIndex(1, true, false);
end

function Lua_TotemRecruitPreviewWindow:dispose()
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.wishList ~= nil then
		self.wishList:dispose();
		self.wishList = nil;
	end
	self:superCall("dispose");
end










Lua_TotemRecruitPreviewItem = class("Lua_TotemRecruitPreviewItem", Lua_ListCell);
function Lua_TotemRecruitPreviewItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setLocation(0, 23, 0);
	self.itemIcon:setScale(0.96, 0.96);

	self.rateBg = UICreate.createUIAtlasImage(self.content, "totem_recruit_atlas_1", "xui_fs_widget_03", 0, -65, 114, 36);
	self.rateTxt = UICreate.createLabel(self.content, nil, 0, -65, 100, 31, 26);
	self.rateTxt.fontName = Lua_MyUISettings.huakangFontName;
	self.rateTxt.alignmentValue = 4;
	self.rateTxt.horizontalOverflowValue = 1;
	self.rateTxt.colorStr = Lua_ColorDefine.transColorStr("836751");
end

function Lua_TotemRecruitPreviewItem:setData(data)
	if data == nil then
		return;
	end

	local tvo = Lua_ToolVo.createToolVo(tonumber(tostring(data.item_id)), data.amount);
	self.itemIcon:setData(tvo);
	self.rateTxt.text = LanUtil.formateStr(784009, string.format("%.2f", data.rate * 100));
end

function Lua_TotemRecruitPreviewItem:onPressClick()
	local winPos = LuaUtil.getTouchPosInverseObj(self.mainContent);
	if self.itemIcon:checkInBound(winPos.x, winPos.y) then
		self.itemIcon:onItemClick();
	end
end

function Lua_TotemRecruitPreviewItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	if self.rateBg ~= nil then
		self.rateBg:dispose();
		self.rateBg = nil;
	end
	if self.rateTxt ~= nil then
		self.rateTxt:dispose();
		self.rateTxt = nil;
	end
	self:superCall("dispose");
end