-- 图腾招募-记录信息界面
Lua_TotemRecruitRecordWindow = class("Lua_TotemRecruitRecordWindow", Lua_Window);
function Lua_TotemRecruitRecordWindow:ctor()
	self:superCall("ctor");

	self.showBlackMask = true;
	self.isClickClose = true;
	self.blackAlpha = 0.01;
end

function Lua_TotemRecruitRecordWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.recordBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_tips_001", 0, -1, 504, 607);

	self.recordList = Lua_DragList.new(self.content, 404, 520, Lua_AxisDefine.Vertical);
	self.recordList:setListCell(Lua_TotemRecruitRecordItem, 404, 24, 1);
	self.recordList:setCellSpacing(0, 6, 0);
	self.recordList:setLocation(0, -1, 0);

	self:addLuaEvent("UPDATE_TOTEMRECRUIT_RECORD_INFO", self, self.updateTotemRecruitRecordInfo);
end

function Lua_TotemRecruitRecordWindow:showWin(param)
	self:superCall("showWin", param);
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sTotemRecruitRecordInfo(param.actVo.actIdx, param.recruitType);
end

function Lua_TotemRecruitRecordWindow:updateTotemRecruitRecordInfo(msg)
	if msg == nil or msg.index ~= self.showData.recruitType then
		return;
	end
	if msg.record_list then
		self.recordList:setArrayData(msg.record_list);
	end
end

function Lua_TotemRecruitRecordWindow:dispose()
	if self.recordBg ~= nil then
		self.recordBg:dispose();
		self.recordBg = nil;
	end
	if self.recordList ~= nil then
		self.recordList:dispose();
		self.recordList = nil;
	end
	self:superCall("dispose");
end











Lua_TotemRecruitRecordItem = class("Lua_TotemRecruitRecordItem", Lua_ListCell);
function Lua_TotemRecruitRecordItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_TotemRecruitRecordItem:buildShowItem()
	self:superCall("buildShowItem");

	self.recordTxt = UICreate.createLabel(self.content, nil, 0, 0, 404, 35, 22);
	self.recordTxt.alignmentValue = 3;
end

function Lua_TotemRecruitRecordItem:setData(data)
	if data == nil then
		return ;
	end

	local tvo = Lua_ToolVo.createToolVo(data.item_id, data.amount);
	if tvo.count > 1 then
		self.recordTxt.text = LanUtil.formateStr(784015, data.player_name, tvo.colorStr, tvo.name, tvo.count);
	else
		self.recordTxt.text = LanUtil.formateStr(784016, data.player_name, tvo.colorStr, tvo.name);
	end
end

function Lua_TotemRecruitRecordItem:dispose()
	if self.recordTxt ~= nil then
		self.recordTxt:dispose();
		self.recordTxt = nil;
	end
	self:superCall("dispose");
end