Lua_TotemRecruitShowRewardWindow = class("Lua_TotemRecruitShowRewardWindow", Lua_Window);
function Lua_TotemRecruitShowRewardWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_TotemRecruitShowRewardWindow";
	self.skinName = "TotemRecruitShowRewardWindow_skin";
	self.isFullSizeWin = true;
	self.isFullSizeBg = true;
	self.showBlackMask = true;
end

function Lua_TotemRecruitShowRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.moneyItemArr = Array();
	self.showItemArr = Array();

	self.endMaskBtn:addClickFuntion(self, self.onEndMaskClick);
	self.drawAnginaBtn:addClickFuntion(self, self.onDrawAnginClick);
	self.sureBtn:addClickFuntion(self, self.hide);
end

function Lua_TotemRecruitShowRewardWindow:onScreenResize()
	self:superCall("onScreenResize");

	if self.boxModelEffImg ~= nil then
		self.boxModelEffImg:SetDimensions(1440 + self.adaptHeight, 1440 + self.adaptHeight);
	end
end

function Lua_TotemRecruitShowRewardWindow:showWin(param)
	self:superCall("showWin", param);

	self.isCanClick = true;
	self.endMaskBtn:setEnable(true);
	self:setShowBtnEnble(false);

	local info = DataCenter.totemRecruitData:getCurTypeRecruitInfo(param.index);
	local list = {tonumber(tostring(info.act_item)), tonumber(tostring(info.draw_once.key))}
	local item;
	for i = 1, #list do
		item = Lua_MoneyItem.new(self.content);
		item:setRectAnchor(1);
		item:setLocation(249 - (i - 1) * 190, -26, 0);
		item:setCanClick(true);
		item:setMoney(list[i]);
		self.moneyItemArr:add(item);
	end

	local hasCount = DataCenter.packData:getItemCountById(info.act_item);
	local tvo = Lua_ToolVo.createToolVo(info.act_item);
	local str = spliceIconStr(tvo.atlas, tvo.sprite, tvo.iconWidth, tvo.iconHeight);
	if #param.draw_list <= 1 then -- 再抽一次
		self.drawAnginaBtn.label = LanUtil.formateStr(784010, 1);
		if hasCount >= 1 then
			self.drawState = 0;
			self.costTxt.text = LanUtil.formateStr(784004, str, "FFFFFF", 1);
		else
			local payItemId = tonumber(tostring(info.draw_once.key));
			local payHasCount = DataCenter.packData:getItemCountById(payItemId);
			self.payCostNum = tonumber(tostring(info.draw_once.value));
			if info.cost_times >= 1 and payHasCount >= self.payCostNum then
				local payTvo = Lua_ToolVo.createToolVo(payItemId);
				local payStr = spliceIconStr(payTvo.atlas, payTvo.sprite, payTvo.iconWidth, payTvo.iconHeight);
				self.drawState = 1;
				self.costTxt.text = LanUtil.formateStr(784004, payStr, "FFFFFF", self.payCostNum);
			else
				self.drawState = 2;
				self.costTxt.text = LanUtil.formateStr(784004, str, "ED4C30", 1);
			end
		end
	else -- 再抽n次
		self.drawAnginaBtn.label = LanUtil.formateStr(784010, info.act_multi_draw);
		if hasCount >= info.act_multi_cost then
			self.drawState = 0;
			self.costTxt.text = LanUtil.formateStr(784004, str, "FFFFFF", info.act_multi_cost);
		else
			local payItemId = tonumber(tostring(info.draw_ten.key));
			local payHasCount = DataCenter.packData:getItemCountById(payItemId);
			self.payCostNum = tonumber(tostring(info.draw_ten.value));
			if info.cost_times >= info.act_multi_cost and payHasCount >= self.payCostNum then
				local payTvo = Lua_ToolVo.createToolVo(payItemId);
				local payStr = spliceIconStr(payTvo.atlas, payTvo.sprite, payTvo.iconWidth, payTvo.iconHeight);
				self.drawState = 1;
				self.costTxt.text = LanUtil.formateStr(784004, payStr, "FFFFFF", self.payCostNum);
			else
				self.drawState = 2;
				self.costTxt.text = LanUtil.formateStr(784004, str, "ED4C30", info.act_multi_cost);
			end
		end
	end

	if not DataCenter.totemRecruitData.isNotPlay then
		self:showAniFun();
	else
		DataCenter.totemRecruitData.isNotPlay = false;
		self:showRewardFun();
	end
end

function Lua_TotemRecruitShowRewardWindow:showAniFun()
	local modelName;
	local effName;
	if self.showData.index == 1 then
		modelName = "baoxiang_01";
		effName = "ttmb_cjdh_01";
	elseif self.showData.index == 2 then
		modelName = "baoxiang_02";
		effName = "ttmb_cjdh_02";
	else
		modelName = "baoxiang_03";
		effName = "ttmb_cjdh_03";
	end
	if self.boxModelEffImg == nil then
		self.boxModelEffImg = UICreate.createModelEffImg(self.content, nil, nil, 0, 0, 1440 + self.adaptHeight, 1440 + self.adaptHeight);
		self.boxModelEffImg.canRot = false;
		-- self.boxModelEffImg:setScale(0.5, 0.5, 0.5);
		self.boxModelEffImg:setCamField(3, 1, 100, true);
		self.boxModelEffImg:setCamPos(-2.6, 2.4, -5.88);
		self.boxModelEffImg:setModelEffDir(180);
	end
	self.boxModelEffImg.isShareEffCam = false;
	self.boxModelEffImg:setCamRot(19.6, 23.8, 1);
	self.boxModelEffImg:setEnable(true);
	self.boxModelEffImg:setUrl("/model/ttmb/ttmb_baoxiang", modelName);
	self.boxModelEffImg:setActionName("idle");
	self.boxModelEffImg:addHangerEff(effName);
	Lua_CommonUtil.delayCall(3, self, self.showRewardFun);
end

function Lua_TotemRecruitShowRewardWindow:showRewardFun()
	self.isCanClick = false;
	self.endMaskBtn:setEnable(false);
	if self.boxModelEffImg ~= nil then
		self.boxModelEffImg:setEnable(false);
	end
	Lua_CommonUtil.removeTimer(self, self.showRewardFun);

	local tvo;
	local list = self.showData.draw_list;
	if #list <= 1 then -- 单抽
		tvo = DataCenter.packData:getRewardVo(list[1]);
		self.showItem = Lua_TotemRecruitShowRewardItem.new(self.content);
		self.showItem:setScale(0.001, 0.001, 1);
		self.showItem:setData(tvo);
		TweenUtil.getInstance():addTweenTargetScale(self.showItem.mainContent,
			0.5, 0, 0.84, 0.84, 1, self, self.endPlayTween);
	else -- 多抽
		local radius = 275; -- 半径
		local posX, posY, angle;
		for i = 1, #list do
			tvo = DataCenter.packData:getRewardVo(list[i]);
			angle = 1 / #list * 360;
			posX = radius * Mathf.Sin(Mathf.Rad(angle * (i - 1) + angle / 2));
			posY = radius * Mathf.Cos(Mathf.Rad(angle * (i - 1) + angle / 2));

			item = Lua_TotemRecruitShowRewardItem.new(self.content);
			item.contentName = "Lua_TotemRecruitShowRewardItem_"..i;
			item:setLocation(posX, posY, 0);
			item:setScale(0.00001, 0.84, 1);
			item:setData(tvo);
			TweenUtil.getInstance():stop(item.mainContent);
			self.showItemArr:add(item);
		end
		TweenUtil.getInstance():addTweenTargetScale(self.showItemArr[1].mainContent,
			0.1, 0, 0.84, 0.84, 1, self, self.onPlayingTween, 0, false, 1);
	end
end

function Lua_TotemRecruitShowRewardWindow:endPlayTween()
	self:setShowBtnEnble(true);
	TweenUtil.getInstance():stop(self.showItem.mainContent);
end

function Lua_TotemRecruitShowRewardWindow:onPlayingTween(idx)
	TweenUtil.getInstance():stop(self.showItemArr[idx].mainContent);

	idx = idx + 1;
	if idx <= self.showItemArr:getSize() then
		TweenUtil.getInstance():addTweenTargetScale(self.showItemArr[idx].mainContent,
			0.1, 0, 0.84, 0.84, 1, self, self.onPlayingTween, 0, false, idx);
	else
		self:setShowBtnEnble(true);
	end
end

function Lua_TotemRecruitShowRewardWindow:setShowBtnEnble(bShow)
	self.drawAnginaBtn:setEnable(bShow);
	self.sureBtn:setEnable(bShow);
	self.costTxt:setEnable(bShow);
end

function Lua_TotemRecruitShowRewardWindow:onEndMaskClick(go)
	if self.isCanClick then
		self:showRewardFun();
	end
end

function Lua_TotemRecruitShowRewardWindow:onDrawAnginClick(go)
	local info = DataCenter.totemRecruitData:getCurTypeRecruitInfo(self.showData.index);
	if self.drawState == 0 or self.drawState == 1 then -- 0活动道具可抽 1货币消耗可抽
		DataCenter.totemRecruitData.isNotPlay = true; -- 再抽不播放动画
		self:onSureDrawFun();
	elseif self.drawState == 2 then -- 活动道具不可抽
		DataCenter.packUtil:openPathWindow(tonumber(tostring(info.act_item)));
	end
end

function Lua_TotemRecruitShowRewardWindow:onSureDrawFun()
	if #self.showData.draw_list <= 1 then -- 单抽
		Lua_MsgUtil.callFunc("REQUEST_TOTEMRECRUIT_ONE_DRAW");
	else -- 多抽
		Lua_MsgUtil.callFunc("REQUEST_TOTEMRECRUIT_MORE_DRAW");
	end
end

function Lua_TotemRecruitShowRewardWindow:dispose()
	if self.moneyItemArr ~= nil then
		self.moneyItemArr:dispose();
		self.moneyItemArr:clear();
		self.moneyItemArr = nil;
	end
	if self.showItem ~= nil then
		TweenUtil.getInstance():stop(self.showItem.mainContent);
		self.showItem:dispose();
		self.showItem = nil;
	end
	if self.showItemArr ~= nil then
		for i = 1, self.showItemArr:getSize() do
			TweenUtil.getInstance():stop(self.showItemArr[i].mainContent);
			self.showItemArr[i]:dispose();
		end
		self.showItemArr:dispose();
		self.showItemArr:clear();
		self.showItemArr = nil;
	end
	if self.boxModelEffImg ~= nil then
		self.boxModelEffImg:dispose();
		self.boxModelEffImg = nil;
	end
	self:superCall("dispose");
end











Lua_TotemRecruitShowRewardItem = class("Lua_TotemRecruitShowRewardItem", Lua_DisplayObject);
function Lua_TotemRecruitShowRewardItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_TotemRecruitShowRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setCanClick(true);
end

function Lua_TotemRecruitShowRewardItem:setData(data)
	if data == nil then
		return;
	end
	self.itemIcon:setData(data);
end

function Lua_TotemRecruitShowRewardItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self:superCall("dispose");
end