-- 图腾招募-任务界面
Lua_TotemRecruitTaskWindow = class("Lua_TotemRecruitTaskWindow", Lua_Window);
function Lua_TotemRecruitTaskWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_TotemRecruitTaskWindow";
	self.skinName = "TotemRecruitTaskWindow_skin";
	self.showClose = true;
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_TotemRecruitTaskWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.taskList = Lua_DragList.new(self.content, 628, 700, Lua_AxisDefine.Vertical);
	-- self.taskList.tweenId = 2023;
	-- self.taskList.delayTween = true;
	self.taskList:setListCell(Lua_TotemRecruitTaskItem, 628, 143, 1);
	self.taskList:setCellSpacing(0, 4);
	self.taskList:setLocation(0, -141, 0);

	local arr = Array();
	arr:add({textStr = 784011, redPointId = Lua_RedPointList.TotemRecruit_Task_Daily});
	arr:add({textStr = 784012, redPointId = Lua_RedPointList.TotemRecruit_Task_Cumulate});

	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList:setButtonStyle("common_altas_1", "xui_common_tab_002", "xui_common_tab_001", 133, 77);
	self.btnList:setButtonText(0, 10, "7A6A5F", "8F5123", 28, 28, Lua_MyUISettings.huakangFontName);
	self.btnList:setRedPoint(45, 15);
	self.btnList:setButtonItem(135, 77);
	self.btnList:setSiblingIndex(0);
	self.btnList:setRectPivot(3);
	self.btnList:setLocation(-330, -570, 0);
	self.btnList:setClickCallBack(self, self.onBtnClick);
	self.btnList:setData(arr);

	self:addLuaEvent("UPDATE_TOTEMRECRUIT_TASK_INFO", self, self.updateTotemRecruitTaskInfo);
	self:addLuaEvent("ON_TOTEMRECRUIT_DRAWREWARD_CLICK", self, self.onTotemRecruitDrawRewardClick);
end

function Lua_TotemRecruitTaskWindow:showWin(param)
	self:superCall("showWin", param);
	self.btnList:setSelected(1);
end

function Lua_TotemRecruitTaskWindow:onBtnClick(val)
	-- self.taskList.showTween = true;
	self.taskType = val;
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sTotemRecruitTaskInfo(self.showData.actIdx, val);
end

function Lua_TotemRecruitTaskWindow:updateTotemRecruitTaskInfo(msg)
	if msg == nil or msg.task_type ~= self.taskType then
		return;
	end

	-- 可领取＞未达成＞已领取，info1：0未完成 1可领取 2已领取
	table.sort( msg.task_state,
		function(a, b)
			if a.info1 == b.info1 then
				return a.task_id < b.task_id;
			else
				local aOpen = true;
				if a.func_id ~= 0 then
					aOpen = DataCenter.funcOpenData:isOpened(a.func_id);
				end
				local bOpen = true;
				if b.func_id ~= 0 then
					bOpen = DataCenter.funcOpenData:isOpened(b.func_id);
				end
				if aOpen ~= bOpen then
					return aOpen;
				else
					local aWeight = (a.info1 + 1) % 3;
					local bWeight = (b.info1 + 1) % 3;
					return aWeight > bWeight;
				end
			end
		end
	);
	self.taskList:setArrayData(msg.task_state);
	self.taskList:moveToIndex(1, true, false);
end

function Lua_TotemRecruitTaskWindow:onTotemRecruitDrawRewardClick(data)
	if DataCenter.backstageActData:checkActIsEnd(self.showData) then
		return;
	end
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sTotemRecruitDrawTaskReward(self.showData.actIdx, data.task_id);
end

function Lua_TotemRecruitTaskWindow:dispose()
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.taskList ~= nil then
		self.taskList:dispose();
		self.taskList = nil;
	end
	self:superCall("dispose");
end










Lua_TotemRecruitTaskItem = class("Lua_TotemRecruitTaskItem", Lua_ListCell);
function Lua_TotemRecruitTaskItem:ctor(p)
	self:superCall("ctor", p, "TotemRecruitTaskItem_skin");
end

function Lua_TotemRecruitTaskItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 360, 87, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_TotemRecruitTaskRewardItem, 87, 87, 1);
	self.rewardList:setCellSpacing(9, 0);
	self.rewardList:setRectPivot(3);
	self.rewardList:setLocation(-280, -16, 0);
	self:setSubList(self.rewardList);

	self.stateBtn:addClickFuntion(self, self.onBtnClick);
end

function Lua_TotemRecruitTaskItem:setData(data)
	self._data = data;
	if self._data == nil then
		return;
	end

	self.titleTxt.text = data.dec;
	self.rewardList.canDrag = #data.award > 3;
	self.rewardList:setArrayData(data.award);
	self.progressBar:setMaxValue(data.info3);
	self.progressBar:setValue(data.info2);
	self.progressBar:setText(data.info2 .. "/" .. data.info3);

	local isOpen = true;
	if data.func_id ~= 0 then
		isOpen = DataCenter.funcOpenData:isOpened(data.func_id);
	end
	if not isOpen then -- 未开启
		self.drawIcon:setAltas("task_altas", "xui_rcrw_label_1");
	else
		self.drawIcon:setAltas("common_altas_1", "xui_common_label_12");
		if data.info1 == 0 then
			self.stateBtn:setLangValue(784013);
			self.stateBtn:setStyle(16);
		elseif data.info1 == 1 then
			self.stateBtn:setLangValue(784014);
			self.stateBtn:setStyle(1);
		end
	end
	self.progressBar:setEnable(isOpen and data.info1 ~= 2);
	self.stateBtn:setEnable(isOpen and data.info1 ~= 2);
	self.drawIcon:setEnable(not isOpen or data.info1 == 2);
	self:showRedDot(isOpen and data.info1 == 1);
end

function Lua_TotemRecruitTaskItem:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:createRedPointEff();
			self.redPoint:setLocation(270, 12, 0);
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_TotemRecruitTaskItem:onBtnClick(go)
	if self._data.info1 == 0 then -- 未达成
		if self._data.func_path_id and self._data.func_path_id ~= 0 then
			DataCenter.funcPathUtil:gotoFunction(self._data.func_path_id, true)
		end
	else -- 可领取
		Lua_MsgUtil.callFunc("ON_TOTEMRECRUIT_DRAWREWARD_CLICK", self._data);
	end
end

function Lua_TotemRecruitTaskItem:dispose()
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end










Lua_TotemRecruitTaskRewardItem = class("Lua_TotemRecruitTaskRewardItem", Lua_ItemIconCell);
function Lua_TotemRecruitTaskRewardItem:buildShowItem()
	self:superCall("buildShowItem");
	self.itemIcon:setScale(0.7, 0.7);
end