-- 古树秘宝
Lua_TreeTreasurePanel = class("Lua_TreeTreasurePanel", Lua_DisplayObject);
function Lua_TreeTreasurePanel:ctor(p, skinName)
	self:superCall("ctor", p, skinName);
end

function Lua_TreeTreasurePanel:buildShowItem()
	self:superCall("buildShowItem");

	-- 树
	self.treeEffect = UICreate.createUIEffect(self.content, "/effects/uiEffects/gsmb_sm", "gsmb_sm", -14, -320); -- 待机
	self.treeEffect.siblingIndex = 1;
	-- 和树一起挂载的
	-- self.treeMountEffect = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_ks_dj_01", "ui_ks_dj_01", 0, 0); -- 待机
	-- self.treeMountEffect:setEnable(false);
	-- self.treeMountEffect:setEnable(true);
	-- 熊
	self.bearEffect = UICreate.createUIEffect(self.content, "/effects/uiEffects/gsmb_hs", "gsmb_hs", 175, -320); -- 待机
	self.bearEffect.siblingIndex = 2;

	self.taskRedPoint = Lua_RedPointIcon.new(self.content, Lua_RedPointList.TreeTreasure_Task);
	self.taskRedPoint:setRectAnchor(1);
	self.taskRedPoint:setLocation(323, -118, 0);

	self.shopRedPoint = Lua_RedPointIcon.new(self.content, Lua_RedPointList.TreeTreasure_Shop);
	self.shopRedPoint:setRectAnchor(1);
	self.shopRedPoint:setLocation(323, -330, 0);

	local posList = {{4, 437}, {-199, 395}, {185, 367}, {-287, 251}, {-79.5, 275},
		{105, 215}, {291.5, 184}, {-282, 34}, {-187, 156}, {-4, 113}, {176, 79}};
	local item;
	self.rewardArr = Array();
	for i = 1, #posList do
		item = Lua_TreeTreasureItem.new(self.content);
		item.contentName = "Lua_TreeTreasureItem_" .. i;
		item:setLocation(posList[i][1], posList[i][2]);
		item:setSiblingIndex(2 + i);
		self.rewardArr:add(item);
	end

	self.ruleBtn:addClickFuntion(self, self.onRuleClick);
	self.taskBtn:addClickFuntion(self, self.onTaskClick);
	self.previewBtn:addClickFuntion(self, self.onPreviewClick);
	self.shopBtn:addClickFuntion(self, self.onShopClick);
	self.oneBtn:addClickFuntion(self, self.onOneDrawClick);
	self.moreBtn:addClickFuntion(self, self.onMoreDrawClick);
	self.readBtn:addClickFuntion(self, self.onReadClick);

	self:addLuaEvent("UPDATE_TREETREASURE_INFO", self, self.updateTreeTreasureInfo);
	self:addLuaEvent("DRAW_TREETREASURE_REWARD_INFO", self, self.showDrawTween);
	self:addLuaEvent("UPDATE_TREETREASURE_RECORD_INFO", self, self.updateTreeTreasureRecordInfo);
	self:addLuaEvent("MONEY_UPDATE", self, self.updateCostInfo); 
	self:addLuaEvent("PACK_ITEMS_UPDATE", self, self.updateCostInfo);
	self:addLuaEvent("ON_TREETREASURE_REFRESH_CLICK", self, self.onTreeTreasureRefreshClick);
	self:addLuaEvent("ON_TREETREASURE_OPENSELECT_CLICK", self, self.onOpenSelectClick);
end

function Lua_TreeTreasurePanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
end

function Lua_TreeTreasurePanel:setData(actVo)
	self.actVo = actVo;
	self:startTimer();
	self:updateLeftTime();
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sTreeTreasureRecordInfo(actVo.actIdx);
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sTreeTreasureTaskInfo(actVo.actIdx, 1); -- 每日任务红点
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sTreeTreasureTaskInfo(actVo.actIdx, 2); -- 累计任务红点
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sTreeTreasureShopInfo(actVo.actIdx);
end

function Lua_TreeTreasurePanel:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		self:addTimer("Lua_TreeTreasurePanel", 1, self, self.updateLeftTime);
	end
end

function Lua_TreeTreasurePanel:updateLeftTime()
	local time = self.actVo.residueTime;
	self.timeTxt.text = LanUtil.formateStr(797000, Lua_TimeTransform.transSeconds16(time, true, true, true));
	if time <= 0 then
		self.timeTxt:setLangValue(797001);
		self:endTimer();
	end
end

function Lua_TreeTreasurePanel:endTimer()
	if self.bTimer == true then
		self.bTimer = false;
		self:removeTimer(self, self.updateLeftTime);
	end
end

function Lua_TreeTreasurePanel:updateTreeTreasureInfo()
	for i = 1, self.rewardArr:getSize() do
		self.rewardArr[i]:setData(i);
	end

	self.desTxt_2.text = LanUtil.formateStr(797002, DataCenter.treeTreasureData.leftMaxTimes);
	self.leftTimesTxt.text = LanUtil.formateStr(797003, DataCenter.treeTreasureData.leftPayTimes);
	self:updateCostInfo();
end

function Lua_TreeTreasurePanel:updateCostInfo(dic)
	self.oneCostId, self.oneCostNum = DataCenter.treeTreasureData:getOneCostInfo();
	self.moreCostId, self.moreCostNum = DataCenter.treeTreasureData:getMoreCostInfo();
	if dic then
		if dic[self.oneCostId] == nil and dic[self.moreCostId] == nil then
			return;
		end
	end
	if self.oneCostId == 0 or self.moreCostId == 0 then
		return;
	end

	local tvo = Lua_ToolVo.createToolVo(self.oneCostId);
	local packNum = DataCenter.packData:getItemCountById(self.oneCostId);
	local colorStr = packNum >= self.oneCostNum and "EDEBEC" or "E05156";
	self.oneCostIcon:setAltas(tvo.atlas, tvo.sprite);
	self.oneCostTxt.text = Lua_ColorDefine.getColorStr(colorStr, packNum);
	self:showOneRed(self.oneCostId == DataCenter.treeTreasureData.actItemId and packNum >= self.oneCostNum);

	packNum = DataCenter.packData:getItemCountById(self.moreCostId);
	tvo = Lua_ToolVo.createToolVo(self.moreCostId);
	colorStr = packNum >= self.moreCostNum and "EDEBEC" or "E05156";
	self.moreCostIcon:setAltas(tvo.atlas, tvo.sprite);
	self.moreCostTxt.text = Lua_ColorDefine.getColorStr(colorStr, packNum);
	self:showMoreRed(self.moreCostId == DataCenter.treeTreasureData.actItemId and packNum >= self.moreCostNum);

	self.oneBtn.label = LanUtil.formateStr(797004, 1);
	self.moreBtn.label = LanUtil.formateStr(797004, DataCenter.treeTreasureData.actMoreTimes);
end

function Lua_TreeTreasurePanel:showOneRed(bShow)
	if bShow == true then
		if self.oneRedPoint == nil then
			self.oneRedPoint = Lua_RedPointIcon.new(self.content);
			self.oneRedPoint:createRedPointEff();
			self.oneRedPoint:setRectAnchor(7);
			self.oneRedPoint:setLocation(-70, 289, 0);
		end
		self.oneRedPoint:updateRedPointShow(true);
	else
		if self.oneRedPoint ~= nil then
			self.oneRedPoint:updateRedPointShow(false);
		end
	end
end

function Lua_TreeTreasurePanel:showMoreRed(bShow)
	if bShow == true then
		if self.moreRedPoint == nil then
			self.moreRedPoint = Lua_RedPointIcon.new(self.content);
			self.moreRedPoint:createRedPointEff();
			self.moreRedPoint:setRectAnchor(7);
			self.moreRedPoint:setLocation(248, 289, 0);
		end
		self.moreRedPoint:updateRedPointShow(true);
	else
		if self.moreRedPoint ~= nil then
			self.moreRedPoint:updateRedPointShow(false);
		end
	end
end

function Lua_TreeTreasurePanel:showDrawTween(msg)
	if msg and #msg.draw_list > 0 then
		if self.showArr == nil then
			self.showArr = Array();
		else
			self.showArr:clear();
		end
		for i = 1, #msg.draw_list do
			vo = DataCenter.packData:getRewardVo(msg.draw_list[i]);
			self.showArr:add(vo);
		end
		self.bearEffect:setSpineAniState(0, "gsmb_hs_chop"); -- 砍树
		self.treeEffect:setSpineAniState(0, "gsmb_sm_sloshing"); -- 晃动
		-- self.treeMountEffect:setSpineAniState(0, "ui_ks_hd_01"); -- 晃动
		Lua_CommonUtil.delayCall(0.667, self, self.onDelayFun);
	end
end

function Lua_TreeTreasurePanel:onDelayFun()
	Lua_CommonUtil.removeTimer(self, self.onDelayFun);
	self.bearEffect:setSpineAniState(0, "gsmb_hs_wait1");
	self.treeEffect:setSpineAniState(0, "gsmb_sm_wait");
	self:showStopEff();
end

function Lua_TreeTreasurePanel:showStopEff()
	-- if self.drawEffect == nil then
	-- 	self.drawEffect = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_ks_cj_01", "ui_ks_cj_01", 0, 0); -- 抽奖
	-- end
	-- self.drawEffect:setEnable(false);
	-- self.drawEffect:setEnable(true);
	Lua_WindowUtil.openWin("Lua_ObtainItemTipsWindow", Lua_WinParam.ACTION_OPEN, self.showArr);
end

function Lua_TreeTreasurePanel:updateTreeTreasureRecordInfo(msg)
	if msg and #msg.record_list > 0 then
		local info = msg.record_list[1];
		local tvo = Lua_ToolVo.createToolVo(tonumber(info.item_id))
		self.recordTxt.text = LanUtil.formateStr(797005, info.player_name, tvo.colorName, info.amount);
	else
		self.recordTxt.text = "";
	end
end

function Lua_TreeTreasurePanel:onRuleClick(go)
	local tipData = { des = self.actVo.help_des, posX = -200, posY = -245 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_TreeTreasurePanel:onTreeTreasureRefreshClick()
	self:onTreeTreasureOperate(1);
end

function Lua_TreeTreasurePanel:onTaskClick()
	self:onTreeTreasureOperate(2);
end

function Lua_TreeTreasurePanel:onPreviewClick()
	self:onTreeTreasureOperate(3);
end

function Lua_TreeTreasurePanel:onShopClick()
	self:onTreeTreasureOperate(4);
end

function Lua_TreeTreasurePanel:onOneDrawClick()
	self:onDrawFun(1);
end

function Lua_TreeTreasurePanel:onMoreDrawClick()
	self:onDrawFun(2);
end

function Lua_TreeTreasurePanel:onDrawFun(drawType)
	self.drawType = drawType;
	self:onTreeTreasureOperate(5);
end

function Lua_TreeTreasurePanel:onReadClick()
	self:onTreeTreasureOperate(6);
end

function Lua_TreeTreasurePanel:onOpenSelectClick()
	self:onTreeTreasureOperate(7);
end

function Lua_TreeTreasurePanel:onTreeTreasureOperate(operateType, param)
	if DataCenter.backstageActData:checkActIsEnd(self.actVo) then
		return;
	end

	if operateType == 1 then -- 开启刷新
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sActivityInfo(self.actVo.actIdx);
	elseif operateType == 2 then -- 任务界面
		Lua_WindowUtil.openWin("Lua_TreeTreasureTaskWindow", Lua_WinParam.ACTION_OPEN, self.actVo);
	elseif operateType == 3 then -- 预览界面
		Lua_WindowUtil.openWin("Lua_TreeTreasurePreviewWindow", Lua_WinParam.ACTION_OPEN, self.actVo);
	elseif operateType == 4 then -- 商店界面
		Lua_WindowUtil.openWin("Lua_TreeTreasureShopWindow", Lua_WinParam.ACTION_OPEN, self.actVo);
	elseif operateType == 5 then -- 抽奖
		if DataCenter.treeTreasureData.selectNum < 3 then
			OperateAlert.showLangValue(797006);
			self:onOpenSelectClick();
		else
			Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sDrawTreeTreasureRewardInfo(self.actVo.actIdx, self.drawType == 1 and 1 or DataCenter.treeTreasureData.actMoreTimes);
		end
	elseif operateType == 6 then -- 查看记录信息
		Lua_WindowUtil.openWin("Lua_TreeTreasureRecordWindow", Lua_WinParam.ACTION_OPEN, self.actVo);
	elseif operateType == 7 then -- 自选奖励界面
		Lua_WindowUtil.openWin("Lua_TreeTreasureSelectWindow", Lua_WinParam.ACTION_OPEN, self.actVo);
	end
end

function Lua_TreeTreasurePanel:dispose()
	if self.treeEffect ~= nil then
		self.treeEffect:dispose();
		self.treeEffect = nil;
	end
	if self.bearEffect ~= nil then
		self.bearEffect:dispose();
		self.bearEffect = nil;
	end
	if self.taskRedPoint ~= nil then
		self.taskRedPoint:dispose();
		self.taskRedPoint = nil;
	end
	if self.shopRedPoint ~= nil then
		self.shopRedPoint:dispose();
		self.shopRedPoint = nil;
	end
	if self.oneRedPoint ~= nil then
		self.oneRedPoint:dispose();
		self.oneRedPoint = nil;
	end
	if self.moreRedPoint ~= nil then
		self.moreRedPoint:dispose();
		self.moreRedPoint = nil;
	end
	if self.treeMountEffect ~= nil then
		self.treeMountEffect:dispose();
		self.treeMountEffect = nil;
	end
	if self.drawEffect ~= nil then
		self.drawEffect:dispose();
		self.drawEffect = nil;
	end
	if self.showArr ~= nil then
		self.showArr:dispose();
		self.showArr:clear();
		self.showArr = nil;
	end
	self.actVo = nil;
	Lua_CommonUtil.removeTimer(self, self.onDelayFun);
	self:superCall("dispose");
end










Lua_TreeTreasureItem = class("Lua_TreeTreasureItem", Lua_DisplayObject);
function Lua_TreeTreasureItem:ctor(p)
	self:superCall("ctor", p, "TreeTreasureItem_skin");
end

function Lua_TreeTreasureItem:buildShowItem()
	self:superCall("buildShowItem");

	self.selectBtn:addClickFuntion(self, self.onSelectClick);
end

function Lua_TreeTreasureItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local sprite;
	if data <= 3 then
		sprite = "xui_gsmb_widget_1";
		self.selectBtn:setLocation(-9, -1, 0);
		self.selectBtn:SetDimensions(133, 133);
		self.itemIcon:setLocation(-9, -1, 0);
		self.itemIcon:setScale(1, 1);
	else
		sprite = "xui_gsmb_widget_2";
		self.selectBtn:setLocation(0, 0, 0);
		self.selectBtn:SetDimensions(100, 100);
		self.itemIcon:setLocation(0, 0, 0);
		self.itemIcon:setScale(0.7, 0.7);
	end
	self.itemBg:setAltas("tree_treasure", sprite);
	self.itemBg:resetSize();

	local showInfo = DataCenter.treeTreasureData.showDic[data];
	if showInfo and tonumber(showInfo.key) ~= 0 then
		self.tvo = Lua_ToolVo.createToolVo(tonumber(showInfo.key), tonumber(showInfo.value));
		self.itemIcon:setEnable(true);
		self.itemIcon:setAltas(self.tvo.atlas, self.tvo.sprite);
	else
		self.itemIcon:setEnable(false);
	end
	self.addIcon:setEnable(data <= 3);
end

function Lua_TreeTreasureItem:onSelectClick(go)
	if self._data then
		if self._data <= 3 then
			Lua_MsgUtil.callFunc("ON_TREETREASURE_OPENSELECT_CLICK", self._data);
		else
			DataCenter.packUtil:showItemInfo(self.tvo);
		end
	end
end

function Lua_TreeTreasureItem:dispose()
	self._data = nil;
	self:superCall("dispose");
end