-- 古树秘宝-奖励预览界面
Lua_TreeTreasurePreviewWindow = class("Lua_TreeTreasurePreviewWindow", Lua_Window);
function Lua_TreeTreasurePreviewWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_TreeTreasurePreviewWindow";
	self.skinName = "TreeTreasurePreviewWindow_skin";
	self.layer = Lua_MainWinDefine.TIPS_WINDOW_LAYER;
	self.showWinBg = true;
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_TreeTreasurePreviewWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.previewList = Lua_DragList.new(self.content, 444, 430, Lua_AxisDefine.Vertical);
	self.previewList:setListCell(Lua_TreeTreasurePreviewItem, 111, 129, 4);
	self.previewList:setCellSpacing(0, 2);
	self.previewList:setLocation(0, -10, 0);
	self.previewList:setArrayData(DataCenter.treeTreasureData.previewList);
end

function Lua_TreeTreasurePreviewWindow:showWin(param)
	self:superCall("showWin", param);
end

function Lua_TreeTreasurePreviewWindow:dispose()
	if self.previewList ~= nil then
		self.previewList:dispose();
		self.previewList = nil;
	end
	self:superCall("dispose");
end











Lua_TreeTreasurePreviewItem = class("Lua_TreeTreasurePreviewItem", Lua_ListCell);
function Lua_TreeTreasurePreviewItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_TreeTreasurePreviewItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setLocation(0, 14.5, 0);
	self.itemIcon:setScale(0.8, 0.8);

	self.probabilityTxt = UICreate.createLabel(self.content, nil, 0, -50, 100, 31, 20);
	self.probabilityTxt.alignmentValue = 4;
	self.probabilityTxt.horizontalOverflowValue = 1;
	self.probabilityTxt.fontName = Lua_MyUISettings.huakangFontName;
end

function Lua_TreeTreasurePreviewItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local tvo = Lua_ToolVo.createToolVo(tonumber(data.item_id), data.amount);
	self.itemIcon:setData(tvo);
	self.probabilityTxt.text = string.format("%.2f%s", data.rate * 100, "%");
end

function Lua_TreeTreasurePreviewItem:onPressClick()
	if self._data then
		self.itemIcon:onItemClick();
	end
end

function Lua_TreeTreasurePreviewItem:checkInBound(posX, posY)
	local minX = self.centerPosX - self.itemIcon.itemW / 2 * self.itemIcon.scaleX;
	local maxX = self.centerPosX + self.itemIcon.itemW / 2 * self.itemIcon.scaleX;
	local minY = self.centerPosY - self.itemIcon.itemH / 2 * self.itemIcon.scaleY;
	local maxY = self.centerPosY + self.itemIcon.itemH / 2 * self.itemIcon.scaleY;
	return posX >= minX and posX <= maxX and posY >= minY and posY <= maxY;
end

function Lua_TreeTreasurePreviewItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	if self.probabilityTxt ~= nil then
		self.probabilityTxt:dispose();
		self.probabilityTxt = nil;
	end
	self:superCall("dispose");
end