-- 古树秘宝-记录信息界面
Lua_TreeTreasureRecordWindow = class("Lua_TreeTreasureRecordWindow", Lua_Window);
function Lua_TreeTreasureRecordWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_TreeTreasureRecordWindow";
	self.layer = Lua_MainWinDefine.TIPS_WINDOW_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
	self.blackAlpha = 0.01;
end

function Lua_TreeTreasureRecordWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.recordBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_tips_001", 0, -1, 504, 607);

	self.recordList = Lua_DragList.new(self.content, 404, 520, Lua_AxisDefine.Vertical);
	self.recordList:setListCell(Lua_TreeTreasureRecordItem, 404, 24, 1);
	self.recordList:setCellSpacing(0, 6);
	self.recordList:setLocation(0, -1, 0);

	self:addLuaEvent("UPDATE_TREETREASURE_RECORD_INFO", self, self.updateTreeTreasureRecordInfo);
end

function Lua_TreeTreasureRecordWindow:showWin(param)
	self:superCall("showWin", param);
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sTreeTreasureRecordInfo(param.actIdx);
end

function Lua_TreeTreasureRecordWindow:updateTreeTreasureRecordInfo(msg)
	if msg == nil then
		return;
	end
	self.recordList:setArrayData(msg.record_list);
end

function Lua_TreeTreasureRecordWindow:dispose()
	if self.recordBg ~= nil then
		self.recordBg:dispose();
		self.recordBg = nil;
	end
	if self.recordList ~= nil then
		self.recordList:dispose();
		self.recordList = nil;
	end
	self:superCall("dispose");
end











Lua_TreeTreasureRecordItem = class("Lua_TreeTreasureRecordItem", Lua_ListCell);
function Lua_TreeTreasureRecordItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_TreeTreasureRecordItem:buildShowItem()
	self:superCall("buildShowItem");

	self.recordTxt = UICreate.createLabel(self.content, nil, 0, 0, 404, 35, 22);
	self.recordTxt.alignmentValue = 3;
end

function Lua_TreeTreasureRecordItem:setData(data)
	if data == nil then
		return ;
	end

	local tvo = Lua_ToolVo.createToolVo(tonumber(data.item_id))
	self.recordTxt.text = LanUtil.formateStr(797005, data.player_name, tvo.colorName, data.amount);
end

function Lua_TreeTreasureRecordItem:dispose()
	if self.recordTxt ~= nil then
		self.recordTxt:dispose();
		self.recordTxt = nil;
	end
	self:superCall("dispose");
end