-- 半月礼包-自选奖励界面
Lua_TreeTreasureSelectWindow = class("Lua_TreeTreasureSelectWindow", Lua_Window);
function Lua_TreeTreasureSelectWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_TreeTreasureSelectWindow";
	self.skinName = "TreeTreasureSelectWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_TreeTreasureSelectWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 586, 494, Lua_AxisDefine.Vertical);
	self.rewardList.canDrag = false;
	self.rewardList:setListCell(Lua_TreeTreasureSelectItem, 586, 160, 1);
	self.rewardList:setCellSpacing(0, 7);
	self.rewardList:setLocation(0, -15, 0);
	self.rewardList:setArrayData(DataCenter.treeTreasureData.selectDic);

	self.sureBtn:addClickFuntion(self, self.onSureClick);
	self:addLuaEvent("ON_TREETREASURE_SELECT_CLICK", self, self.onSelcetRewardClick);
end

function Lua_TreeTreasureSelectWindow:showWin(param)
	self:superCall("showWin", param);

	local selectDic = DataCenter.treeTreasureData.selectDic;
	local obj;
	self.selectNum = 0;
	self.itemDic = {};
	for i = 1, #selectDic do
		obj = selectDic[i];
		for j = 1, #obj.type_info do
			if obj.type_info[j].is_choose == 1 then
				self.selectNum = self.selectNum + 1;
				self.itemDic[obj.type_info[j].index] = obj.type_info[j];
				self.rewardList.showDragDataList[i].cell.rewardList:setSelected(j);
			end
		end
	end
end

function Lua_TreeTreasureSelectWindow:onSelcetRewardClick(data)
	if self.itemDic[data.index] == nil or data.reward_id ~= self.itemDic[data.index].reward_id then
		self.selectNum = self.selectNum >= 3 and 3 or self.selectNum + 1;
		self.itemDic[data.index] = data;
	else
		self.selectNum = self.selectNum <= 0 and 0 or self.selectNum - 1;
		self.itemDic[data.index] = nil;
	end
end

function Lua_TreeTreasureSelectWindow:onSureClick(go)
	if DataCenter.backstageActData:checkActIsEnd(self.showData) then
		self:hide();
		return;
	end
	if self.selectNum < 3 then
		OperateAlert.showLangValue(797006);
	else
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sTreeTreasureSelectRewardInfo(self.showData.actIdx, self.itemDic);
		self:hide();
	end
end

function Lua_TreeTreasureSelectWindow:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	if self.itemDic then
		for k,v in pairs(self.itemDic) do
			v = nil;
		end
		self.itemDic = nil;
	end
	self:superCall("dispose");
end












Lua_TreeTreasureSelectItem = class("Lua_TreeTreasureSelectItem", Lua_ListCell);
function Lua_TreeTreasureSelectItem:ctor(p)
	self:superCall("ctor", p, "TreeTreasureSelectItem_skin");
end

function Lua_TreeTreasureSelectItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 520, 106, Lua_AxisDefine.Horizontal);
	self.rewardList.canLongPress = true;
	self.rewardList.longPressLimit = 0.4;
	self.rewardList:setListCell(Lua_TreeTreasureSelectRewardItem, 87, 106, 1);
	self.rewardList:setCellSpacing(9, 0);
	self.rewardList:setRectPivot(3);
	self.rewardList:setLocation(-260, -16, 0);
	self:setSubList(self.rewardList);
end

function Lua_TreeTreasureSelectItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.titleTxt.text = data.des;
	self.rewardList:setArrayData(data.type_info);
end

function Lua_TreeTreasureSelectItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end












Lua_TreeTreasureSelectRewardItem = class("Lua_TreeTreasureSelectRewardItem", Lua_ListCell);
function Lua_TreeTreasureSelectRewardItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_TreeTreasureSelectRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setLocation(0, 9, 0);
	self.itemIcon:setScale(0.7, 0.7);

	self.timesTxt = UICreate.createLabel(self.content, nil, 0, -44, 100, 31, 18);
	self.timesTxt.alignmentValue = 4;
	self.timesTxt.horizontalOverflowValue = 1;
	self.timesTxt.colorStr = Lua_ColorDefine.transColorStr("987E67");
end

function Lua_TreeTreasureSelectRewardItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local tvo = Lua_ToolVo.createToolVo(data.item_info.key, data.item_info.value);
	self.itemIcon:setData(tvo);
	self.timesTxt.text = LanUtil.formateStr(797007, data.max_draw - data.draw_times, data.max_draw);
end

function Lua_TreeTreasureSelectRewardItem:onPressClick()
	if self._data then
		if self._data.draw_times < self._data.max_draw then
			Lua_MsgUtil.callFunc("ON_TREETREASURE_SELECT_CLICK", self._data);
			return true;
		else
			OperateAlert.showLangValue(797015);
		end
	end
end

function Lua_TreeTreasureSelectRewardItem:onLongPressClick()
	self.itemIcon:onItemClick();
end

function Lua_TreeTreasureSelectRewardItem:onSelectionChange(bSelect)
	self:superCall("onSelectionChange", bSelect);
	self.itemIcon:setDrawMask(bSelect);
end

function Lua_TreeTreasureSelectRewardItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end