-- 古树秘宝-任务界面
Lua_TreeTreasureTaskWindow = class("Lua_TreeTreasureTaskWindow", Lua_Window);
function Lua_TreeTreasureTaskWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_TreeTreasureTaskWindow";
	self.skinName = "TreeTreasureTaskWindow_skin";
	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.showClose = true;
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_TreeTreasureTaskWindow:buildShowItem()
	self:superCall("buildShowItem");

	local arr = Array();
	arr:add({textStr = 797011, redPointId = Lua_RedPointList.TreeTreasure_Task_Daily});
	arr:add({textStr = 797012, redPointId = Lua_RedPointList.TreeTreasure_Task_Cumulate});

	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList:setButtonStyle("common_altas_1", "xui_common_tab_002", "xui_common_tab_001", 133, 77);
	self.btnList:setButtonText(0, 10, "7A6A5F", "8F5123", 28, 28, Lua_MyUISettings.huakangFontName);
	self.btnList:setRedPoint(45, 15);
	self.btnList:setButtonItem(135, 77);
	self.btnList:setSiblingIndex(0);
	self.btnList:setRectPivot(3);
	self.btnList:setLocation(-330, -570, 0);
	self.btnList:setClickCallBack(self, self.onBtnClick);
	self.btnList:setData(arr);

	self.taskList = Lua_DragList.new(self.content, 628, 700, Lua_AxisDefine.Vertical);
	self.taskList.tweenId = 2023;
	self.taskList.delayTween = true;
	self.taskList:setListCell(Lua_TreeTreasureTaskItem, 628, 143, 1);
	self.taskList:setCellSpacing(0, 4);
	self.taskList:setLocation(0, -141, 0);

	self:addLuaEvent("UPDATE_TREETREASURE_TASK_INFO", self, self.updateTreeTreasureTaskInfo);
	self:addLuaEvent("ON_TREETREASURE_DRAWREWARD_CLICK", self, self.onTreeTreasureDrawRewardClick);
end

function Lua_TreeTreasureTaskWindow:showWin(param)
	self:superCall("showWin", param);
	self.btnList:setSelected(1);
end

function Lua_TreeTreasureTaskWindow:onBtnClick(val)
	self.isNeedRefresh = true;
	self.taskList.showTween = true;
	self.taskType = val;
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sTreeTreasureTaskInfo(self.showData.actIdx, val);
end

function Lua_TreeTreasureTaskWindow:updateTreeTreasureTaskInfo(msg)
	if msg == nil or msg.task_type ~= self.taskType then
		return;
	end

	-- 可领取＞未达成＞已领取，info1：0未完成 1可领取 2已领取
	table.sort( msg.task_list,
		function(a, b)
			if a.info1 == b.info1 then
				return a.task_id < b.task_id;
			else
				local aWeight = (a.info1 + 1) % 3;
				local bWeight = (b.info1 + 1) % 3;
				return aWeight > bWeight;
			end
		end
	);
	self.taskList:setArrayData(msg.task_list);
	if self.isNeedRefresh then
		self.isNeedRefresh = false;
		self.taskList:moveToIndex(1, true, false);
	end
end

function Lua_TreeTreasureTaskWindow:onTreeTreasureDrawRewardClick(data)
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sDrawTreeTreasureTaskReward(self.showData.actIdx, self.taskType, data.task_id);
end

function Lua_TreeTreasureTaskWindow:dispose()
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.taskList ~= nil then
		self.taskList:dispose();
		self.taskList = nil;
	end
	self:superCall("dispose");
end










Lua_TreeTreasureTaskItem = class("Lua_TreeTreasureTaskItem", Lua_ListCell);
function Lua_TreeTreasureTaskItem:ctor(p)
	self:superCall("ctor", p, "TreeTreasureTaskItem_skin");
end

function Lua_TreeTreasureTaskItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 360, 87, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_TreeTreasureTaskRewardItem, 87, 87, 1);
	self.rewardList:setCellSpacing(9, 0);
	self.rewardList:setRectPivot(3);
	self.rewardList:setLocation(-280, -16, 0);
	self:setSubList(self.rewardList);

	self.stateBtn:addClickFuntion(self, self.onDrawRewardClick);
end

function Lua_TreeTreasureTaskItem:setData(data)
	self._data = data;
	if self._data == nil then
		return;
	end

	self.titleTxt.text = data.dec;
	self.rewardList.canDrag = #data.award > 3;
	self.rewardList:setArrayData(data.award);
	self.progressBar:setMaxValue(data.info2);
	self.progressBar:setValue(data.info3);
	self.progressBar:setText(data.info3 .. "/" .. data.info2);

	if data.info1 == 0 then -- 未完成
		self.stateBtn:setLangValue(797013);
		self.stateBtn:setMouseEnable(false);
		self.stateBtn:setStyle(3);
	elseif data.info1 == 1 then -- 可领取
		self.stateBtn:setLangValue(797014);
		self.stateBtn:setMouseEnable(true);
		self.stateBtn:setStyle(1);
	end
	self.progressBar:setEnable(data.info1 ~= 2);
	self.stateBtn:setEnable(data.info1 ~= 2);
	self.drawedIcon:setEnable(data.info1 == 2);
	self:showRedDot(data.info1 == 1);
end

function Lua_TreeTreasureTaskItem:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:createRedPointEff();
			self.redPoint:setLocation(270, 12, 0);
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_TreeTreasureTaskItem:onDrawRewardClick(go)
	Lua_MsgUtil.callFunc("ON_TREETREASURE_DRAWREWARD_CLICK", self._data);
end

function Lua_TreeTreasureTaskItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end










Lua_TreeTreasureTaskRewardItem = class("Lua_TreeTreasureTaskRewardItem", Lua_ItemIconCell);
function Lua_TreeTreasureTaskRewardItem:buildShowItem()
	self:superCall("buildShowItem");
	self.itemIcon:setScale(0.7, 0.7);
end